CREATE TABLE `{PREFIX}active_users` (
  `internalKey` int(9) NOT NULL default '0',
  `username` varchar(50) NOT NULL default '',
  `lasthit` int(20) NOT NULL default '0',
  `id` int(10) default NULL,
  `action` varchar(10) NOT NULL default '',
  `ip` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`internalKey`)
) TYPE=MyISAM COMMENT='Contains data about active users.';

CREATE TABLE `{PREFIX}document_groups` (
  `id` int(10) NOT NULL auto_increment,
  `document_group` int(10) NOT NULL default '0',
  `document` int(10) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM COMMENT='Contains data used for access permissions.' ;

CREATE TABLE `{PREFIX}documentgroup_names` (
  `id` int(10) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) TYPE=MyISAM COMMENT='Contains data used for access permissions.' ;

CREATE TABLE `{PREFIX}keyword_xref` (
  `content_id` int(11) NOT NULL default '0',
  `keyword_id` int(11) NOT NULL default '0',
  KEY `content_id` (`content_id`),
  KEY `keyword_id` (`keyword_id`)
) TYPE=MyISAM COMMENT='Cross reference bewteen keywords and content';

CREATE TABLE `{PREFIX}log_access` (
  `visitor` bigint(11) NOT NULL default '0',
  `document` bigint(11) NOT NULL default '0',
  `timestamp` int(20) NOT NULL default '0',
  `hour` tinyint(2) NOT NULL default '0',
  `weekday` tinyint(1) NOT NULL default '0',
  `referer` bigint(11) NOT NULL default '0',
  `entry` tinyint(1) NOT NULL default '0',
  KEY `visitor` (`visitor`),
  KEY `document` (`document`),
  KEY `timestamp` (`timestamp`),
  KEY `referer` (`referer`),
  KEY `entry` (`entry`),
  KEY `hour` (`hour`),
  KEY `weekday` (`weekday`)
) TYPE=MyISAM COMMENT='Contains visitor statistics.';

CREATE TABLE `{PREFIX}log_hosts` (
  `id` bigint(11) NOT NULL default '0',
  `data` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM COMMENT='Contains visitor statistics.';

CREATE TABLE `{PREFIX}log_operating_systems` (
  `id` bigint(11) NOT NULL default '0',
  `data` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM COMMENT='Contains visitor statistics.';

CREATE TABLE `{PREFIX}log_referers` (
  `id` bigint(11) NOT NULL default '0',
  `data` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM COMMENT='Contains visitor statistics.';

CREATE TABLE `{PREFIX}log_totals` (
  `today` date NOT NULL default '0000-00-00',
  `month` char(2) NOT NULL default '0',
  `piDay` int(11) NOT NULL default '0',
  `piMonth` int(11) NOT NULL default '0',
  `piAll` int(11) NOT NULL default '0',
  `viDay` int(11) NOT NULL default '0',
  `viMonth` int(11) NOT NULL default '0',
  `viAll` int(11) NOT NULL default '0',
  `visDay` int(11) NOT NULL default '0',
  `visMonth` int(11) NOT NULL default '0',
  `visAll` int(11) NOT NULL default '0'
) TYPE=MyISAM COMMENT='Stores temporary logging information.';

CREATE TABLE `{PREFIX}log_user_agents` (
  `id` bigint(11) NOT NULL default '0',
  `data` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM COMMENT='Contains visitor statistics.';

CREATE TABLE `{PREFIX}log_visitors` (
  `id` bigint(11) NOT NULL default '0',
  `os_id` bigint(11) NOT NULL default '0',
  `ua_id` bigint(11) NOT NULL default '0',
  `host_id` bigint(11) NOT NULL default '0',
  KEY `id` (`id`),
  KEY `os_id` (`os_id`),
  KEY `ua_id` (`ua_id`),
  KEY `host_id` (`host_id`)
) TYPE=MyISAM COMMENT='Contains visitor statistics.';

CREATE TABLE `{PREFIX}manager_log` (
  `id` int(10) NOT NULL auto_increment,
  `timestamp` int(20) NOT NULL default '0',
  `internalKey` int(10) NOT NULL default '0',
  `username` varchar(255) default NULL,
  `action` int(10) NOT NULL default '0',
  `itemid` varchar(10) default '0',
  `itemname` varchar(255) default NULL,
  `message` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM COMMENT='Contains a record of user interaction with Etomite.' ;

CREATE TABLE `{PREFIX}manager_users` (
  `id` int(10) NOT NULL auto_increment,
  `username` varchar(15) NOT NULL default '',
  `password` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `username` (`username`)
) TYPE=MyISAM COMMENT='Contains login information for Etomite users.' ;

CREATE TABLE `{PREFIX}member_groups` (
  `id` int(10) NOT NULL auto_increment,
  `user_group` int(10) NOT NULL default '0',
  `member` int(10) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM COMMENT='Contains data used for access permissions.' ;

CREATE TABLE `{PREFIX}membergroup_access` (
  `id` int(10) NOT NULL auto_increment,
  `membergroup` int(10) NOT NULL default '0',
  `documentgroup` int(10) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM COMMENT='Contains data used for access permissions.' ;

CREATE TABLE `{PREFIX}membergroup_names` (
  `id` int(10) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) TYPE=MyISAM COMMENT='Contains data used for access permissions.' ;

CREATE TABLE `{PREFIX}site_content` (
  `id` int(10) NOT NULL auto_increment,
  `type` varchar(20) NOT NULL default 'document',
  `contentType` varchar(50) NOT NULL default 'text/html',
  `pagetitle` varchar(100) NOT NULL default '',
  `longtitle` varchar(255) NOT NULL default '',
  `description` varchar(255) NOT NULL default '',
  `alias` varchar(100) default '',
  `published` int(1) NOT NULL default '0',
  `pub_date` int(20) NOT NULL default '0',
  `unpub_date` int(20) NOT NULL default '0',
  `parent` int(10) NOT NULL default '0',
  `isfolder` int(1) NOT NULL default '0',
  `content` mediumtext NOT NULL,
  `richtext` tinyint(1) NOT NULL default '1',
  `template` int(10) NOT NULL default '1',
  `menuindex` int(10) NOT NULL default '0',
  `searchable` int(1) NOT NULL default '1',
  `cacheable` int(1) NOT NULL default '1',
  `createdby` int(10) NOT NULL default '0',
  `createdon` int(20) NOT NULL default '0',
  `editedby` int(10) NOT NULL default '0',
  `editedon` int(20) NOT NULL default '0',
  `deleted` int(1) NOT NULL default '0',
  `deletedon` int(20) NOT NULL default '0',
  `deletedby` int(10) NOT NULL default '0',
  `authenticate` int(1) NOT NULL default '0',
  `showinmenu` int(1) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `parent` (`parent`),
  FULLTEXT KEY `content_ft_idx` (`pagetitle`,`description`,`content`)
) TYPE=MyISAM COMMENT='Contains the site''s document tree.' ;

CREATE TABLE `{PREFIX}system_settings` (
  `setting_name` varchar(50) NOT NULL default '',
  `setting_value` varchar(250) NOT NULL default '',
  UNIQUE KEY `setting_name` (`setting_name`)
) TYPE=MyISAM COMMENT='Contains Etomite settings.';

CREATE TABLE `{PREFIX}user_attributes` (
  `id` int(10) NOT NULL auto_increment,
  `internalKey` int(10) NOT NULL default '0',
  `fullname` varchar(100) NOT NULL default '',
  `role` int(10) NOT NULL default '0',
  `email` varchar(100) NOT NULL default '',
  `phone` varchar(100) NOT NULL default '',
  `mobilephone` varchar(100) NOT NULL default '',
  `blocked` int(1) NOT NULL default '0',
  `blockeduntil` int(11) NOT NULL default '0',
  `logincount` int(11) NOT NULL default '0',
  `lastlogin` int(11) NOT NULL default '0',
  `thislogin` int(11) NOT NULL default '0',
  `failedlogincount` int(10) NOT NULL default '0',
  `sessionid` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `userid` (`internalKey`)
) TYPE=MyISAM COMMENT='Contains information about Etomite users.' ;

CREATE TABLE `{PREFIX}user_messages` (
  `id` int(10) NOT NULL auto_increment,
  `type` varchar(15) NOT NULL default '',
  `subject` varchar(60) NOT NULL default '',
  `message` text NOT NULL,
  `sender` int(10) NOT NULL default '0',
  `recipient` int(10) NOT NULL default '0',
  `private` tinyint(4) NOT NULL default '0',
  `postdate` int(20) NOT NULL default '0',
  `messageread` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM COMMENT='Contains messages for the Etomite messaging system.' ;

CREATE TABLE `{PREFIX}user_roles` (
  `id` int(10) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `description` varchar(255) NOT NULL default '',
  `frames` int(1) NOT NULL default '0',
  `home` int(1) NOT NULL default '0',
  `view_document` int(1) NOT NULL default '0',
  `new_document` int(1) NOT NULL default '0',
  `save_document` int(1) NOT NULL default '0',
  `delete_document` int(1) NOT NULL default '0',
  `action_ok` int(1) NOT NULL default '0',
  `logout` int(1) NOT NULL default '0',
  `help` int(1) NOT NULL default '0',
  `messages` int(1) NOT NULL default '0',
  `new_user` int(1) NOT NULL default '0',
  `edit_user` int(1) NOT NULL default '0',
  `logs` int(1) NOT NULL default '0',
  `edit_parser` int(1) NOT NULL default '0',
  `save_parser` int(1) NOT NULL default '0',
  `edit_template` int(1) NOT NULL default '0',
  `settings` int(1) NOT NULL default '0',
  `credits` int(1) NOT NULL default '0',
  `new_template` int(1) NOT NULL default '0',
  `save_template` int(1) NOT NULL default '0',
  `delete_template` int(1) NOT NULL default '0',
  `edit_snippet` int(1) NOT NULL default '0',
  `new_snippet` int(1) NOT NULL default '0',
  `save_snippet` int(1) NOT NULL default '0',
  `delete_snippet` int(1) NOT NULL default '0',
  `empty_cache` int(1) NOT NULL default '0',
  `edit_document` int(1) NOT NULL default '0',
  `change_password` int(1) NOT NULL default '0',
  `error_dialog` int(1) NOT NULL default '0',
  `about` int(1) NOT NULL default '0',
  `file_manager` int(1) NOT NULL default '0',
  `save_user` int(1) NOT NULL default '0',
  `delete_user` int(1) NOT NULL default '0',
  `save_password` int(11) NOT NULL default '0',
  `edit_role` int(11) NOT NULL default '0',
  `save_role` int(11) NOT NULL default '0',
  `delete_role` int(11) NOT NULL default '0',
  `new_role` int(11) NOT NULL default '0',
  `access_permissions` int(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM COMMENT='Contains information describing the Etomite user roles.' ;

INSERT INTO `{PREFIX}manager_users` VALUES (1, '{ADMIN}', MD5('{ADMINPASS}'));

INSERT INTO `{PREFIX}user_attributes` VALUES (1, 1, 'Administration account', 1, 'Your email goes here', '0', '0', 0, 0, 1, 0, 1144784313, 0, 'c444a26bb664497b631bf386922bf37b');

INSERT INTO `{PREFIX}site_content` VALUES (1, 'document', 'text/html', 'Etomite CMS', 'Fast, Free, and Infinitely Flexible', 'Introduction to Etomite', 'home', 1, 0, 0, 0, 0, '<p><strong>Welcome to Etomite!</strong></p>\r\n\r\n<p>This is the default installation site. If you''re reading this, it means you''ve successfully installed Etomite, and have also configured the site. Now all you need to do is to add your content, design a unique template for your site, perhaps write some snippets which make your site stand out (don''t forget to share them at the <a href="[~5~]">forums</a>), and, most of all, enjoy using Etomite!</p>\r\n\r\n<p>To log into the manager, point your browser to <a href="manager">yoursite/manager</a>.</p>\r\n\r\n[[NewsListing?newsid=8]]', 1, 1, 1, 1, 0, 1, 1087155171, 1, 1144618723, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` VALUES (2, 'document', 'text/html', 'Repository', 'The secret Repository', 'Folder for other stuff :)', '', 0, 0, 0, 0, 1, 'Why are you reading this?', 0, 1, 0, 0, 0, 1, 1090963494, 1, 1090963494, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` VALUES (3, 'document', 'text/html', 'Site statistics', 'Visitors statistics for this site', 'Page that shows some visitor statistics for the site.', 'stats', 1, 0, 0, 0, 0, '\r\n<p>This page shows the site''s visitor statistics per <strong>[[DateTime]]</strong>.<br />The first ever hit to the site to be recorded was on <strong>[[FirstHit]]</strong>.</p>\r\n[[GetStats]]', 1, 1, 40, 1, 0, 1, 1090690452, 1, 1121626441, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` VALUES (4, 'document', 'text/html', 'Search this site', 'Let us help you find what you''re looking for', 'This page allows you to search the site.', 'search', 1, 0, 0, 0, 0, '<p>This page allows you to search the site. Enter the words \r\nyou want to search for, and press the search button. \r\nVery original, not. But hey, it''s quite difficult to write a good \r\n''search this site'' message!</p>\r\n\r\n[[SearchForm]]', 1, 1, 60, 1, 0, 1, 1090799883, 1, 1144386139, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` VALUES (5, 'reference', 'text/html', 'Etomite Forums', '', 'A link to the Etomite forums.', '', 1, 0, 0, 2, 0, 'http://www.etomite.com/forums/', 0, 0, 0, 1, 0, 1, 1091395960, 1, 1121359712, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` VALUES (6, 'document', 'text/html', 'Error 404 - Page Not Found', 'Unable to locate the page you requested.', 'The error page which is displayed when the requested page cannot be found', 'http404', 1, 0, 0, 2, 0, '\r\n<p><strong>404 Error - File not Found</strong></p><p>Hm. The page you''ve requested wasn''t found. Perhaps the page has moved, or you mistyped the URL. Or, you could try going back to the main site and trying to find the page you were looking for from there.[[DontLogPageHit]]</p>', 1, 1, 0, 0, 0, 1, 1091012335, 1, 1121382306, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` VALUES (8, 'document', 'text/html', 'News', '', '', '', 0, 0, 0, 2, 1, 'Contains news articles.', 0, 1, 5, 1, 0, 1, 1091028497, 1, 1091396661, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` VALUES (7, 'document', 'text/html', 'Installation successful!', '', '', '', 1, 0, 0, 8, 0, '<p>This is a news article to show:</p>\r\n\r\n<ul>\r\n<li>That the installation was successful</li>\r\n<li>The working of the NewsListing snippet</li>\r\n</ul>\r\n\r\n<p>The NewsListing snippet is written into the document like this:</p>\r\n\r\n<p style="font-family: courier new,courier,monospace;">[ [NewsListing?newsid=8] ]</p>\r\n\r\n<!--FullStory-->\r\n\r\n<p>This calls the NewsListing snippet, and feeds it with a variable called \r\nnewsid, which has a value of 8. The newsid variable is then used by \r\nthe snippet so it knows where to look for news. This way, you can \r\nhave as many different news sections, or blogs even, using just one \r\nsnippet! Oh yeah, there''s not meant to be a space between the \r\ndouble [ and ] characters. I just put those in to stop Etomite from \r\nthinking it needed to call the snippet here ;)</p>', 1, 1, 0, 1, 1, 1, 1091398401, 1, 1144366293, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` VALUES (9, 'document', 'text/html', 'Dummy news article', '', 'A news article that doesn''t contain any news ;)', '', 1, 0, 0, 8, 0, '<p>Nothing much here!</p>', 1, 1, 0, 1, 1, 1, 1091398374, 1, 1091398374, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` VALUES (10, 'document', 'text/html', 'Dummy news article', '', 'A news article that doesn''t contain any news ;)', '', 1, 0, 0, 8, 0, '<p>Also empty.</p>', 1, 1, 0, 1, 1, 1, 1091398360, 1, 1091398360, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` VALUES (11, 'document', 'text/html', 'Even older news', '', '', '', 1, 0, 0, 8, 0, '<p>Nope, no content here!</p>', 1, 1, 0, 1, 1, 1, 1091398320, 1, 1091398510, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` VALUES (12, 'document', 'text/html', 'Older news', '', '', '', 1, 0, 0, 8, 0, 'And still there''s nothing to say! ', 1, 1, 0, 1, 1, 1, 1091398340, 1, 1091398499, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` VALUES (13, 'document', 'text/html', 'Templates', 'More options this time around', 'This is the folder where the template demo''s are stored', 'templates', 1, 0, 0, 0, 1, '<h2>Now with MORE templates!</h2>\r\n\r\n<p>For the fun of it, Etomite 0.6.1 now comes with a wide selection of \r\ntemplates already installed. You can use them as is, or as a basis of \r\nyour own template. You can seek out other Etomite ready templates on the \r\n<a href="http://www.etomite.com" title="Etomite CMS web site">Etomite CMS</a> \r\nweb site, or from other sources. Of course, you can also ignore all of these\r\noptions and come up with something new!</p>\r\n\r\n<p>It''s Etomite - you decide.</p>', 1, 1, 20, 1, 0, 1, 1091398605, 1, 1144671552, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` VALUES (14, 'document', 'text/html', 'AlexisPro Redux', 'The Etomite classic', 'Demonstration of the AlexisPro Redux page template', 'alexispro-redux', 1, 0, 0, 13, 0, '<p>For as long as Etomite has been Etomite, there has been the \r\nAlexisPro Redux template. Built on tables and the classic orange \r\nand blue theme, this template is familiar territory.</p>', 1, 3, 10, 1, 0, 1, 1091398643, 1, 1144671969, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` VALUES (15, 'document', 'text/html', 'New-E', 'Classic colors - contemporary design', 'Demonstration of the New-E page template', 'new-e', 1, 0, 0, 13, 0, '<h2>Fresh</h2>\r\n\r\n<p>New-E is a more contemporary take on the classic orange \r\nand blue theme. Brighter, bolder, and more standards compliant, \r\nNew-E is the new Etomite standard.</p>\r\n\r\n<p>Also a shout of thanks to Capertino for the layout inspiration!</p>', 1, 1, 90, 1, 1, 1, 1091398664, 1, 1144672653, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` VALUES (16, 'document', 'text/html', 'Search Results', 'This document contains the SearchResults snippet call', 'Displays the results of the SearchPrompt snippet', '', 1, 0, 0, 2, 0, '[!SearchResults!]', 1, 2, 0, 0, 0, 1, 1121382499, 1, 1121382561, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` VALUES (17, 'document', 'text/html', 'Greens Template', 'Created by Karen Atherholt', 'Demonstration of the Greens page template', 'greens-template', 1, 0, 0, 13, 0, '<p>The Greens template being used here was created by Karen Atherholt.</p>\r\n\r\n<p>This page is being used to demonstrate the <span>DateTimePlus</span>, <span>GetAuthorData</span>, and <span>ListDocuments</span> snippets \r\nas well as documenting their use.</p>\r\n\r\n<p>This page was last edited on: [!DateTimePlus?timestamp=[*editedon*]!] \r\nby [[GetAuthorData?internalKey=[*editedby*]&amp;field=fullname]]</p>\r\n\r\n<p>This page was last rendered on [!DateTimePlus?format=m-d-Y @ H:i:s!]</p>\r\n\r\n<hr />\r\n\r\n<p><b>Using DateTimePlus</b></p>\r\n\r\n<p><span>DateTimePlus</span> is an <span>Etomite</span> snippet \r\nthat I developed as a versatile piece of code for displaying date \r\nand time information in templates, other snippets, or in chunks. \r\nAs you can see from the examples listed below, I tried to cover \r\nas many bases as possible with this one. And without breaking my \r\narm patting myself on the back, I think I did a pretty good job in \r\ndoing so. After giving the nitty gritty details on how the snippet \r\nworks I''m sure that you''ll be finding many ways to make use of <span>DateTimePlus</span>.</p>\r\n\r\n<p>Why is this snippet named <span>DateTimePlus</span>, you might ask. \r\nWell it isn''t because it can be used to display the date and time \r\nas it can do a whole lot more than that simple task. This snippet \r\ncan display any portions of a date and time based on parameters \r\nsent as the <span>format</span> variable within the snippet call \r\nwhich will be used by the PHP <span>strftime()</span> function to \r\nformat the output. The snippet will, by default, display the current \r\ndate and time, or any portions thereof, based on the default settings \r\nwhich can be configured within the snippet code. It can also display \r\na documents <span>createdon</span> or <span>editedon</span> date and \r\ntime by assigning either date object to the <span>timestamp</span> \r\nvariable when calling the snippet. And if all of those features \r\nweren''t enough, you can also make adjustments to reflect differences \r\nbetween timezones. This is done by sending the appropriate \r\n<span>+/-</span> difference with the <span>diff</span> variable.</p>\r\n\r\n<p>Okay, now that I''ve boasted the capabilities of the \r\n<span>DateTimePlus</span> snippet, look at the examples below and \r\ntake notice of how many different ways it can be implemented. \r\nThe examples are fairly self-explanitory and the snippet has \r\nenough documentation to cover the code logic as well as default \r\nvariable assignments. If someone happens to be adventurous and is using <span>Etomite</span> to develop a multi-language site I''m sure that <span>DateTimePlus</span> could be modified accordingly to cater \r\nto differing date and time display formats.</p>\r\n\r\n<p><span>Last Edited:</span> <span>[ [DateTimePlus?timestamp=</span>editedon<span>] ]</span> \r\n<span>=</span> [[DateTimePlus?timestamp=editedon]]</p><p><span>Created:</span> <span>[ [DateTimePlus?timestamp=createdon&amp;diff=0&amp;format=m/d/Y] ]</span>  <span>=</span>  [[DateTimePlus?timestamp=createdon&amp;diff=0&amp;format=m/d/Y]]</p>\r\n\r\n<p><span>Current Time (UK):</span> <span>[ [DateTimePlus?diff=5] ]</span>  <span>=</span>  [[DateTimePlus?diff=5]]</p><p><span>Current Time (EST):</span> <span>[ [DateTimePlus] ]</span>  <span>=</span>  [[DateTimePlus]]</p><p><span>Current Time (PST):</span> <span>[ [DateTimePlus?diff=-3] ]</span>  <span>=</span>  [[DateTimePlus?diff=-3]]</p>\r\n\r\n<p>The <span>DateTimePlus</span> snippet will be one of the standard \r\nsnipptes starting with <span>Etomite 0.6.1</span> in an effort to \r\nmake Etomite as flexible as possible.</p>\r\n\r\n<hr />\r\n\r\n<p><b>Using GetAuthorData</b></p>\r\n\r\n<p><span>GetAuthorData</span>, as the name implies, is a snippet \r\nwhich retrieves information about the author of a given document. \r\nAs with all of the new snippets which I have created for inclusion \r\nin future releases of Etomite this snippet gives plenty of \r\nflexibility to the developer. In addition, besides the \r\n<span>GetAuthorData</span> snippet, I have also created a core \r\nAPI function with the same name, <span>getAuthorData()</span>, \r\nwhich can be used within other snippets. In fact, the \r\n<span>GetAuthorData</span> snippet makes use of the \r\n<span>getAuthorData()</span> function. In light of the correlation \r\nbetween the two methods I will be covering both within this article.</p>\r\n\r\n<p>Considering how the <span>GetAuthorData</span> snippet \r\nutilizes the <span>getAuthorData</span> function we''ll cover \r\nthe function first. The theory behind the <span>getAuthorData</span> \r\nfunction is that it returns an array of data to the caller based \r\non the common Etomite table column <span>internalKey</span>. The \r\n<span>internalKey</span> column is used as a link between all of \r\nthe <span>manager_user</span> related data tables within the \r\nEtomite database. The resulting array returned a call to \r\n<span>getAuthorData</span>, <span>$author = $etomite-&gt;getAuthorData($internalKey);</span> would yield an \r\narray containing <span>$key=&gt;$value</span> pairs for \r\nall of the columns in the <span>user_attributes</span> table. \r\nThe <span>user_attributes</span> table contains the columns \r\n<span>id, internalKey, fullname, role, email, phone, mobilephone, \r\nblocked, blockeduntil, logincount, lastlogin, thislogin, \r\nfailedlogincount, and sessionid</span>. Using the example \r\nfunction call above it would then be possible to assign \r\nthese values to variables using <span>$fullname=$author[''fullname''];</span> \r\nor <span>$email =$author[''email''];</span>, for example. The \r\nfunction itself is relatively straightforward when compared to the \r\n<span>GetAuthorData</span> snippet which will be covered next.</p>\r\n\r\n<p>Now that we''ve covered how to use the <span>getAuthorData()</span> \r\nfunction we''ll examine how to use the corresponding snippet call, <span>GetAuthorData</span>. First, some theory. As stated previously, \r\nthe <span>GetAuthorData</span> snippet uses the <span>getAuthorData</span> \r\nfunction as a means of retrieving author related data from within \r\n<span>templates</span>, <span>chunks</span>, and <span>documents</span>. \r\nThe main difference between the two methods is that when using the snippet \r\ncall it is only possible to retrieve one column of data at a time from \r\nthe authors user_attributes record. But that doesn''t mean that the snippet \r\nlacks efficiency. The snippet actually optimizes its efficiency by storing \r\nthe current results in a session variable in an effort to reduce database \r\nqueries which could slow the parsers page renderings. A subsequent \r\ncall to <span>GetAuthorData</span>, whether in the same document or the \r\nnext page rendering, would result in the snippet checking the appropriate \r\nsession variable for results prior to calling the <span>getAuthorData</span> \r\nfunction which would once again query the database for the \r\n<span>user_attributes</span> record. If the <span>internalKey</span> \r\nof the record stored in the session variable matches the \r\n<span>internalKey</span> of the current snippet call then the \r\nresult is returned without the need for the additional database \r\nquery, thus saving valuable server resources over a period of time. \r\nAlthough the session variable could be populated by the \r\n<span>getAuthorData</span> function this task has been left to \r\nthe snippet so that this process can be bypassed by other \r\nsnippets utilizing the function call that may not require \r\nthe overhead of such functionality.</p>\r\n\r\n<p>So much for the \r\ntheory, now let''s move on the practical application. Here is \r\nwhere the versatility of this function/snippet pair truly comes \r\nto light. Let''s say, for example, that you are creating a \r\ncustom template that is intended to be used by either a specific \r\nauthor or a group of authors, possibly for columnist publications. \r\nSuch is the theory behind this column, <span>Doing More With \r\nEtomite</span>, which implements these features for both practical \r\napplication as well as proof of concept. My name, which is \r\ndisplayed in the header of this article, has been extracted \r\nfrom the user_attributes table using the snippet call <span>[ [GetAuthorData?internalKey=[*createdby*]&amp;field=fullname] ]</span>. \r\nWhen this snippet runs it sends the internalKey, which has been \r\nextracted from the document object record by the parser, to the \r\n<span>getAuthorData</span> function for processing. When the \r\nresults are returned to the snippet it then extracts fullname \r\nand returns that value for display on the rendered page. Along \r\nthe way the snippet also stores the entire author array in a \r\nsession variable for future reference prior to calling the \r\n<span>getAuthorData</span> function again with a subsequent <span>GetAuthorData</span> snippet call. If the internalKey''s \r\nmatch then the data will be extracted from the session array \r\nrather than wasting time querying the database again. So, what \r\nelse can this snippet do that makes it so special? How about retrieving information pertaining to the last person who edited a particular page by \r\nusing the snippet call <span>[ [GetAuthorData?internalKey=[*editedby*]&amp;field=fullname] ]</span> \r\nand then getting that persons email address by issuing the \r\nsnippet call <span>[ [GetAuthorData?internalKey=[*editedby*]&amp;field=email] ]</span>, both of which would be returned with only one \r\nquery of the database because both calls are using the \r\nsame <span>internalKey</span>. And if the next document page \r\nrendered happens to call for the same authors information it \r\nwill once again be returned without accessing the database. \r\nNow does it all make sense? Think versatility and efficiency! \r\nIt should be noted that you could also send <span>internalKey</span> \r\nas an integer just as easily as sending a document variable tag \r\nalthough I don''t foresee that method being required very often.</p>\r\n\r\n<p>Well, that about wraps things up for this installment of \r\n<span>Doing More With Etomite</span>. Next time I''ll be covering \r\nyet another versatile snippet, <span>GetDocObject</span>, which \r\ndoes as the name implies but with a few added twists. In closing, \r\nthe <span>getAuthorData</span> function and <span>GetAuthorData</span> \r\nsnippet will be included in the <span>Etomite 0.6.1 core API</span> \r\nfor developer convenience.</p>\r\n\r\n<hr />\r\n\r\n<p><b>Using ListDocuments</b></p>\r\n\r\n<p>ListDocuments being used to display the contents of the Repository &gt; \r\nNews folder.</p>\r\n\r\n<p>These listings have been created \r\nusing the <span>ListDocuments</span> snippet which is an improved \r\nversion of the original NewsListings snippet. <span>ListDocuments</span> \r\ncan be used to aggregate documents from multiple folders as well \r\nas having the capabilities to accept passed parameters to control \r\nseveral output parameters. See the snippet code for details on the \r\nversatility of this snippet.</p>\r\n\r\n[!ListDocuments?ids=8!]\r\n\r\n<p>&nbsp;</p>', 1, 2, 20, 1, 0, 1, 1121382689, 1, 1144672033, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` VALUES (19, 'document', 'text/html', 'Site Map', 'Links to every page on this web site', 'Links to every page on this web site', 'site-map', 1, 0, 0, 0, 0, '[!ListSiteMap!]', 1, 1, 50, 1, 0, 1, 1144386786, 1, 1144386786, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` VALUES (20, 'document', 'text/xml', 'Google Site Map', '', '', 'google-sitemap', 1, 0, 0, 2, 0, '', 0, 4, 10, 0, 0, 1, 1144396808, 1, 1144396866, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` VALUES (21, 'document', 'text/html', 'Mollio typeC', '3 columns - Main + Left hand nav + Right Sidebar', '3 columns - Main + Left hand nav + Right Sidebar', 'mollio-type-c', 1, 0, 0, 24, 0, '			<h1>Heading 1 Consect etuer adipisci ngon.</h1>\r\n			<h2>Heading 2 Consect etuer adipisci ngon.</h2>\r\n			<h3>Heading 3 Consect etuer adipisci ngon.</h3>\r\n			<h4>Heading 4 Consect etuer adipisci ngon.</h4>\r\n			<h5>Heading 5 Consect etuer adipisci ngon.</h5>\r\n			<h6>Heading 6 Consect etuer adipisci ngon.</h6>\r\n\r\n			<hr />\r\n			\r\n			<p>A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="highlight">A paragraph of text with class="highlight", A paragraph of text with class="highlight", A paragraph of text with class="highlight", A paragraph of text with class="highlight", A paragraph of text with class="highlight", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="subdued">A paragraph of text with class="subdued", A paragraph of text with class="subdued", A paragraph of text with class="subdued", A paragraph of text with class="subdued", A paragraph of text with class="subdued", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="error">A paragraph of text with class="error", A paragraph of text with class="error", A paragraph of text with class="error", A paragraph of text with class="error", A paragraph of text with class="error", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="success">A paragraph of text with class="success", A paragraph of text with class="success", A paragraph of text with class="success", A paragraph of text with class="success", A paragraph of text with class="success", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="caption">A paragraph of text with class="caption", A paragraph of text with class="caption", A paragraph of text with class="caption", A paragraph of text with class="caption", A paragraph of text with class="caption", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p><small>A paragraph of text with the text with &lt;small&gt; tags, A paragraph of text with the text with &lt;small&gt; tags, A paragraph of text with the text with &lt;small&gt; tags, A paragraph of text with the text with &lt;small&gt; tags, A paragraph of text with the text with &lt;small&gt; tags, </small></p>\r\n			\r\n			<hr />\r\n\r\n			\r\n			<p><strong>A paragraph of text with the text with &lt;strong&gt; tags, A paragraph of text with the text with &lt;strong&gt; tags, A paragraph of text with the text with &lt;strong&gt; tags, A paragraph of text with the text with &lt;strong&gt; tags, A paragraph of text with the text with &lt;strong&gt; tags, </strong></p>\r\n			\r\n			<hr />\r\n			\r\n			<div class="featurebox"><h3>A h3 level heading inside a "featurebox" div</h3><p>A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox" <a href="devtodo" class="morelink" title="A h3 level heading inside a featurebox div">More <span>about: A h3 level heading inside a featurebox div</span></a></p></div>\r\n			\r\n			<hr />\r\n			\r\n			<ul>\r\n			<li><a href="devtodo">A list of links</a></li>\r\n			<li><a href="devtodo">A list of links</a></li>\r\n			<li><a href="devtodo">A list of links</a></li>\r\n			</ul>\r\n			\r\n			<hr />\r\n			\r\n			<p>A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, </p>\r\n			<ul class="related">\r\n			<li><a href="devtodo">A list of related links</a></li>\r\n			<li><a href="devtodo">A list of related links</a></li>\r\n			<li><a href="devtodo">A list of related links</a></li>\r\n			</ul>\r\n			\r\n			<hr />\r\n			\r\n			<ul>\r\n			<li>An unordered list</li>\r\n			<li>An unordered list</li>\r\n			<li>An unordered list</li>\r\n			</ul>\r\n			\r\n			<hr />\r\n			\r\n			<ol>\r\n			<li>An ordered list</li>\r\n			<li>An ordered list</li>\r\n			<li>An ordered list</li>\r\n			</ol>\r\n			\r\n			<hr />\r\n			\r\n			<dl>\r\n			<dt>A definition list - and this is the dt</dt>\r\n			<dd>A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, </dd>\r\n			<dt>A definition list - and this is the dt</dt>\r\n			<dd>A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, </dd>\r\n			</dl>\r\n			\r\n			<hr />\r\n			\r\n			<h4><span class="date">29 July 2005</span> Headline and associate teaser</h4>\r\n			<p>Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Donec pharetra. <a href="devtodo" class="morelink" title="Headline and associate teaser">More <span>about: Headline and associate teaser</span></a></p>\r\n			\r\n			<h4><span class="date">29 July 2005</span> Headline and associate teaser</h4>\r\n			<p>Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Donec pharetra. <a href="devtodo" class="morelink" title="Headline and associate teaser">More <span>about: Headline and associate teaser</span></a></p>\r\n			\r\n			<hr />\r\n			\r\n			<h4><span class="date">29 July 2005</span> Headline and associate teaser and thumbnail</h4>\r\n			<p><span class="thumbnail"><a href="devtodo"><img src="templates/mollio/images/thumb_100wide.gif" alt="Demo" width="100" height="75" /></a></span>Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Donec pharetra. <a href="devtodo" class="morelink" title="Headline and associate teaser">More <span>about: Headline and associate teaser</span></a></p>\r\n			\r\n			<hr />\r\n			\r\n			<h4><span class="date">29 July 2005</span> Headline and associate teaser and thumbnail</h4>\r\n			<p><span class="thumbnail"><a href="devtodo"><img src="templates/mollio/images/thumb_100wide.gif" alt="Demo" width="100" height="75" /></a></span>Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Donec pharetra. <a href="devtodo" class="morelink" title="Headline and associate teaser">More <span>about: Headline and associate teaser</span></a></p>\r\n			\r\n			<hr />\r\n			\r\n			<div class="pagination">\r\n			<p><span><strong>Previous</strong></span> <span>1</span> <a href="devtodo">2</a> <a href="devtodo">3</a> <a href="devtodo">4</a> <a href="devtodo">5</a> <a href="devtodo"><strong>Next</strong></a></p>\r\n			<h4>Page 1 of 5</h4>\r\n			</div>\r\n			\r\n			<hr />\r\n			\r\n			<h1>Search Results</h1>\r\n			\r\n			<div id="resultslist-wrap">\r\n				<ol>\r\n				<li>\r\n					<dl>\r\n					<dt><a href="devtodo">Fringilla tortor. Sed ullamcorper imperdiet metus.</a></dt>\r\n					<dd class="desc">Maecenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris at enim. Ut vestibulum erat at tellus.</dd>\r\n					<dd class="filetype">HTML</dd>\r\n					<dd class="date">22 April 2005</dd>\r\n					</dl>\r\n				</li>\r\n				<li>\r\n					<dl>\r\n					<dt><a href="devtodo">Fringilla tortor. Sed ullamcorper imperdiet metus.</a></dt>\r\n					<dd class="desc">Maecenas nec ante vitae turpis intecenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris rdum placerat. Duis in nisi. Mauris at enim. Ut vestibulum erat at tellus.</dd>\r\n					<dd class="filetype">HTML</dd>\r\n					<dd class="date">22 April 2005</dd>\r\n					</dl>\r\n				</li>\r\n				<li>\r\n					<dl>\r\n					<dt><a href="devtodo">Fringilla tortor. Sed ullamcorper imperdiet metus.</a></dt>\r\n					<dd class="desc">Maecenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris at enim. Ut vestibulum erat at tellus.</dd>\r\n					<dd class="filetype">PDF</dd>\r\n					<dd class="date">22 April 2005</dd>\r\n					</dl>\r\n				</li>\r\n				<li>\r\n					<dl>\r\n					<dt><a href="devtodo">Fringilla tortor. Sed ullamcorper imperdiet metus.</a></dt>\r\n					<dd class="desc">Maecenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris at enim. Ut vestibulum erat at tellus.</dd>\r\n					<dd class="filetype">WORD</dd>\r\n					<dd class="date">22 April 2005</dd>\r\n					</dl>\r\n				</li>\r\n				</ol>\r\n			</div>\r\n', 1, 5, 30, 1, 1, 1, 1144473567, 1, 1144672849, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` VALUES (24, 'document', 'text/html', 'Mollio Templates', 'Mollio CSS/HTML Templates', 'Mollio is a simple set of html/css templates.', 'mollio-templates', 1, 0, 0, 13, 1, '		<h2>What is Mollio?</h2>\r\n		\r\n		<p>\r\n		Mollio is a simple set of html/css templates. The aim was to create a set of page templates that use \r\n		css for layout <strong>as well as</strong> some sample basic content which has also had some css applied. It''s definitely a work in \r\n		progress. More sample content and layouts are planned to be added. Get involved, suggest &amp; contribute \r\n		ideas via the <a href="http://groups.google.com/group/Mollio">Mollio Google Group</a>.\r\n		</p>\r\n		\r\n		<h2>So enough of the chit chat, what are you talking about?</h2>\r\n		\r\n		<ul>\r\n		<li><b>Type A</b> - 1 column</li>\r\n		<li><b>Type B</b> - 2 columns - Main + Left hand nav</li>\r\n		<li><b>Type C</b> - 3 columns - Main + Left hand nav + Right Sidebar</li>\r\n		<li><b>Type D</b> - 2 columns - Main + Right Sidebar</li>\r\n		<li><b>Type E</b> - 2 columns - Main + Right hand nav</li>\r\n		<li><b>Type F</b> - 3 columns - Main + Right hand nav + Left Sidebar</li>\r\n		<li><a href="http://www.mollio.org/mollio_style_guide.pdf">Styleguide (PDF)</a></li>\r\n		</ul>\r\n		\r\n		<h2>Can I use it on my own project?</h2>\r\n		<p>\r\n		Our hope is to make Mollio templates and their derivatives as universal as possible.  In order to help those creating derivative works of Mollio we''ve agreed to release the templates under three different licenses; <a href="http://creativecommons.org/licenses/by/2.5/">Creative Commons</a>, <a href="http://creativecommons.org/licenses/GPL/2.0/">GPL</a> and <a href="http://www.opensource.org/licenses/cpl1.0.php">CPL</a>.  \r\n		As a creator of a derivative work you simply need to choose the license that suits your project.\r\n		</p>\r\n		<p>\r\n		If you have no idea about licensing or want to know nothing about licensing then you are after the Creative Commons license.  Essentially you can do what you like as long as you keep the attribution in the HTML\r\n		- basically a link to Mollio saying where it all began.\r\n		</p>\r\n		\r\n		<h2>Who made it?</h2>\r\n		<p>\r\n		Pete Ottery (pottery at daemon dot com dot au), Creative Director from a Web Development company in Sydney called <a href="http://daemon.com.au/">Daemon</a>.\r\n		</p>\r\n		\r\n		<h2>Why?</h2>\r\n		<p>\r\n		Daemon built an open source CMS called <a href="http://www.farcrycms.org/">FarCry</a>, and Pete created this skin to use as a default install skin \r\n		when creating a site. We figured the html/css would be helpful to use in its own right, so even if you \r\n		are not using FarCry you might find it useful.\r\n		</p>\r\n		\r\n		<h2>Is there any support or help provided?</h2>\r\n		<p>\r\n		Theres a very basic styleguide linked above which details how the page templates are structured.\r\n		Beyond that, join the <a href="http://groups.google.com/group/Mollio">Mollio Google Group</a> &amp; ask questions.\r\n		</p>\r\n		\r\n		<h2>The History of updates</h2>\r\n		<dl>\r\n		<dt>Version 1.1</dt>\r\n		<dd>\r\n			<ol>\r\n			<li>added another layout, a "type F". basically the same as Type C but the left and right columns swapped</li>\r\n			<li>added partial support for Mac IE5. the css now has a set (fixed) width you can define (set at 10em in Mollio) for those top horizontal nav items. other browsers get a width:auto</li>\r\n			<li>the licenses its released under have been updated. now CC, GPL &amp; CPL. All the detail you could ever want to know is linked above.</li>\r\n			</ol>\r\n		</dd>\r\n\r\n		<dt>Mollio for Etomite CMS</dt>\r\n		<dd>\r\n			<ol>\r\n			<li>Mollio templates adapted for use with <a href="http://www.etomite.com/" title="Etomite CMS">Etomite CMS web site</a> by <a href="http://www.borrett.id.au" title="Lloyd Borrett''s web site">Lloyd Borrett</a>, 9th April 2006.</li>\r\n			<li>Snippets built/adapted by Lloyd Borrett to generate suitable output for the Mollio templates.</li>\r\n			</ol>\r\n		</dd>\r\n		</dl>\r\n		\r\n		<hr />\r\n		\r\n		<p>Copyright &copy; 2006 <a href="http://daemon.com.au/">Daemon Pty Limited</a></p>\r\n', 1, 5, 30, 1, 1, 1, 1144587301, 1, 1144672169, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` VALUES (49, 'document', 'text/html', 'Mollio typeA', '1 column', '1 column', 'mollio-type-a', 1, 0, 0, 24, 0, '			<h1>Heading 1 Consect etuer adipisci ngon.</h1>\r\n			<h2>Heading 2 Consect etuer adipisci ngon.</h2>\r\n			<h3>Heading 3 Consect etuer adipisci ngon.</h3>\r\n			<h4>Heading 4 Consect etuer adipisci ngon.</h4>\r\n			<h5>Heading 5 Consect etuer adipisci ngon.</h5>\r\n			<h6>Heading 6 Consect etuer adipisci ngon.</h6>\r\n			\r\n			<hr />\r\n			\r\n			<p>A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="highlight">A paragraph of text with class="highlight", A paragraph of text with class="highlight", A paragraph of text with class="highlight", A paragraph of text with class="highlight", A paragraph of text with class="highlight", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="subdued">A paragraph of text with class="subdued", A paragraph of text with class="subdued", A paragraph of text with class="subdued", A paragraph of text with class="subdued", A paragraph of text with class="subdued", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="error">A paragraph of text with class="error", A paragraph of text with class="error", A paragraph of text with class="error", A paragraph of text with class="error", A paragraph of text with class="error", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="success">A paragraph of text with class="success", A paragraph of text with class="success", A paragraph of text with class="success", A paragraph of text with class="success", A paragraph of text with class="success", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="caption">A paragraph of text with class="caption", A paragraph of text with class="caption", A paragraph of text with class="caption", A paragraph of text with class="caption", A paragraph of text with class="caption", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p><small>A paragraph of text with the text with &lt;small&gt; tags, A paragraph of text with the text with &lt;small&gt; tags, A paragraph of text with the text with &lt;small&gt; tags, A paragraph of text with the text with &lt;small&gt; tags, A paragraph of text with the text with &lt;small&gt; tags, </small></p>\r\n			\r\n			<hr />\r\n			\r\n			<p><em>A paragraph of text with the text with &lt;em&gt; tags, A paragraph of text with the text with</em></p>\r\n			\r\n			<hr />\r\n			\r\n			<p><strong>A paragraph of text with the text with &lt;strong&gt; tags, A paragraph of text with the text with &lt;strong&gt; tags, A paragraph of text with the text with &lt;strong&gt; tags, A paragraph of text with the text with &lt;strong&gt; tags, A paragraph of text with the text with &lt;strong&gt; tags, </strong></p>\r\n\r\n			<hr />\r\n			\r\n			<div class="featurebox"><h3>A h3 level heading inside a "featurebox" div</h3><p>A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox" <a href="devtodo" class="morelink" title="A h3 level heading inside a featurebox div">More <span>about: A h3 level heading inside a featurebox div</span></a></p></div>\r\n			\r\n			<hr />\r\n			\r\n			<ul>\r\n			<li><a href="devtodo">A list of links</a></li>\r\n			<li><a href="devtodo">A list of links</a></li>\r\n			<li><a href="devtodo">A list of links</a></li>\r\n			</ul>\r\n			\r\n			<hr />\r\n			\r\n			<p>A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, </p>\r\n			<ul class="related">\r\n			<li><a href="devtodo">A list of related links</a></li>\r\n			<li><a href="devtodo">A list of related links</a></li>\r\n			<li><a href="devtodo">A list of related links</a></li>\r\n			</ul>\r\n			\r\n			<hr />\r\n			\r\n			<ul>\r\n			<li>An unordered list</li>\r\n			<li>An unordered list</li>\r\n			<li>An unordered list</li>\r\n			</ul>\r\n			\r\n			<hr />\r\n			\r\n			<ol>\r\n			<li>An ordered list</li>\r\n			<li>An ordered list</li>\r\n			<li>An ordered list</li>\r\n			</ol>\r\n			\r\n			<hr />\r\n			\r\n			<dl>\r\n			<dt>A definition list - and this is the dt</dt>\r\n			<dd>A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, </dd>\r\n			<dt>A definition list - and this is the dt</dt>\r\n			<dd>A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, </dd>\r\n			</dl>\r\n			\r\n			<hr />\r\n			\r\n			<h4><span class="date">29 July 2005</span> Headline and associate teaser</h4>\r\n			<p>Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Donec pharetra. <a href="devtodo" class="morelink" title="Headline and associate teaser">More <span>about: Headline and associate teaser</span></a></p>\r\n			<div class="clear">&nbsp;</div>\r\n			\r\n			<h4><span class="date">29 July 2005</span> Headline and associate teaser</h4>\r\n			<p>Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Donec pharetra. <a href="devtodo" class="morelink" title="Headline and associate teaser">More <span>about: Headline and associate teaser</span></a></p>\r\n			<div class="clear">&nbsp;</div>\r\n			\r\n			<hr />\r\n			\r\n			<h4><span class="date">29 July 2005</span> Headline and associate teaser and thumbnail</h4>\r\n			<p><span class="thumbnail"><a href="devtodo"><img src="templates/mollio/images/thumb_100wide.gif" alt="Demo" width="100" height="75" /></a></span>Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Donec pharetra. <a href="devtodo" class="morelink" title="Headline and associate teaser">More <span>about: Headline and associate teaser</span></a></p>\r\n			\r\n			\r\n			<h4><span class="date">29 July 2005</span> Headline and associate teaser and thumbnail</h4>\r\n			<p><span class="thumbnail"><a href="devtodo"><img src="templates/mollio/images/thumb_100wide.gif" alt="Demo" width="100" height="75" /></a></span>Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Donec pharetra. <a href="devtodo" class="morelink" title="Headline and associate teaser">More <span>about: Headline and associate teaser</span></a></p>\r\n			\r\n			\r\n			<hr />\r\n			\r\n			<div class="pagination">\r\n			<p><span><strong>Previous</strong></span> <span>1</span> <a href="devtodo">2</a> <a href="devtodo">3</a> <a href="devtodo">4</a> <a href="devtodo">5</a> <a href="devtodo"><strong>Next</strong></a></p>\r\n			<h4>Page 1 of 5</h4>\r\n			</div>\r\n			\r\n			<hr />\r\n			\r\n			<h1>Search Results</h1>\r\n			\r\n			<div id="resultslist-wrap">\r\n				<ol>\r\n				<li>\r\n					<dl>\r\n					<dt><a href="devtodo">Fringilla tortor. Sed ullamcorper imperdiet metus.</a></dt>\r\n					<dd class="desc">Maecenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris at enim. Ut vestibulum erat at tellus.</dd>\r\n					<dd class="filetype">HTML</dd>\r\n					<dd class="date">22 April 2005</dd>\r\n					</dl>\r\n				</li>\r\n				<li>\r\n					<dl>\r\n					<dt><a href="devtodo">Fringilla tortor. Sed ullamcorper imperdiet metus.</a></dt>\r\n					<dd class="desc">Maecenas nec ante vitae turpis intecenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris rdum placerat. Duis in nisi. Mauris at enim. Ut vestibulum erat at tellus.</dd>\r\n					<dd class="filetype">HTML</dd>\r\n					<dd class="date">22 April 2005</dd>\r\n					</dl>\r\n				</li>\r\n				<li>\r\n					<dl>\r\n					<dt><a href="devtodo">Fringilla tortor. Sed ullamcorper imperdiet metus.</a></dt>\r\n					<dd class="desc">Maecenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris at enim. Ut vestibulum erat at tellus.</dd>\r\n					<dd class="filetype">PDF</dd>\r\n					<dd class="date">22 April 2005</dd>\r\n					</dl>\r\n				</li>\r\n				<li>\r\n					<dl>\r\n					<dt><a href="devtodo">Fringilla tortor. Sed ullamcorper imperdiet metus.</a></dt>\r\n					<dd class="desc">Maecenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris at enim. Ut vestibulum erat at tellus.</dd>\r\n					<dd class="filetype">WORD</dd>\r\n					<dd class="date">22 April 2005</dd>\r\n					</dl>\r\n				</li>\r\n				</ol>\r\n			</div>\r\n			\r\n			<hr />\r\n			\r\n			<table class="table1">\r\n			<thead>\r\n				<tr>\r\n				<th colspan="3">Table Heading</th>\r\n				</tr>\r\n			</thead>\r\n			<tbody>\r\n				<tr>\r\n				<th>Col 1</th>\r\n				<th>Col 2</th>\r\n				<th>Col 3</th>\r\n				</tr>\r\n				<tr>\r\n				<th class="sub">Sub head 1</th>\r\n				<td>209385</td>\r\n				<td>45</td>\r\n				</tr>\r\n				<tr>\r\n				<th class="sub">Sub head 2</th>\r\n				<td>4577</td>\r\n				<td>22</td>\r\n				</tr>\r\n				<tr>\r\n				<th class="sub">Sub head 3</th>\r\n				<td>69765</td>\r\n				<td>75</td>\r\n				</tr>\r\n			</tbody>\r\n			</table>\r\n			\r\n			<hr />\r\n			\r\n			<table class="table1 calendar">\r\n			<thead>\r\n				<tr>\r\n				<th colspan="7">October</th>\r\n				</tr>\r\n			</thead>\r\n			<tbody>\r\n				<tr>\r\n				<th>S</th>\r\n				<th>M</th>\r\n				<th>T</th>\r\n				<th>W</th>\r\n				<th>T</th>\r\n				<th>F</th>\r\n				<th>S</th>\r\n				</tr>\r\n				<tr>\r\n				<td>1</td>\r\n				<td>2</td>\r\n				<td>3</td>\r\n				<td>4</td>\r\n				<td>5</td>\r\n				<td>6</td>\r\n				<td>7</td>\r\n				</tr>\r\n				<tr>\r\n				<td>1</td>\r\n				<td>2</td>\r\n				<td>3</td>\r\n				<td>4</td>\r\n				<td>5</td>\r\n				<td>6</td>\r\n				<td>7</td>\r\n				</tr>\r\n				<tr>\r\n				<td>1</td>\r\n				<td>2</td>\r\n				<td>3</td>\r\n				<td>4</td>\r\n				<td>5</td>\r\n				<td>6</td>\r\n				<td>7</td>\r\n				</tr>\r\n				<tr>\r\n				<td>1</td>\r\n				<td>2</td>\r\n				<td>3</td>\r\n				<td>4</td>\r\n				<td>5</td>\r\n				<td>6</td>\r\n				<td>7</td>\r\n				</tr>\r\n			</tbody>\r\n			</table>\r\n			\r\n			<hr />\r\n			\r\n			<form action="forms.html" method="post" class="f-wrap-1">\r\n			\r\n			<div class="req"><b>*</b> Indicates required field</div>\r\n			\r\n			<fieldset>\r\n			\r\n			<h3>Form title here</h3>\r\n			\r\n			<label for="firstname"><b><span class="req">*</span>First name:</b>\r\n			<input id="firstname" name="firstname" type="text" class="f-name" tabindex="1" /><br />\r\n			</label>\r\n			\r\n			<label for="lastname"><b><span class="req">*</span>Last name:</b>\r\n			<input id="lastname" name="lastname" type="text" class="f-name" tabindex="2" /><br />\r\n			</label>\r\n			\r\n			<label for="emailaddress"><b><span class="req">*</span>Email Address:</b>\r\n			<input id="emailaddress" name="emailaddress" type="text" class="f-email" tabindex="3" /><br />\r\n			</label>\r\n			\r\n			<label for="enquiry"><b>Enquiry Type:</b>\r\n			<select id="enquiry" name="enquiry" tabindex="4">\r\n			<option>Select...</option>\r\n			<option>c nulla. Fusce tincidu</option>\r\n			<option>Maecenas digniss</option>\r\n			<option>tincidunt arcu eget sapien</option>\r\n			</select>\r\n			<br />\r\n			</label>\r\n			\r\n			<fieldset class="f-checkbox-wrap">\r\n			\r\n			<b>Colour:</b>\r\n			\r\n				<fieldset>\r\n				\r\n				<label for="blue">\r\n				<input id="blue" type="checkbox" name="checkbox" value="checkbox" class="f-checkbox" tabindex="5" />\r\n				sit amet, consectetu</label>\r\n				\r\n				<label for="green">\r\n				<input id="green" type="checkbox" name="checkbox2" value="checkbox" class="f-checkbox" tabindex="6" />\r\n				c nulla. Fusce tincidu</label>\r\n				\r\n				<label for="yellow">\r\n				<input id="yellow" type="checkbox" name="checkbox3" value="checkbox" class="f-checkbox" tabindex="7" />\r\n				tincidunt arcu eget </label>\r\n				</fieldset>\r\n				\r\n			</fieldset> \r\n			\r\n			<fieldset class="f-radio-wrap">\r\n		\r\n			<b>Country:</b>\r\n			\r\n				<fieldset>\r\n				\r\n				<label for="australia">\r\n				<input id="australia" type="radio" name="radio" value="Australia" class="f-radio" tabindex="8" />\r\n				Australia</label>\r\n				\r\n				<label for="newzealand">\r\n				<input id="newzealand" type="radio" name="radio" value="New Zealand" class="f-radio" tabindex="9" />\r\n				New Zealand</label>\r\n				\r\n				<label for="antarctica">\r\n				<input id="antarctica" type="radio" name="radio" value="Antarctica" class="f-radio" tabindex="10" />\r\n				Antarctica</label>\r\n	\r\n				</fieldset>\r\n			\r\n			</fieldset>\r\n			\r\n			<label for="comments"><b>Comments:</b>\r\n			<textarea id="comments" name="comments" class="f-comments" rows="6" cols="20" tabindex="11"></textarea><br />\r\n			</label>\r\n			\r\n			<div class="f-submit-wrap">\r\n			<input type="submit" value="Submit" class="f-submit" tabindex="12" /><br />\r\n			</div>\r\n			</fieldset>\r\n			</form>', 1, 22, 10, 1, 1, 1, 1144667056, 1, 1144672799, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` VALUES (50, 'document', 'text/html', 'Mollio typeB', '2 columns - Main + Left hand nav', '2 columns - Main + Left hand nav', 'mollio-type-b', 1, 0, 0, 24, 0, '			<h1>Heading 1 Consect etuer adipisci ngon.</h1>\r\n			<h2>Heading 2 Consect etuer adipisci ngon.</h2>\r\n			<h3>Heading 3 Consect etuer adipisci ngon.</h3>\r\n			<h4>Heading 4 Consect etuer adipisci ngon.</h4>\r\n			<h5>Heading 5 Consect etuer adipisci ngon.</h5>\r\n			<h6>Heading 6 Consect etuer adipisci ngon.</h6>\r\n\r\n			<hr />\r\n			\r\n			<p>A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="highlight">A paragraph of text with class="highlight", A paragraph of text with class="highlight", A paragraph of text with class="highlight", A paragraph of text with class="highlight", A paragraph of text with class="highlight", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="subdued">A paragraph of text with class="subdued", A paragraph of text with class="subdued", A paragraph of text with class="subdued", A paragraph of text with class="subdued", A paragraph of text with class="subdued", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="error">A paragraph of text with class="error", A paragraph of text with class="error", A paragraph of text with class="error", A paragraph of text with class="error", A paragraph of text with class="error", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="success">A paragraph of text with class="success", A paragraph of text with class="success", A paragraph of text with class="success", A paragraph of text with class="success", A paragraph of text with class="success", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="caption">A paragraph of text with class="caption", A paragraph of text with class="caption", A paragraph of text with class="caption", A paragraph of text with class="caption", A paragraph of text with class="caption", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p><small>A paragraph of text with the text with &lt;small&gt; tags, A paragraph of text with the text with &lt;small&gt; tags, A paragraph of text with the text with &lt;small&gt; tags, A paragraph of text with the text with &lt;small&gt; tags, A paragraph of text with the text with &lt;small&gt; tags, </small></p>\r\n			\r\n			<hr />\r\n			\r\n			<p><em>A paragraph of text with the text with &lt;em&gt; tags, A paragraph of text with the text with</em></p>\r\n			\r\n			<hr />\r\n			\r\n			<p><strong>A paragraph of text with the text with &lt;strong&gt; tags, A paragraph of text with the text with &lt;strong&gt; tags, A paragraph of text with the text with &lt;strong&gt; tags, A paragraph of text with the text with &lt;strong&gt; tags, A paragraph of text with the text with &lt;strong&gt; tags, </strong></p>\r\n			\r\n			<hr />\r\n			\r\n			<div class="featurebox"><h3>A h3 level heading inside a "featurebox" div</h3><p>A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox" <a href="devtodo" class="morelink" title="A h3 level heading inside a featurebox div">More <span>about: A h3 level heading inside a featurebox div</span></a></p></div>\r\n			\r\n			<hr />\r\n			\r\n			<div class="featurebox2"><h3>A h3 level heading inside a "featurebox2" div</h3><p>A normal paragraph of text within a div with a class="featurebox2", A normal paragraph of text within a div with a class="featurebox2", A normal paragraph of text within a div with a class="featurebox2", A normal paragraph of text within a div with a class="featurebox2", A normal paragraph of text within a div with a class="featurebox2", A normal paragraph of text within a div with a class="featurebox2" <a href="devtodo" class="morelink" title="A h3 level heading inside a featurebox2 div">More <span>about: A h3 level heading inside a featurebox2 div</span></a></p></div>\r\n			\r\n			<hr />\r\n			\r\n			<ul>\r\n			<li><a href="devtodo">A list of links</a></li>\r\n			<li><a href="devtodo">A list of links</a></li>\r\n			<li><a href="devtodo">A list of links</a></li>\r\n			</ul>\r\n			\r\n			<hr />\r\n			\r\n			<p>A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, </p>\r\n			<ul class="related">\r\n			<li><a href="devtodo">A list of related links</a></li>\r\n			<li><a href="devtodo">A list of related links</a></li>\r\n			<li><a href="devtodo">A list of related links</a></li>\r\n			</ul>\r\n			\r\n			<hr />\r\n			\r\n			<ul>\r\n			<li>An unordered list</li>\r\n			<li>An unordered list</li>\r\n			<li>An unordered list</li>\r\n			</ul>\r\n			\r\n			<hr />\r\n			\r\n			<ol>\r\n			<li>An ordered list</li>\r\n			<li>An ordered list</li>\r\n			<li>An ordered list</li>\r\n			</ol>\r\n			\r\n			<hr />\r\n			\r\n			<dl>\r\n			<dt>A definition list - and this is the dt</dt>\r\n			<dd>A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, </dd>\r\n			<dt>A definition list - and this is the dt</dt>\r\n			<dd>A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, </dd>\r\n			</dl>\r\n			\r\n			<hr />\r\n			\r\n			<h4><span class="date">29 July 2005</span> Headline and associate teaser</h4>\r\n			<p>Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Donec pharetra. <a href="devtodo" class="morelink" title="Headline and associate teaser">More <span>about: Headline and associate teaser</span></a></p>\r\n			\r\n			<h4><span class="date">29 July 2005</span> Headline and associate teaser</h4>\r\n			<p>Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Donec pharetra. <a href="devtodo" class="morelink" title="Headline and associate teaser">More <span>about: Headline and associate teaser</span></a></p>\r\n			\r\n			<hr />\r\n			\r\n			<h4><span class="date">29 July 2005</span> Headline and associate teaser and thumbnail</h4>\r\n			<p><span class="thumbnail"><a href="devtodo"><img src="templates/mollio/images/thumb_100wide.gif" alt="Demo" width="100" height="75" /></a></span>Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Donec pharetra. <a href="devtodo" class="morelink" title="Headline and associate teaser">More <span>about: Headline and associate teaser</span></a></p>\r\n			\r\n			<hr />\r\n			\r\n			<h4><span class="date">29 July 2005</span> Headline and associate teaser and thumbnail</h4>\r\n			<p><span class="thumbnail"><a href="devtodo"><img src="templates/mollio/images/thumb_100wide.gif" alt="Demo" width="100" height="75" /></a></span>Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Donec pharetra. <a href="devtodo" class="morelink" title="Headline and associate teaser">More <span>about: Headline and associate teaser</span></a></p>\r\n			\r\n			<hr />\r\n			\r\n			<div class="pagination">\r\n			<p><span><strong>Previous</strong></span> <span>1</span> <a href="devtodo">2</a> <a href="devtodo">3</a> <a href="devtodo">4</a> <a href="devtodo">5</a> <a href="devtodo"><strong>Next</strong></a></p>\r\n			<h4>Page 1 of 5</h4>\r\n			</div>\r\n			\r\n			<hr />\r\n			\r\n			<h1>Search Results</h1>\r\n			\r\n			<div id="resultslist-wrap">\r\n				<ol>\r\n				<li>\r\n					<dl>\r\n					<dt><a href="devtodo">Fringilla tortor. Sed ullamcorper imperdiet metus.</a></dt>\r\n					<dd class="desc">Maecenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris at enim. Ut vestibulum erat at tellus.</dd>\r\n					<dd class="filetype">HTML</dd>\r\n					<dd class="date">22 April 2005</dd>\r\n					</dl>\r\n				</li>\r\n				<li>\r\n					<dl>\r\n					<dt><a href="devtodo">Fringilla tortor. Sed ullamcorper imperdiet metus.</a></dt>\r\n					<dd class="desc">Maecenas nec ante vitae turpis intecenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris rdum placerat. Duis in nisi. Mauris at enim. Ut vestibulum erat at tellus.</dd>\r\n					<dd class="filetype">HTML</dd>\r\n					<dd class="date">22 April 2005</dd>\r\n					</dl>\r\n				</li>\r\n				<li>\r\n					<dl>\r\n					<dt><a href="devtodo">Fringilla tortor. Sed ullamcorper imperdiet metus.</a></dt>\r\n					<dd class="desc">Maecenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris at enim. Ut vestibulum erat at tellus.</dd>\r\n					<dd class="filetype">PDF</dd>\r\n					<dd class="date">22 April 2005</dd>\r\n					</dl>\r\n				</li>\r\n				<li>\r\n					<dl>\r\n					<dt><a href="devtodo">Fringilla tortor. Sed ullamcorper imperdiet metus.</a></dt>\r\n					<dd class="desc">Maecenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris at enim. Ut vestibulum erat at tellus.</dd>\r\n					<dd class="filetype">WORD</dd>\r\n					<dd class="date">22 April 2005</dd>\r\n					</dl>\r\n				</li>\r\n				</ol>\r\n			</div>\r\n			\r\n			<hr />\r\n			\r\n			<table class="table1">\r\n			<thead>\r\n				<tr>\r\n				<th colspan="3">Table Heading</th>\r\n				</tr>\r\n			</thead>\r\n			<tbody>\r\n				<tr>\r\n				<th>Col 1</th>\r\n				<th>Col 2</th>\r\n				<th>Col 3</th>\r\n				</tr>\r\n				<tr>\r\n				<th class="sub">Sub head 1</th>\r\n				<td>209385</td>\r\n				<td>45</td>\r\n				</tr>\r\n				<tr>\r\n				<th class="sub">Sub head 2</th>\r\n				<td>4577</td>\r\n				<td>22</td>\r\n				</tr>\r\n				<tr>\r\n				<th class="sub">Sub head 3</th>\r\n				<td>69765</td>\r\n				<td>75</td>\r\n				</tr>\r\n			</tbody>\r\n			</table>\r\n			\r\n			<hr />\r\n			\r\n			<table class="table1 calendar">\r\n			<thead>\r\n				<tr>\r\n				<th colspan="7">October</th>\r\n				</tr>\r\n			</thead>\r\n			<tbody>\r\n				<tr>\r\n				<th>S</th>\r\n				<th>M</th>\r\n				<th>T</th>\r\n				<th>W</th>\r\n				<th>T</th>\r\n				<th>F</th>\r\n				<th>S</th>\r\n				</tr>\r\n				<tr>\r\n				<td>1</td>\r\n				<td>2</td>\r\n				<td>3</td>\r\n				<td>4</td>\r\n				<td>5</td>\r\n				<td>6</td>\r\n				<td>7</td>\r\n				</tr>\r\n				<tr>\r\n				<td>1</td>\r\n				<td>2</td>\r\n				<td>3</td>\r\n				<td>4</td>\r\n				<td>5</td>\r\n				<td>6</td>\r\n				<td>7</td>\r\n				</tr>\r\n				<tr>\r\n				<td>1</td>\r\n				<td>2</td>\r\n				<td>3</td>\r\n				<td>4</td>\r\n				<td>5</td>\r\n				<td>6</td>\r\n				<td>7</td>\r\n				</tr>\r\n				<tr>\r\n				<td>1</td>\r\n				<td>2</td>\r\n				<td>3</td>\r\n				<td>4</td>\r\n				<td>5</td>\r\n				<td>6</td>\r\n				<td>7</td>\r\n				</tr>\r\n			</tbody>\r\n			</table>\r\n			\r\n			<hr />\r\n			\r\n			<form action="forms.html" method="post" class="f-wrap-1">\r\n			\r\n			<div class="req"><b>*</b> Indicates required field</div>\r\n			\r\n			<fieldset>\r\n			\r\n			<h3>Form title here</h3>\r\n			\r\n			<label for="firstname"><b><span class="req">*</span>First name:</b>\r\n			<input id="firstname" name="firstname" type="text" class="f-name" tabindex="1" /><br />\r\n			</label>\r\n			\r\n			<label for="lastname"><b><span class="req">*</span>Last name:</b>\r\n			<input id="lastname" name="lastname" type="text" class="f-name" tabindex="2" /><br />\r\n			</label>\r\n			\r\n			<label for="emailaddress"><b><span class="req">*</span>Email Address:</b>\r\n			<input id="emailaddress" name="emailaddress" type="text" class="f-email" tabindex="3" /><br />\r\n			</label>\r\n			\r\n			<label for="enquiry"><b>Enquiry Type:</b>\r\n			<select id="enquiry" name="enquiry" tabindex="4">\r\n			<option>Select...</option>\r\n			<option>c nulla. Fusce tincidu</option>\r\n			<option>Maecenas digniss</option>\r\n			<option>tincidunt arcu eget sapien</option>\r\n			</select>\r\n			<br />\r\n			</label>\r\n			\r\n			<fieldset class="f-checkbox-wrap">\r\n			\r\n			<b>Colour:</b>\r\n			\r\n				<fieldset>\r\n				\r\n				<label for="blue">\r\n				<input id="blue" type="checkbox" name="checkbox" value="checkbox" class="f-checkbox" tabindex="5" />\r\n				sit amet, consectetu</label>\r\n				\r\n				<label for="green">\r\n				<input id="green" type="checkbox" name="checkbox2" value="checkbox" class="f-checkbox" tabindex="6" />\r\n				c nulla. Fusce tincidu</label>\r\n				\r\n				<label for="yellow">\r\n				<input id="yellow" type="checkbox" name="checkbox3" value="checkbox" class="f-checkbox" tabindex="7" />\r\n				tincidunt arcu eget </label>\r\n				</fieldset>\r\n				\r\n			</fieldset> \r\n			\r\n			<fieldset class="f-radio-wrap">\r\n		\r\n			<b>Country:</b>\r\n			\r\n				<fieldset>\r\n				\r\n				<label for="australia">\r\n				<input id="australia" type="radio" name="radio" value="Australia" class="f-radio" tabindex="8" />\r\n				Australia</label>\r\n				\r\n				<label for="newzealand">\r\n				<input id="newzealand" type="radio" name="radio" value="New Zealand" class="f-radio" tabindex="9" />\r\n				New Zealand</label>\r\n				\r\n				<label for="antarctica">\r\n				<input id="antarctica" type="radio" name="radio" value="Antarctica" class="f-radio" tabindex="10" />\r\n				Antarctica</label>\r\n	\r\n				</fieldset>\r\n			\r\n			</fieldset>\r\n			\r\n			<label for="comments"><b>Comments:</b>\r\n			<textarea id="comments" name="comments" class="f-comments" rows="6" cols="20" tabindex="11"></textarea><br />\r\n			</label>\r\n			\r\n			<div class="f-submit-wrap">\r\n			<input type="submit" value="Submit" class="f-submit" tabindex="12" /><br />\r\n			</div>\r\n			</fieldset>\r\n			</form>', 1, 23, 20, 1, 1, 1, 1144667732, 1, 1144672821, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` VALUES (51, 'document', 'text/html', 'Mollio typeD', '2 columns - Main + Right Sidebar', '2 columns - Main + Right Sidebar', 'mollio-type-d', 1, 0, 0, 24, 0, '			<h1>Heading 1 Consect etuer adipisci ngon.</h1>\r\n			<h2>Heading 2 Consect etuer adipisci ngon.</h2>\r\n			<h3>Heading 3 Consect etuer adipisci ngon.</h3>\r\n			<h4>Heading 4 Consect etuer adipisci ngon.</h4>\r\n			<h5>Heading 5 Consect etuer adipisci ngon.</h5>\r\n			<h6>Heading 6 Consect etuer adipisci ngon.</h6>\r\n			\r\n			<hr />\r\n			\r\n			<p>A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="highlight">A paragraph of text with class="highlight", A paragraph of text with class="highlight", A paragraph of text with class="highlight", A paragraph of text with class="highlight", A paragraph of text with class="highlight", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="subdued">A paragraph of text with class="subdued", A paragraph of text with class="subdued", A paragraph of text with class="subdued", A paragraph of text with class="subdued", A paragraph of text with class="subdued", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="error">A paragraph of text with class="error", A paragraph of text with class="error", A paragraph of text with class="error", A paragraph of text with class="error", A paragraph of text with class="error", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="success">A paragraph of text with class="success", A paragraph of text with class="success", A paragraph of text with class="success", A paragraph of text with class="success", A paragraph of text with class="success", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="caption">A paragraph of text with class="caption", A paragraph of text with class="caption", A paragraph of text with class="caption", A paragraph of text with class="caption", A paragraph of text with class="caption", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p><small>A paragraph of text with the text with &lt;small&gt; tags, A paragraph of text with the text with &lt;small&gt; tags, A paragraph of text with the text with &lt;small&gt; tags, A paragraph of text with the text with &lt;small&gt; tags, A paragraph of text with the text with &lt;small&gt; tags, </small></p>\r\n			\r\n			<hr />\r\n			\r\n			<p><em>A paragraph of text with the text with &lt;em&gt; tags, A paragraph of text with the text with</em></p>\r\n			\r\n			<hr />\r\n			\r\n			<p><strong>A paragraph of text with the text with &lt;strong&gt; tags, A paragraph of text with the text with &lt;strong&gt; tags, A paragraph of text with the text with &lt;strong&gt; tags, A paragraph of text with the text with &lt;strong&gt; tags, A paragraph of text with the text with &lt;strong&gt; tags, </strong></p>\r\n			\r\n			<hr />\r\n			\r\n			<div class="featurebox"><h3>A h3 level heading inside a "featurebox" div</h3><p>A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox" <a href="devtodo" class="morelink" title="A h3 level heading inside a featurebox div">More <span>about: A h3 level heading inside a featurebox div</span></a></p></div>\r\n			\r\n			<hr />\r\n			\r\n			<div class="featurebox2"><h3>A h3 level heading inside a "featurebox2" div</h3><p>A normal paragraph of text within a div with a class="featurebox2", A normal paragraph of text within a div with a class="featurebox2", A normal paragraph of text within a div with a class="featurebox2", A normal paragraph of text within a div with a class="featurebox2", A normal paragraph of text within a div with a class="featurebox2", A normal paragraph of text within a div with a class="featurebox2" <a href="devtodo" class="morelink" title="A h3 level heading inside a featurebox2 div">More <span>about: A h3 level heading inside a featurebox2 div</span></a></p></div>\r\n			\r\n			<hr />\r\n			\r\n			<ul>\r\n			<li><a href="devtodo">A list of links</a></li>\r\n			<li><a href="devtodo">A list of links</a></li>\r\n			<li><a href="devtodo">A list of links</a></li>\r\n			</ul>\r\n			\r\n			<hr />\r\n			\r\n			<p>A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, </p>\r\n			<ul class="related">\r\n			<li><a href="devtodo">A list of related links</a></li>\r\n			<li><a href="devtodo">A list of related links</a></li>\r\n			<li><a href="devtodo">A list of related links</a></li>\r\n			</ul>\r\n			\r\n			<hr />\r\n			\r\n			<ul>\r\n			<li>An unordered list</li>\r\n			<li>An unordered list</li>\r\n			<li>An unordered list</li>\r\n			</ul>\r\n			\r\n			<hr />\r\n			\r\n			<ol>\r\n			<li>An ordered list</li>\r\n			<li>An ordered list</li>\r\n			<li>An ordered list</li>\r\n			</ol>\r\n			\r\n			<hr />\r\n			\r\n			<dl>\r\n			<dt>A definition list - and this is the dt</dt>\r\n			<dd>A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, </dd>\r\n			<dt>A definition list - and this is the dt</dt>\r\n			<dd>A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, </dd>\r\n			</dl>\r\n			\r\n			<hr />\r\n			\r\n			<h4><span class="date">29 July 2005</span> Headline and associate teaser</h4>\r\n			<p>Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Donec pharetra. <a href="devtodo" class="morelink" title="Headline and associate teaser">More <span>about: Headline and associate teaser</span></a></p>\r\n			<div class="clear">&nbsp;</div>\r\n			\r\n			<h4><span class="date">29 July 2005</span> Headline and associate teaser</h4>\r\n			<p>Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Donec pharetra. <a href="devtodo" class="morelink" title="Headline and associate teaser">More <span>about: Headline and associate teaser</span></a></p>\r\n			<div class="clear">&nbsp;</div>\r\n			\r\n			<hr />\r\n			\r\n			<h4><span class="date">29 July 2005</span> Headline and associate teaser and thumbnail</h4>\r\n			<p><span class="thumbnail"><a href="devtodo"><img src="templates/mollio/images/thumb_100wide.gif" alt="Demo" width="100" height="75" /></a></span>Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Donec pharetra. <a href="devtodo" class="morelink" title="Headline and associate teaser">More <span>about: Headline and associate teaser</span></a></p>\r\n			\r\n			\r\n			<h4><span class="date">29 July 2005</span> Headline and associate teaser and thumbnail</h4>\r\n			<p><span class="thumbnail"><a href="devtodo"><img src="templates/mollio/images/thumb_100wide.gif" alt="Demo" width="100" height="75" /></a></span>Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Donec pharetra. <a href="devtodo" class="morelink" title="Headline and associate teaser">More <span>about: Headline and associate teaser</span></a></p>\r\n			\r\n			\r\n			<hr />\r\n			\r\n			<div class="pagination">\r\n			<p><span><strong>Previous</strong></span> <span>1</span> <a href="devtodo">2</a> <a href="devtodo">3</a> <a href="devtodo">4</a> <a href="devtodo">5</a> <a href="devtodo"><strong>Next</strong></a></p>\r\n			<h4>Page 1 of 5</h4>\r\n			</div>\r\n			\r\n			<hr />\r\n			\r\n			<h1>Search Results</h1>\r\n			\r\n			<div id="resultslist-wrap">\r\n				<ol>\r\n				<li>\r\n					<dl>\r\n					<dt><a href="devtodo">Fringilla tortor. Sed ullamcorper imperdiet metus.</a></dt>\r\n					<dd class="desc">Maecenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris at enim. Ut vestibulum erat at tellus.</dd>\r\n					<dd class="filetype">HTML</dd>\r\n					<dd class="date">22 April 2005</dd>\r\n					</dl>\r\n				</li>\r\n				<li>\r\n					<dl>\r\n					<dt><a href="devtodo">Fringilla tortor. Sed ullamcorper imperdiet metus.</a></dt>\r\n					<dd class="desc">Maecenas nec ante vitae turpis intecenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris rdum placerat. Duis in nisi. Mauris at enim. Ut vestibulum erat at tellus.</dd>\r\n					<dd class="filetype">HTML</dd>\r\n					<dd class="date">22 April 2005</dd>\r\n					</dl>\r\n				</li>\r\n				<li>\r\n					<dl>\r\n					<dt><a href="devtodo">Fringilla tortor. Sed ullamcorper imperdiet metus.</a></dt>\r\n					<dd class="desc">Maecenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris at enim. Ut vestibulum erat at tellus.</dd>\r\n					<dd class="filetype">PDF</dd>\r\n					<dd class="date">22 April 2005</dd>\r\n					</dl>\r\n				</li>\r\n				<li>\r\n					<dl>\r\n					<dt><a href="devtodo">Fringilla tortor. Sed ullamcorper imperdiet metus.</a></dt>\r\n					<dd class="desc">Maecenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris at enim. Ut vestibulum erat at tellus.</dd>\r\n					<dd class="filetype">WORD</dd>\r\n					<dd class="date">22 April 2005</dd>\r\n					</dl>\r\n				</li>\r\n				</ol>\r\n			</div>\r\n			\r\n			<hr />\r\n			\r\n			<table class="table1">\r\n			<thead>\r\n				<tr>\r\n				<th colspan="3">Table Heading</th>\r\n				</tr>\r\n			</thead>\r\n			<tbody>\r\n				<tr>\r\n				<th>Col 1</th>\r\n				<th>Col 2</th>\r\n				<th>Col 3</th>\r\n				</tr>\r\n				<tr>\r\n				<th class="sub">Sub head 1</th>\r\n				<td>209385</td>\r\n				<td>45</td>\r\n				</tr>\r\n				<tr>\r\n				<th class="sub">Sub head 2</th>\r\n				<td>4577</td>\r\n				<td>22</td>\r\n				</tr>\r\n				<tr>\r\n				<th class="sub">Sub head 3</th>\r\n				<td>69765</td>\r\n				<td>75</td>\r\n				</tr>\r\n			</tbody>\r\n			</table>\r\n			\r\n			<hr />\r\n			\r\n			<table class="table1 calendar">\r\n			<thead>\r\n				<tr>\r\n				<th colspan="7">October</th>\r\n				</tr>\r\n			</thead>\r\n			<tbody>\r\n				<tr>\r\n				<th>S</th>\r\n				<th>M</th>\r\n				<th>T</th>\r\n				<th>W</th>\r\n				<th>T</th>\r\n				<th>F</th>\r\n				<th>S</th>\r\n				</tr>\r\n				<tr>\r\n				<td>1</td>\r\n				<td>2</td>\r\n				<td>3</td>\r\n				<td>4</td>\r\n				<td>5</td>\r\n				<td>6</td>\r\n				<td>7</td>\r\n				</tr>\r\n				<tr>\r\n				<td>1</td>\r\n				<td>2</td>\r\n				<td>3</td>\r\n				<td>4</td>\r\n				<td>5</td>\r\n				<td>6</td>\r\n				<td>7</td>\r\n				</tr>\r\n				<tr>\r\n				<td>1</td>\r\n				<td>2</td>\r\n				<td>3</td>\r\n				<td>4</td>\r\n				<td>5</td>\r\n				<td>6</td>\r\n				<td>7</td>\r\n				</tr>\r\n				<tr>\r\n				<td>1</td>\r\n				<td>2</td>\r\n				<td>3</td>\r\n				<td>4</td>\r\n				<td>5</td>\r\n				<td>6</td>\r\n				<td>7</td>\r\n				</tr>\r\n			</tbody>\r\n			</table>\r\n			\r\n			<hr />\r\n			\r\n			<form action="forms.html" method="post" class="f-wrap-1">\r\n			\r\n			<div class="req"><b>*</b> Indicates required field</div>\r\n			\r\n			<fieldset>\r\n			\r\n			<h3>Form title here</h3>\r\n			\r\n			<label for="firstname"><b><span class="req">*</span>First name:</b>\r\n			<input id="firstname" name="firstname" type="text" class="f-name" tabindex="1" /><br />\r\n			</label>\r\n			\r\n			<label for="lastname"><b><span class="req">*</span>Last name:</b>\r\n			<input id="lastname" name="lastname" type="text" class="f-name" tabindex="2" /><br />\r\n			</label>\r\n			\r\n			<label for="emailaddress"><b><span class="req">*</span>Email Address:</b>\r\n			<input id="emailaddress" name="emailaddress" type="text" class="f-email" tabindex="3" /><br />\r\n			</label>\r\n			\r\n			<label for="enquiry"><b>Enquiry Type:</b>\r\n			<select id="enquiry" name="enquiry" tabindex="4">\r\n			<option>Select...</option>\r\n			<option>c nulla. Fusce tincidu</option>\r\n			<option>Maecenas digniss</option>\r\n			<option>tincidunt arcu eget sapien</option>\r\n			</select>\r\n			<br />\r\n			</label>\r\n			\r\n			<fieldset class="f-checkbox-wrap">\r\n			\r\n			<b>Colour:</b>\r\n			\r\n				<fieldset>\r\n				\r\n				<label for="blue">\r\n				<input id="blue" type="checkbox" name="checkbox" value="checkbox" class="f-checkbox" tabindex="5" />\r\n				sit amet, consectetu</label>\r\n				\r\n				<label for="green">\r\n				<input id="green" type="checkbox" name="checkbox2" value="checkbox" class="f-checkbox" tabindex="6" />\r\n				c nulla. Fusce tincidu</label>\r\n				\r\n				<label for="yellow">\r\n				<input id="yellow" type="checkbox" name="checkbox3" value="checkbox" class="f-checkbox" tabindex="7" />\r\n				tincidunt arcu eget </label>\r\n				</fieldset>\r\n				\r\n			</fieldset> \r\n			\r\n			<fieldset class="f-radio-wrap">\r\n		\r\n			<b>Country:</b>\r\n			\r\n				<fieldset>\r\n				\r\n				<label for="australia">\r\n				<input id="australia" type="radio" name="radio" value="Australia" class="f-radio" tabindex="8" />\r\n				Australia</label>\r\n				\r\n				<label for="newzealand">\r\n				<input id="newzealand" type="radio" name="radio" value="New Zealand" class="f-radio" tabindex="9" />\r\n				New Zealand</label>\r\n				\r\n				<label for="antarctica">\r\n				<input id="antarctica" type="radio" name="radio" value="Antarctica" class="f-radio" tabindex="10" />\r\n				Antarctica</label>\r\n	\r\n				</fieldset>\r\n			\r\n			</fieldset>\r\n			\r\n			<label for="comments"><b>Comments:</b>\r\n			<textarea id="comments" name="comments" class="f-comments" rows="6" cols="20" tabindex="11"></textarea><br />\r\n			</label>\r\n			\r\n			<div class="f-submit-wrap">\r\n			<input type="submit" value="Submit" class="f-submit" tabindex="12" /><br />\r\n			</div>\r\n			</fieldset>\r\n			</form>', 1, 24, 40, 1, 1, 1, 1144669004, 1, 1144672871, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` VALUES (52, 'document', 'text/html', 'Mollio typeE', '2 columns - Main + Right hand nav', '2 columns - Main + Right hand nav', 'mollio-type-e', 1, 0, 0, 24, 0, '			<h1>Heading 1 Consect etuer adipisci ngon.</h1>\r\n			<h2>Heading 2 Consect etuer adipisci ngon.</h2>\r\n			<h3>Heading 3 Consect etuer adipisci ngon.</h3>\r\n			<h4>Heading 4 Consect etuer adipisci ngon.</h4>\r\n			<h5>Heading 5 Consect etuer adipisci ngon.</h5>\r\n			<h6>Heading 6 Consect etuer adipisci ngon.</h6>\r\n			\r\n			<hr />\r\n			\r\n			<p>A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="highlight">A paragraph of text with class="highlight", A paragraph of text with class="highlight", A paragraph of text with class="highlight", A paragraph of text with class="highlight", A paragraph of text with class="highlight", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="subdued">A paragraph of text with class="subdued", A paragraph of text with class="subdued", A paragraph of text with class="subdued", A paragraph of text with class="subdued", A paragraph of text with class="subdued", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="error">A paragraph of text with class="error", A paragraph of text with class="error", A paragraph of text with class="error", A paragraph of text with class="error", A paragraph of text with class="error", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="success">A paragraph of text with class="success", A paragraph of text with class="success", A paragraph of text with class="success", A paragraph of text with class="success", A paragraph of text with class="success", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="caption">A paragraph of text with class="caption", A paragraph of text with class="caption", A paragraph of text with class="caption", A paragraph of text with class="caption", A paragraph of text with class="caption", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p><small>A paragraph of text with the text with &lt;small&gt; tags, A paragraph of text with the text with &lt;small&gt; tags, A paragraph of text with the text with &lt;small&gt; tags, A paragraph of text with the text with &lt;small&gt; tags, A paragraph of text with the text with &lt;small&gt; tags, </small></p>\r\n			\r\n			<hr />\r\n			\r\n			<p><em>A paragraph of text with the text with &lt;em&gt; tags, A paragraph of text with the text with</em></p>\r\n			\r\n			<hr />\r\n			\r\n			<p><strong>A paragraph of text with the text with &lt;strong&gt; tags, A paragraph of text with the text with &lt;strong&gt; tags, A paragraph of text with the text with &lt;strong&gt; tags, A paragraph of text with the text with &lt;strong&gt; tags, A paragraph of text with the text with &lt;strong&gt; tags, </strong></p>\r\n			\r\n			<hr />\r\n			\r\n			<div class="featurebox"><h3>A h3 level heading inside a "featurebox" div</h3><p>A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox" <a href="devtodo" class="morelink" title="A h3 level heading inside a featurebox div">More <span>about: A h3 level heading inside a featurebox div</span></a></p></div>\r\n			\r\n			<hr />\r\n			\r\n			<div class="featurebox2"><h3>A h3 level heading inside a "featurebox2" div</h3><p>A normal paragraph of text within a div with a class="featurebox2", A normal paragraph of text within a div with a class="featurebox2", A normal paragraph of text within a div with a class="featurebox2", A normal paragraph of text within a div with a class="featurebox2", A normal paragraph of text within a div with a class="featurebox2", A normal paragraph of text within a div with a class="featurebox2" <a href="devtodo" class="morelink" title="A h3 level heading inside a featurebox2 div">More <span>about: A h3 level heading inside a featurebox2 div</span></a></p></div>\r\n			\r\n			<hr />\r\n			\r\n			<ul>\r\n			<li><a href="devtodo">A list of links</a></li>\r\n			<li><a href="devtodo">A list of links</a></li>\r\n			<li><a href="devtodo">A list of links</a></li>\r\n			</ul>\r\n			\r\n			<hr />\r\n			\r\n			<p>A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, </p>\r\n			<ul class="related">\r\n			<li><a href="devtodo">A list of related links</a></li>\r\n			<li><a href="devtodo">A list of related links</a></li>\r\n			<li><a href="devtodo">A list of related links</a></li>\r\n			</ul>\r\n			\r\n			<hr />\r\n			\r\n			<ul>\r\n			<li>An unordered list</li>\r\n			<li>An unordered list</li>\r\n			<li>An unordered list</li>\r\n			</ul>\r\n			\r\n			<hr />\r\n			\r\n			<ol>\r\n			<li>An ordered list</li>\r\n			<li>An ordered list</li>\r\n			<li>An ordered list</li>\r\n			</ol>\r\n			\r\n			<hr />\r\n			\r\n			<dl>\r\n			<dt>A definition list - and this is the dt</dt>\r\n			<dd>A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, </dd>\r\n			<dt>A definition list - and this is the dt</dt>\r\n			<dd>A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, </dd>\r\n			</dl>\r\n			\r\n			<hr />\r\n			\r\n			<h4><span class="date">29 July 2005</span> Headline and associate teaser</h4>\r\n			<p>Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Donec pharetra. <a href="devtodo" class="morelink" title="Headline and associate teaser">More <span>about: Headline and associate teaser</span></a></p>\r\n			<div class="clear">&nbsp;</div>\r\n			\r\n			<h4><span class="date">29 July 2005</span> Headline and associate teaser</h4>\r\n			<p>Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Donec pharetra. <a href="devtodo" class="morelink" title="Headline and associate teaser">More <span>about: Headline and associate teaser</span></a></p>\r\n			<div class="clear">&nbsp;</div>\r\n			\r\n			<hr />\r\n			\r\n			<h4><span class="date">29 July 2005</span> Headline and associate teaser and thumbnail</h4>\r\n			<p><span class="thumbnail"><a href="devtodo"><img src="templates/mollio/images/thumb_100wide.gif" alt="Demo" width="100" height="75" /></a></span>Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Donec pharetra. <a href="devtodo" class="morelink" title="Headline and associate teaser">More <span>about: Headline and associate teaser</span></a></p>\r\n			\r\n			\r\n			<h4><span class="date">29 July 2005</span> Headline and associate teaser and thumbnail</h4>\r\n			<p><span class="thumbnail"><a href="devtodo"><img src="templates/mollio/images/thumb_100wide.gif" alt="Demo" width="100" height="75" /></a></span>Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Donec pharetra. <a href="devtodo" class="morelink" title="Headline and associate teaser">More <span>about: Headline and associate teaser</span></a></p>\r\n			\r\n			\r\n			<hr />\r\n			\r\n			<div class="pagination">\r\n			<p><span><strong>Previous</strong></span> <span>1</span> <a href="devtodo">2</a> <a href="devtodo">3</a> <a href="devtodo">4</a> <a href="devtodo">5</a> <a href="devtodo"><strong>Next</strong></a></p>\r\n			<h4>Page 1 of 5</h4>\r\n			</div>\r\n			\r\n			<hr />\r\n			\r\n			<h1>Search Results</h1>\r\n			\r\n			<div id="resultslist-wrap">\r\n				<ol>\r\n				<li>\r\n					<dl>\r\n					<dt><a href="devtodo">Fringilla tortor. Sed ullamcorper imperdiet metus.</a></dt>\r\n					<dd class="desc">Maecenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris at enim. Ut vestibulum erat at tellus.</dd>\r\n					<dd class="filetype">HTML</dd>\r\n					<dd class="date">22 April 2005</dd>\r\n					</dl>\r\n				</li>\r\n				<li>\r\n					<dl>\r\n					<dt><a href="devtodo">Fringilla tortor. Sed ullamcorper imperdiet metus.</a></dt>\r\n					<dd class="desc">Maecenas nec ante vitae turpis intecenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris rdum placerat. Duis in nisi. Mauris at enim. Ut vestibulum erat at tellus.</dd>\r\n					<dd class="filetype">HTML</dd>\r\n					<dd class="date">22 April 2005</dd>\r\n					</dl>\r\n				</li>\r\n				<li>\r\n					<dl>\r\n					<dt><a href="devtodo">Fringilla tortor. Sed ullamcorper imperdiet metus.</a></dt>\r\n					<dd class="desc">Maecenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris at enim. Ut vestibulum erat at tellus.</dd>\r\n					<dd class="filetype">PDF</dd>\r\n					<dd class="date">22 April 2005</dd>\r\n					</dl>\r\n				</li>\r\n				<li>\r\n					<dl>\r\n					<dt><a href="devtodo">Fringilla tortor. Sed ullamcorper imperdiet metus.</a></dt>\r\n					<dd class="desc">Maecenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris at enim. Ut vestibulum erat at tellus.</dd>\r\n					<dd class="filetype">WORD</dd>\r\n					<dd class="date">22 April 2005</dd>\r\n					</dl>\r\n				</li>\r\n				</ol>\r\n			</div>\r\n			\r\n			<hr />\r\n			\r\n			<table class="table1">\r\n			<thead>\r\n				<tr>\r\n				<th colspan="3">Table Heading</th>\r\n				</tr>\r\n			</thead>\r\n			<tbody>\r\n				<tr>\r\n				<th>Col 1</th>\r\n				<th>Col 2</th>\r\n				<th>Col 3</th>\r\n				</tr>\r\n				<tr>\r\n				<th class="sub">Sub head 1</th>\r\n				<td>209385</td>\r\n				<td>45</td>\r\n				</tr>\r\n				<tr>\r\n				<th class="sub">Sub head 2</th>\r\n				<td>4577</td>\r\n				<td>22</td>\r\n				</tr>\r\n				<tr>\r\n				<th class="sub">Sub head 3</th>\r\n				<td>69765</td>\r\n				<td>75</td>\r\n				</tr>\r\n			</tbody>\r\n			</table>\r\n			\r\n			<hr />\r\n			\r\n			<table class="table1 calendar">\r\n			<thead>\r\n				<tr>\r\n				<th colspan="7">October</th>\r\n				</tr>\r\n			</thead>\r\n			<tbody>\r\n				<tr>\r\n				<th>S</th>\r\n				<th>M</th>\r\n				<th>T</th>\r\n				<th>W</th>\r\n				<th>T</th>\r\n				<th>F</th>\r\n				<th>S</th>\r\n				</tr>\r\n				<tr>\r\n				<td>1</td>\r\n				<td>2</td>\r\n				<td>3</td>\r\n				<td>4</td>\r\n				<td>5</td>\r\n				<td>6</td>\r\n				<td>7</td>\r\n				</tr>\r\n				<tr>\r\n				<td>1</td>\r\n				<td>2</td>\r\n				<td>3</td>\r\n				<td>4</td>\r\n				<td>5</td>\r\n				<td>6</td>\r\n				<td>7</td>\r\n				</tr>\r\n				<tr>\r\n				<td>1</td>\r\n				<td>2</td>\r\n				<td>3</td>\r\n				<td>4</td>\r\n				<td>5</td>\r\n				<td>6</td>\r\n				<td>7</td>\r\n				</tr>\r\n				<tr>\r\n				<td>1</td>\r\n				<td>2</td>\r\n				<td>3</td>\r\n				<td>4</td>\r\n				<td>5</td>\r\n				<td>6</td>\r\n				<td>7</td>\r\n				</tr>\r\n			</tbody>\r\n			</table>\r\n			\r\n			<hr />\r\n			\r\n			<form action="forms.html" method="post" class="f-wrap-1">\r\n			\r\n			<div class="req"><b>*</b> Indicates required field</div>\r\n			\r\n			<fieldset>\r\n			\r\n			<h3>Form title here</h3>\r\n			\r\n			<label for="firstname"><b><span class="req">*</span>First name:</b>\r\n			<input id="firstname" name="firstname" type="text" class="f-name" tabindex="1" /><br />\r\n			</label>\r\n			\r\n			<label for="lastname"><b><span class="req">*</span>Last name:</b>\r\n			<input id="lastname" name="lastname" type="text" class="f-name" tabindex="2" /><br />\r\n			</label>\r\n			\r\n			<label for="emailaddress"><b><span class="req">*</span>Email Address:</b>\r\n			<input id="emailaddress" name="emailaddress" type="text" class="f-email" tabindex="3" /><br />\r\n			</label>\r\n			\r\n			<label for="enquiry"><b>Enquiry Type:</b>\r\n			<select id="enquiry" name="enquiry" tabindex="4">\r\n			<option>Select...</option>\r\n			<option>c nulla. Fusce tincidu</option>\r\n			<option>Maecenas digniss</option>\r\n			<option>tincidunt arcu eget sapien</option>\r\n			</select>\r\n			<br />\r\n			</label>\r\n			\r\n			<fieldset class="f-checkbox-wrap">\r\n			\r\n			<b>Colour:</b>\r\n			\r\n				<fieldset>\r\n				\r\n				<label for="blue">\r\n				<input id="blue" type="checkbox" name="checkbox" value="checkbox" class="f-checkbox" tabindex="5" />\r\n				sit amet, consectetu</label>\r\n				\r\n				<label for="green">\r\n				<input id="green" type="checkbox" name="checkbox2" value="checkbox" class="f-checkbox" tabindex="6" />\r\n				c nulla. Fusce tincidu</label>\r\n				\r\n				<label for="yellow">\r\n				<input id="yellow" type="checkbox" name="checkbox3" value="checkbox" class="f-checkbox" tabindex="7" />\r\n				tincidunt arcu eget </label>\r\n				</fieldset>\r\n				\r\n			</fieldset> \r\n			\r\n			<fieldset class="f-radio-wrap">\r\n		\r\n			<b>Country:</b>\r\n			\r\n				<fieldset>\r\n				\r\n				<label for="australia">\r\n				<input id="australia" type="radio" name="radio" value="Australia" class="f-radio" tabindex="8" />\r\n				Australia</label>\r\n				\r\n				<label for="newzealand">\r\n				<input id="newzealand" type="radio" name="radio" value="New Zealand" class="f-radio" tabindex="9" />\r\n				New Zealand</label>\r\n				\r\n				<label for="antarctica">\r\n				<input id="antarctica" type="radio" name="radio" value="Antarctica" class="f-radio" tabindex="10" />\r\n				Antarctica</label>\r\n	\r\n				</fieldset>\r\n			\r\n			</fieldset>\r\n			\r\n			<label for="comments"><b>Comments:</b>\r\n			<textarea id="comments" name="comments" class="f-comments" rows="6" cols="20" tabindex="11"></textarea><br />\r\n			</label>\r\n			\r\n			<div class="f-submit-wrap">\r\n			<input type="submit" value="Submit" class="f-submit" tabindex="12" /><br />\r\n			</div>\r\n			</fieldset>\r\n			</form>', 1, 25, 50, 1, 1, 1, 1144669782, 1, 1144672890, 0, 0, 0, 0, 1);

INSERT INTO `{PREFIX}site_content` VALUES (53, 'document', 'text/html', 'Mollio typeF', '3 columns - Main + Right hand nav + Left Sidebar', '3 columns - Main + Right hand nav + Left Sidebar', 'mollio-type-f', 1, 0, 0, 24, 0, '			<h1>Heading 1 Consect etuer adipisci ngon.</h1>\r\n			<h2>Heading 2 Consect etuer adipisci ngon.</h2>\r\n			<h3>Heading 3 Consect etuer adipisci ngon.</h3>\r\n			<h4>Heading 4 Consect etuer adipisci ngon.</h4>\r\n			<h5>Heading 5 Consect etuer adipisci ngon.</h5>\r\n			<h6>Heading 6 Consect etuer adipisci ngon.</h6>\r\n\r\n			<hr />\r\n			\r\n			<p>A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="highlight">A paragraph of text with class="highlight", A paragraph of text with class="highlight", A paragraph of text with class="highlight", A paragraph of text with class="highlight", A paragraph of text with class="highlight", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="subdued">A paragraph of text with class="subdued", A paragraph of text with class="subdued", A paragraph of text with class="subdued", A paragraph of text with class="subdued", A paragraph of text with class="subdued", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="error">A paragraph of text with class="error", A paragraph of text with class="error", A paragraph of text with class="error", A paragraph of text with class="error", A paragraph of text with class="error", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="success">A paragraph of text with class="success", A paragraph of text with class="success", A paragraph of text with class="success", A paragraph of text with class="success", A paragraph of text with class="success", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p class="caption">A paragraph of text with class="caption", A paragraph of text with class="caption", A paragraph of text with class="caption", A paragraph of text with class="caption", A paragraph of text with class="caption", </p>\r\n			\r\n			<hr />\r\n			\r\n			<p><small>A paragraph of text with the text with &lt;small&gt; tags, A paragraph of text with the text with &lt;small&gt; tags, A paragraph of text with the text with &lt;small&gt; tags, A paragraph of text with the text with &lt;small&gt; tags, A paragraph of text with the text with &lt;small&gt; tags, </small></p>\r\n			\r\n			<hr />\r\n\r\n			\r\n			<p><strong>A paragraph of text with the text with &lt;strong&gt; tags, A paragraph of text with the text with &lt;strong&gt; tags, A paragraph of text with the text with &lt;strong&gt; tags, A paragraph of text with the text with &lt;strong&gt; tags, A paragraph of text with the text with &lt;strong&gt; tags, </strong></p>\r\n			\r\n			<hr />\r\n			\r\n			<div class="featurebox"><h3>A h3 level heading inside a "featurebox" div</h3><p>A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox", A normal paragraph of text within a div with a class="featurebox" <a href="devtodo" class="morelink" title="A h3 level heading inside a featurebox div">More <span>about: A h3 level heading inside a featurebox div</span></a></p></div>\r\n			\r\n			<hr />\r\n			\r\n			<ul>\r\n			<li><a href="devtodo">A list of links</a></li>\r\n			<li><a href="devtodo">A list of links</a></li>\r\n			<li><a href="devtodo">A list of links</a></li>\r\n			</ul>\r\n			\r\n			<hr />\r\n			\r\n			<p>A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, A normal paragraph of text, </p>\r\n			<ul class="related">\r\n			<li><a href="devtodo">A list of related links</a></li>\r\n			<li><a href="devtodo">A list of related links</a></li>\r\n			<li><a href="devtodo">A list of related links</a></li>\r\n			</ul>\r\n			\r\n			<hr />\r\n			\r\n			<ul>\r\n			<li>An unordered list</li>\r\n			<li>An unordered list</li>\r\n			<li>An unordered list</li>\r\n			</ul>\r\n			\r\n			<hr />\r\n			\r\n			<ol>\r\n			<li>An ordered list</li>\r\n			<li>An ordered list</li>\r\n			<li>An ordered list</li>\r\n			</ol>\r\n			\r\n			<hr />\r\n			\r\n			<dl>\r\n			<dt>A definition list - and this is the dt</dt>\r\n			<dd>A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, </dd>\r\n			<dt>A definition list - and this is the dt</dt>\r\n			<dd>A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, A definition list - and this is the dd, </dd>\r\n			</dl>\r\n			\r\n			<hr />\r\n			\r\n			<h4><span class="date">29 July 2005</span> Headline and associate teaser</h4>\r\n			<p>Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Donec pharetra. <a href="devtodo" class="morelink" title="Headline and associate teaser">More <span>about: Headline and associate teaser</span></a></p>\r\n			\r\n			<h4><span class="date">29 July 2005</span> Headline and associate teaser</h4>\r\n			<p>Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Donec pharetra. <a href="devtodo" class="morelink" title="Headline and associate teaser">More <span>about: Headline and associate teaser</span></a></p>\r\n			\r\n			<hr />\r\n			\r\n			<h4><span class="date">29 July 2005</span> Headline and associate teaser and thumbnail</h4>\r\n			<p><span class="thumbnail"><a href="devtodo"><img src="templates/mollio/images/thumb_100wide.gif" alt="Demo" width="100" height="75" /></a></span>Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Donec pharetra. <a href="devtodo" class="morelink" title="Headline and associate teaser">More <span>about: Headline and associate teaser</span></a></p>\r\n			\r\n			<hr />\r\n			\r\n			<h4><span class="date">29 July 2005</span> Headline and associate teaser and thumbnail</h4>\r\n			<p><span class="thumbnail"><a href="devtodo"><img src="templates/mollio/images/thumb_100wide.gif" alt="Demo" width="100" height="75" /></a></span>Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Lorem ipsum dolor sit amsum dolor sit amet, consectetet, consectetuer adipiscing elit. Donec pharetra. <a href="devtodo" class="morelink" title="Headline and associate teaser">More <span>about: Headline and associate teaser</span></a></p>\r\n			\r\n			<hr />\r\n			\r\n			<div class="pagination">\r\n			<p><span><strong>Previous</strong></span> <span>1</span> <a href="devtodo">2</a> <a href="devtodo">3</a> <a href="devtodo">4</a> <a href="devtodo">5</a> <a href="devtodo"><strong>Next</strong></a></p>\r\n			<h4>Page 1 of 5</h4>\r\n			</div>\r\n			\r\n			<hr />\r\n			\r\n			<h1>Search Results</h1>\r\n			\r\n			<div id="resultslist-wrap">\r\n				<ol>\r\n				<li>\r\n					<dl>\r\n					<dt><a href="devtodo">Fringilla tortor. Sed ullamcorper imperdiet metus.</a></dt>\r\n					<dd class="desc">Maecenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris at enim. Ut vestibulum erat at tellus.</dd>\r\n					<dd class="filetype">HTML</dd>\r\n					<dd class="date">22 April 2005</dd>\r\n					</dl>\r\n				</li>\r\n				<li>\r\n					<dl>\r\n					<dt><a href="devtodo">Fringilla tortor. Sed ullamcorper imperdiet metus.</a></dt>\r\n					<dd class="desc">Maecenas nec ante vitae turpis intecenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris rdum placerat. Duis in nisi. Mauris at enim. Ut vestibulum erat at tellus.</dd>\r\n					<dd class="filetype">HTML</dd>\r\n					<dd class="date">22 April 2005</dd>\r\n					</dl>\r\n				</li>\r\n				<li>\r\n					<dl>\r\n					<dt><a href="devtodo">Fringilla tortor. Sed ullamcorper imperdiet metus.</a></dt>\r\n					<dd class="desc">Maecenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris at enim. Ut vestibulum erat at tellus.</dd>\r\n					<dd class="filetype">PDF</dd>\r\n					<dd class="date">22 April 2005</dd>\r\n					</dl>\r\n				</li>\r\n				<li>\r\n					<dl>\r\n					<dt><a href="devtodo">Fringilla tortor. Sed ullamcorper imperdiet metus.</a></dt>\r\n					<dd class="desc">Maecenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris cenas nec ante vitae turpis interdum placerat. Duis in nisi. Mauris at enim. Ut vestibulum erat at tellus.</dd>\r\n					<dd class="filetype">WORD</dd>\r\n					<dd class="date">22 April 2005</dd>\r\n					</dl>\r\n				</li>\r\n				</ol>\r\n			</div>', 1, 26, 60, 1, 1, 1, 1144670222, 1, 1144672916, 0, 0, 0, 0, 1);

CREATE TABLE `{PREFIX}site_htmlsnippets` (
  `id` int(10) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `description` varchar(255) NOT NULL default 'Chunk',
  `snippet` mediumtext NOT NULL,
  `locked` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM COMMENT='Contains the site''s chunks.' ;

INSERT INTO `{PREFIX}site_htmlsnippets` VALUES (1, 'greens.css', 'Stylesheet for Greens template', 'body {\r\n  background-color : #003300;\r\n  color : #000066;\r\n  margin-top : 8px;\r\n  font-family : sans-serif;\r\n  font-size: 12px;\r\n  margin : 4px 0 0 0;\r\n  background : url(templates/greens/images/abtra19.jpg);\r\n}\r\n\r\na:link    { color: Green; text-decoration: underline }\r\n\r\na:visited  { color: #6633FF; text-decoration: underline }\r\n\r\na:active  { color: Green; text-decoration: underline }\r\n\r\na:hover    { color: #FF6600; text-decoration: underline }\r\n\r\n.divider {\r\n  border-left : 2px dotted Green;\r\n}\r\n\r\n.border {\r\n  border : 1px solid #006600;\r\n}\r\n.copy_white {\r\n  font-family: Geneva, Arial, Helvetica, sans-serif;\r\n  font-size: 12px;\r\n  color: #FFFFFF;\r\n}\r\n.content {\r\n  font-family: Geneva, Arial, Helvetica, sans-serif;\r\n  font-size: 12px;\r\n  color: #000066;\r\n}\r\n\r\n.etomite {\r\n  font-family: Geneva, Arial, Helvetica, sans-serif;\r\n  font-size: 10px;\r\n  color: #FFFFFF;\r\n  margin-left : 15px;\r\n}\r\n\r\n.footer {\r\n  font-family: Geneva, Arial, Helvetica, sans-serif;\r\n  font-size: 12px;\r\n  padding : 3px;\r\n  background:url(templates/greens/images/bkg_greenbar.gif) #C5E157;\r\n}\r\n\r\n\r\nfieldset {\r\n  position:relative;margin: 0px;\r\n  padding:5px;\r\n  border: 1px solid Navy;\r\n}\r\n\r\nlegend {\r\n  padding:2px;\r\n  color : #000080;\r\n  font-weight : bold;\r\n}\r\n\r\n.searchbox {\r\n  background-color: #ffffff;\r\n  color: #000000;\r\n  border: 2px dotted;\r\n}\r\n\r\n.searchbox p {\r\n  margin:0;\r\n  padding:0;\r\n}\r\n\r\nH1 {\r\n  font-family: Geneva, Arial, Helvetica, sans-serif;\r\n  font-size: 22px;\r\n  color: #006633;\r\n  margin-bottom : 3px;\r\n}\r\nH2 {\r\n  font-family: Geneva, Arial, Helvetica, sans-serif;\r\n  font-size: 20px;\r\n  color: #FF6600;\r\n}\r\nH3 {\r\n  font-family: Geneva, Arial, Helvetica, sans-serif;\r\n  font-size: 18px;\r\n  color: Green;\r\n}\r\nH4 {\r\n  font-family: Geneva, Arial, Helvetica, sans-serif;\r\n  font-size: 16px;\r\n  color: #000080;\r\n}\r\n\r\n.navtitle {\r\n  font-family: Verdana, Arial, Helvetica, sans-serif;\r\n  font-size: 12px;\r\n  font-weight: bold;\r\n  background-color: #003300;\r\n  padding : 3px;\r\n  background : url(templates/greens/images/bkg_greenbar.gif);\r\n  width:100%;\r\n}\r\n\r\n.pagetrail {\r\n  font-family: Geneva, Arial, Helvetica, sans-serif;\r\n  font-size: 10px;\r\n  padding : 3px;\r\n}\r\n\r\ndiv#pullquote {float: right; width: 33%; text-align: left;\r\n   font-size: 12px; font-weight: normal; font-family: sans-serif;\r\n   padding: 1em; background: #ffffdd;\r\n   color: #330099; border: 1px solid #228B22; word-spacing: 0.1em;\r\n   border-width: 1px 1px 1px 1px; margin: 0.4em 0.2em 0.2em 0.4em;}\r\n\r\n.slogan {\r\n  font-family: Verdana, Arial, Helvetica, sans-serif;\r\n  font-size: 18px;\r\n  font-style: italic;\r\n  font-weight: bold;\r\n  color: White;\r\n}\r\n\r\nli {\r\n  list-style : url(templates/greens/images/bullet_green_diamond.gif);\r\n  list-style : outside;\r\n  padding : 2px;\r\n}\r\n\r\n.navigation { \r\n  padding: 0px;\r\n  margin: 0px;\r\n  width:100%;\r\n  height: 100%; \r\n  border: none;\r\n  background: transparent;\r\n}\r\n\r\n.navigation a,.navigation a:hover {\r\n  padding: 4px;\r\n  margin: 6px;\r\n  margin-bottom: 2px;\r\n  margin-top: 2px;\r\n  display: block;\r\n  color: #000000;\r\n  border: 1px solid #FFFFFF;\r\n  background: #91d191;\r\n  text-decoration: none;\r\n}\r\n\r\n.navigation a:hover {\r\n  padding: 4px;\r\n  text-decoration: none; \r\n  color: #821517;\r\n  background: #f8d888;\r\n  border: 1px solid #FFFFFF;\r\n}\r\n\r\n.searchbox text {\r\n  background-color: #666699;\r\n  color: #ffffff;\r\n}\r\n.etoNotice {display:none;}\r\n.text {}', 0);

INSERT INTO `{PREFIX}site_htmlsnippets` VALUES (2, 'lm.css', 'Stylesheet settings for ListMenu Snippet', '/* lm.css -- Stylesheet settings for ListMenu Snippet\r\n// STYLES used\r\n//\r\n// #LM_level_N      menu level where N is the number of the depth\r\n//                  starting at 0\r\n// #LM_youAreHere   menu item of current location\r\n// .LM_expanded     expanded menu item with children\r\n// .LM_collapsed    menu item with childen, but not expanded\r\n// .LM_endPage      menu item with children\r\n// .LM_description  menu item description\r\n// \r\n*/\r\n\r\n/* ListMenu Styles */\r\n\r\n#listMenuWrapper {\r\nposition:relative;margin:0;padding:0;\r\nfont-size:1em;\r\ncolor:#000066;\r\n}\r\n\r\n#listMenuWrapper ul {\r\nposition:relative;margin:0;padding:0;\r\n}\r\n\r\n#listMenuWrapper ul li {\r\nposition:relative;margin:2px 0px;padding:0 0 0 0;\r\nlist-style:none;\r\n}\r\n\r\n#listMenuWrapper a, #listMenuWrapper #LM_youAreHere {\r\ndisplay:block;\r\nposition:relative;margin:0;padding:2px 0 2px 15px;\r\ntext-decoration:none;\r\n}\r\n\r\n#listMenuWrapper .snippetName a {position:relative;margin:0;padding:0;display:inline;}\r\n\r\n.LM_collapsed a {}\r\n.LM_collapsed a:hover {}\r\n\r\n.LM_expanded a {}\r\n.LM_expanded a:hover {color:#ff9933;}\r\n.LM_expanded #LM_youAreHere {background-color:#ffffff; border:1px solid #c0c0c0;}\r\n\r\n.LM_endPage a {}\r\n.LM_endPage a:hover {}\r\n.LM_endPage #LM_youAreHere {background-color:#ffffff; border:1px solid #c0c0c0;}\r\n\r\n#LM_level_1 li a, #LM_level_1 li #LM_youAreHere {padding-left:8px;}\r\n#LM_level_2 li a, #LM_level_2 li #LM_youAreHere {padding-left:16px;}\r\n#LM_level_3 li a, #LM_level_3 li #LM_youAreHere {padding-left:24px;}\r\n#LM_level_4 li a, #LM_level_4 li #LM_youAreHere {padding-left:32px;}\r\n', 0);

INSERT INTO `{PREFIX}site_htmlsnippets` VALUES (4, 'AlexisProRedux.css', 'Stylesheet for AlexisProRedux template', 'body {\r\n  text-align: center;\r\n  background-color: #FFFFFF;\r\n  color: #000000;\r\n  font-family: Verdana, Arial, Helvetica, sans-serif; \r\n}\r\n\r\n.w22 {\r\n  width: 22%;\r\n}\r\n\r\n.mainTable { \r\n  border-top: 1px solid #003399;\r\n  border-left: 1px solid #003399;\r\n  border-right: 1px solid #003399;\r\n  width: 740px;\r\n  background: #fff url(images/section.jpg) no-repeat top right ;\r\n  margin: 0px auto;\r\n  text-align: left;\r\n}\r\n\r\n.mainTable tr td { \r\n  padding: 4px;\r\n}\r\n\r\nbody,td,th {\r\n  /* font-family: Verdana, Arial, Helvetica, sans-serif; */\r\n  font-size: 11px;\r\n  color: #000;\r\n}\r\n\r\na,a:hover { \r\n  text-decoration: underline;\r\n}\r\n\r\na { \r\n  color: #821517; \r\n  text-decoration: none;\r\n}\r\n\r\na:hover {\r\n  color: #821517; \r\n  text-decoration: underline;\r\n}\r\n\r\n.navigation { \r\n  padding: 0px;\r\n  margin:	0px;\r\n  height: 100%; \r\n  border:	1px solid #003399;\r\n  background: #fff url(images/section.jpg) no-repeat top right;\r\n}\r\n\r\n.navigation a,.navigation a:hover {\r\n  padding: 4px;\r\n  margin: 6px;\r\n  margin-bottom: 2px;\r\n  margin-top: 2px;\r\n  display: block;\r\n  color: #000000;\r\n  border: 1px solid #FFFFFF;\r\n  background: #fff url(images/section.jpg) no-repeat top right;\r\n}\r\n\r\n.navigation a:hover {\r\n  padding: 4px;\r\n  text-decoration: none; \r\n  color: #821517;\r\n  background: #fff url(images/buttonbar.gif) repeat-x top ;\r\n  border: 1px solid #003399;\r\n}\r\n\r\n.headers {\r\n  font-size: 12px;\r\n  font-weight: bold;\r\n}\r\n\r\n.headers a, .headers a:hover { \r\n  color: #000000;\r\n  text-decoration: none;\r\n}\r\n\r\n.highLight { \r\n  background: #fff url(images/buttonbar.gif) repeat-x top ;\r\n  font-weight: bold;\r\n  border: solid 1px #000000; \r\n}\r\n\r\n.fancyRow {\r\n  background: #fff url(images/buttonbar_gs.gif) repeat-x top;\r\n}\r\n\r\n.fancyRow2 {\r\n  background: #fff url(images/buttonbar.gif) repeat-x top;\r\n}\r\n\r\nbody {\r\n  background: #fff url(images/treeback.jpg) repeat-x top;\r\n}\r\n\r\n.border-top-bottom {\r\n  border-top: 1px solid #003399;\r\n  border-bottom: 1px solid #003399;\r\n}\r\n\r\n.navigationHead {\r\n  text-align:	center;\r\n  font-weight: bold;\r\n  border-top:	1px solid #003399;\r\n  border-left: 1px solid #003399;\r\n  border-right: 1px solid #003399;\r\n}\r\n\r\n.smallText {\r\n  font-size: 9px;\r\n}\r\n\r\n.text { \r\n  width: 154px; \r\n}\r\n\r\nimg { \r\n  border: 0px;\r\n}\r\n\r\nli {\r\n  padding: 0px;\r\n  margin: 6px 0px 0px 15px;\r\n  list-style: disc outside url(images/li.gif);\r\n}\r\n\r\nul {\r\n  margin: 0px 0px 0px 20px;\r\n}\r\n\r\n.silent { \r\n  color: #000000; \r\n  text-decoration: none; \r\n}\r\n\r\n.silent:hover { \r\n  color: #000000 !important; \r\n  text-decoration: none !important; \r\n}\r\n\r\n.logoBox {\r\n  padding: 4px;\r\n  margin: 4px;\r\n  border:	1px solid #003399;\r\n  background: #fff url(images/section.jpg) no-repeat top right;\r\n}\r\n\r\nfieldset { \r\n  padding: 5px; \r\n}\r\n\r\nlegend {  \r\n  font-weight: bold\r\n}\r\n\r\nlegend a,legend a:hover { \r\n  display: block; \r\n  text-decoration: none;\r\n}\r\n\r\n.u { \r\n  text-decoration: underline;\r\n}\r\n\r\n.strike {\r\n  text-decoration:line-through;\r\n}\r\n\r\n.content { \r\n  width: 84%; \r\n  height: 206px;\r\n}\r\n\r\n.mono {\r\n  font-family:"Courier New", Courier, mono, sans-serif;\r\n}\r\n\r\n/* FORM ELEMENTS */\r\n\r\n.textbox, .textarea {\r\n}\r\n\r\ntd.basic {background-color: #FFFFFF; vertical-align:top;} \r\n\r\n.fauxbutton {\r\n  font: 11px Verdana, Tahoma, Arial, Trebuchet MS, Sans-Serif, Georgia, Courier, Times New Roman, Serif;\r\n  border: 1px solid #003399;\r\n  background-color: #F7CC76;\r\n  padding: 2px;\r\n  color: #000000;\r\n}\r\n\r\n.boldtext {font-weight: bold;}\r\n\r\nh1 {\r\n  font-size: 13px;\r\n  color: #003399;\r\n  margin-left: 0px;\r\n  margin-top: 0px;\r\n  margin-right: 0px;\r\n  margin-bottom: 6px;\r\n}\r\n\r\n.boldtitle {\r\n  font-size: 12px;\r\n  font-weight: bold;\r\n  color: #003399;\r\n  margin-left: 0px;\r\n  margin-top: 4px;\r\n  margin-right: 0px;\r\n  margin-bottom: 4px;\r\n}\r\n\r\np.notop {\r\nmargin-top: 0px;\r\n}\r\n\r\nacronym { cursor: hand; border-bottom: dashed 1px #000000; }\r\n\r\n#countdown1 {\r\nfont-weight: bold;\r\nfont-size: 16px;\r\n}', 0);

INSERT INTO `{PREFIX}site_htmlsnippets` VALUES (5, 'new-E.css', 'Stylesheet for new-E template', '/* CSS Document \r\n   Etomite new-E template styles\r\n   2005.08.04\r\n   jaredc\r\n*/\r\n\r\nbody {\r\nmargin:0;padding:0;\r\nbackground:url("images/vertStripes.jpg") repeat-y 50% 0 #C30;\r\nfont-family:Arial, Helvetica, sans-serif;\r\ncolor:#333;\r\n}\r\n#bodyLiner {\r\nposition:relative;margin:0 auto;padding:0;\r\nwidth:760px;\r\n}\r\n\r\na {color:#06C;text-decoration:none;}\r\na:hover {color:#C30;text-decoration:underline;}\r\n\r\n#neweMasthead {\r\nposition:relative;margin:0;padding:0;\r\nborder-bottom:1px solid #06C;\r\nbackground:url("images/mastheadFade.jpg") repeat-x #09F;\r\nheight:140px;\r\n}\r\n#neweMasthead #templateLogo {\r\nfloat:right;\r\nborder-left:1px solid #06C;\r\n}\r\n#neweMasthead h1 {\r\nposition:relative;margin:0 210px 0 20px;padding:70px 0 0 0; \r\ncolor:#FFF;\r\nfont-size:160%;\r\nborder:none;\r\n}\r\n#neweMasthead p{\r\nposition:relative;margin:0 210px 0 20px;padding:0; \r\ncolor:#FFF;\r\nfont-size:90%;\r\n}\r\n\r\n/* ******* */\r\n/* CONTENT */\r\n/* ******* */\r\n#neweContent {\r\nposition:relative;margin:0;padding:20px 0 0 0;\r\n}\r\n#neweContent #neweMainCol {\r\nposition:relative;margin:0;padding:0;\r\nfloat:left;\r\nwidth:559px;\r\n}\r\nh1,h2,h3,h4,h5,h6 {color:#999;font-family:georgia,serif;border-bottom:1px dotted #EEE;}\r\n#neweMainCol p, #neweMainCol ul, #neweMainCol ol {font-size:80%;line-height:140%;}\r\n#neweMainCol ul ul, #neweMainCol ol ul, #neweMainCol ul ol, #neweMainCol ol ol{font-size:100%}\r\n#neweMainColLiner {\r\nposition:relative;margin:0;padding:0 20px;\r\n}\r\n\r\n/* ****** */\r\n/* SIDE   */\r\n/* ****** */\r\n#neweContent #neweSideCol {\r\nposition:relative;margin:0 0 0 560px;\r\n}\r\n#neweSideCol .sideTitle {\r\nposition:relative;margin:0 0 .5em 0;padding:2px 10px;\r\nbackground:#FFF;\r\nfont-size:100%;\r\nfont-style:italic;\r\ncolor:#C30;\r\nfont-weight:bold;\r\n}\r\n\r\n\r\n/* ****** */\r\n/* FOOTER */\r\n/* ****** */\r\n\r\n#neweFooter {\r\nposition:relative;margin:20px 221px 20px 20px;padding:.5em 0;\r\nclear:both;\r\nborder-top:1px dotted #CCC;\r\n}\r\n#neweFooter p{\r\nposition:relative;margin:0;padding:0 0 .5em 0;\r\nfont-size:70%;\r\n}\r\n\r\n\r\n/* SNIPPETS */\r\n\r\nul#LM_level_1 {\r\nmargin:0;padding:0 0 0 20px;\r\nfont-size:80%;\r\n}\r\nul#LM_level_1 ul{\r\nmargin:0;padding:0 0 0 10px;\r\nfont-size:100%;\r\n}\r\nul#LM_level_1 li {\r\nmargin:0;padding:0;\r\nlist-style-image:url("images/bulletBlue.gif");\r\n}\r\n\r\n\r\n#neweTrail {\r\nposition:relative;margin:0;padding:.2em 20px;\r\nfont-size:70%;\r\ncolor:#CCC;\r\n}\r\n#neweTrail a {color:#999;text-decoration:underline;}\r\n#neweTrail a:hover {color:#333;}\r\n\r\n#etoNotice {display:none;}', 0);

INSERT INTO `{PREFIX}site_htmlsnippets` VALUES (6, 'RelatedInfoMollio', '[TEMPLATES] Sidebar information for Mollio templates', '{{MollioEtomite}}\r\n{{MollioTemplates}}', 0);

INSERT INTO `{PREFIX}site_htmlsnippets` VALUES (7, 'MollioEtomite', '[TEMPLATE] Mollio for Etomite sidebar', '			<div class="featurebox">\r\n			<h3>Mollio for Etomite</h3>\r\n			<p><strong>Mollio is a simple set of xhtml/css \r\n			templates.</strong> They were produced by Pete \r\n			Ottery of Daemon Pty Ltd in Sydney, Australia and\r\n			converted for use with Etomite CMS by Lloyd Borrett.</p>\r\n			</div>', 0);

INSERT INTO `{PREFIX}site_htmlsnippets` VALUES (8, 'MollioTemplates', '[TEMPLATE] Mollio Template sidebar', '			<div class="featurebox">\r\n			<h3>Mollio Templates</h3>\r\n			<p>There are now six different layout variations \r\n                        of the Mollio templates.</p>\r\n			</div>', 0);

CREATE TABLE `{PREFIX}site_keywords` (
  `id` int(11) NOT NULL auto_increment,
  `keyword` varchar(40) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `keyword` (`keyword`)
) TYPE=MyISAM COMMENT='Site keyword list' ;

CREATE TABLE `{PREFIX}site_snippets` (
  `id` int(10) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `description` varchar(255) NOT NULL default 'Snippet',
  `snippet` mediumtext NOT NULL,
  `locked` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM PACK_KEYS=0 COMMENT='Contains the site''s snippets.' ;

INSERT INTO `{PREFIX}site_snippets` VALUES (1, 'PoweredBy', 'A little link to Etomite', '// Snippet name: PoweredBy\r\n// Snippet description: A little link to Etomite.\r\n// Revision: 1.00 ships with Etomite 0.6.1-Final\r\n\r\n$version = $etomite->getVersionData();\r\nreturn ''<a href="http://www.etomite.com" title="Etomite Website">Powered by Etomite <b>''.$version[''version''].$version[''patch_level''].''</b> <i>(''.$version[''code_name''].'')</i>.</a>'';', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (2, 'PageTrail', 'Outputs the page trail, based on Bill Wilson''s script', '// Snippet name: PageTrail\r\n// Snippet description: Outputs the page trail, based on Bill Wilson''s script\r\n// Revision: 1.00 ships with Etomite 0.6.1-Final\r\n\r\n$sep = " &raquo; ";\r\n\r\n// end config\r\n$ptarr = array();\r\n$pid = $etomite->documentObject[''parent''];\r\n$ptarr[] = "<a href=''[~".$etomite->documentObject[''id'']."~]''>".$etomite->documentObject[''pagetitle'']."</a>";\r\n\r\nwhile ($parent=$etomite->getParent($pid)) {\r\n    $ptarr[] = "<a href=''[~".$parent[''id'']."~]''>".$parent[''pagetitle'']."</a>";\r\n    $pid = $parent[''parent''];\r\n}\r\n\r\n$ptarr = array_reverse($ptarr);\r\nreturn join($ptarr, $sep);', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (3, 'MenuBuilder', 'Builds the site menu', '// Snippet name: MenuBuilder\r\n// Snippet description: Builds the site menu\r\n// Revision: 1.00 ships with Etomite 0.6.1-Final\r\n\r\n$id = isset($id) ? $id : $etomite->documentIdentifier;\r\n$sortby = "menuindex";\r\n$sortdir = "ASC";\r\n$fields = "id, pagetitle, description, parent, alias";\r\n\r\n$indentString="";\r\n\r\nif(!isset($indent)) {\r\n    $indent = "";\r\n    $indentString .= "";\r\n} else {\r\n    for($in=0; $in<$indent; $in++) {\r\n        $indentString .= "&nbsp;";\r\n    }\r\n    $indentString .= "&raquo;&nbsp;";\r\n}\r\n\r\n$children = $etomite->getActiveChildren($id, $sortby, $sortdir, $fields);\r\n$menu = "";\r\n$childrenCount = count($children);\r\n$active="";\r\n\r\nif($children==false) {\r\n    return false;\r\n}\r\nfor($x=0; $x<$childrenCount; $x++) {\r\n	if($children[$x][''id'']==$etomite->documentIdentifier) {\r\n		$active="class=\\"highLight\\"";\r\n	} else {\r\n		$active="";\r\n	}\r\n	if($children[$x][''id'']==$etomite->documentIdentifier || $children[$x][''id'']==$etomite->documentObject[''parent'']) {\r\n		$menu .= "<a ".$active." href=\\"[~".$children[$x][''id'']."~]\\">$indentString".$children[$x][''pagetitle'']."</a>[[MenuBuilder?id=".$children[$x][''id'']."&indent=2]]";	\r\n	} else {\r\n		$menu .= "<a href=\\"[~".$children[$x][''id'']."~]\\">$indentString".$children[$x][''pagetitle'']."</a>";\r\n	}\r\n}\r\nreturn $menu."";', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (4, 'FirstHit', 'Fetches the first ever recorded page impression from the database.', '// Snippet name: FirstHit\r\n// Snippet description: Fetches the first ever recorded page impression from the database.\r\n// Revision: 1.1 ships with Etomite 0.6.1-Final\r\n\r\n// Changes:\r\n//   v1.1 by Lloyd Borrett -- 2005-04-07\r\n//   Return local time based on Etomite server offset time\r\n\r\n// get the Etomite server offset time in seconds\r\n$server_offset_time = $etomite->config[''server_offset_time''];\r\nif (!$server_offset_time) {\r\n  $server_offset_time = 0;\r\n}\r\n\r\n$sql = "SELECT MIN(timestamp) AS first FROM ".$etomite->dbConfig[''dbase''].".".$etomite->dbConfig[''table_prefix'']."log_access";\r\n$rs = $etomite->dbQuery($sql);\r\n$tmp = $etomite->fetchRow($rs);\r\n\r\nreturn strftime("%d-%m-%Y %H:%M:%S", $tmp[''first''] + $server_offset_time);', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (5, 'SearchForm', 'All-in-one snippet to search the site', '// Snippet name: SearchForm\r\n// Snippet description: All-in-one snippet to search the site\r\n// Revision: 1.1 ships with Etomite 0.6.1-Final\r\n\r\n$searchString = \r\nisset($_POST[''search'']) && \r\n$_POST[''search'']!= "{{" && \r\n$_POST[''search'']!= "[[" && \r\n$_POST[''search'']!= "[(" && \r\n$_POST[''search'']!= "[~" && \r\n$_POST[''search'']!= "[*" ?\r\n$_POST[''search''] : "" ;\r\n\r\n\r\n$SearchForm .= ''<form name="SearchForm" action="" method="post">''."\\n"; \r\n$SearchForm .= ''<input type="text" name="search" class="text" value="''.$searchString.''" /><br />''."\\n"; \r\n$SearchForm .= ''<input type="submit" name="sub" class="button" value="Search" />''."\\n"; \r\n$SearchForm .= ''</form>''; \r\n\r\nif(isset($_POST[''search'']) && $_POST[''search'']!='''') { \r\n   $search = explode(" ", $_POST[''search'']); \r\n   $tbl = $etomite->dbConfig[''dbase''].".".$etomite->dbConfig[''table_prefix'']."site_content";\r\n   $sql = "SELECT id, pagetitle, parent, description FROM $tbl WHERE ($tbl.content LIKE ''%".$search[0]."%''"; \r\n   for ($x=1;$x < count($search); $x++) { \r\n       $sql .= " AND $tbl.content like ''%$search[$x]%''"; \r\n   } \r\n   $sql .= " OR $tbl.pagetitle LIKE ''%".$search[0]."%'' "; \r\n   for ($x=1;$x < count($search); $x++) { \r\n       $sql .= " AND $tbl.pagetitle like ''%$search[$x]%''"; \r\n   } \r\n   $sql .= " OR $tbl.description LIKE ''%".$search[0]."%'' "; \r\n   for ($x=1;$x < count($search); $x++) { \r\n       $sql .= " AND $tbl.description like ''%$search[$x]%''"; \r\n   } \r\n   $sql .= ") AND $tbl.published = 1 AND $tbl.searchable=1 AND $tbl.deleted=0;"; \r\n   $rs = $etomite->dbQuery($sql); \r\n   $limit = $etomite->recordCount($rs); \r\n   if($limit>0) { \r\n      $SearchForm .= "<p>The following results were found:</p>\\n";\r\n      $SearchForm .= "<table cellspacing=\\"0\\" cellpadding=\\"0\\">\\n"; \r\n      for ($y = 0; $y < $limit; $y++) { \r\n         $SearchFormsrc=$etomite->fetchRow($rs); \r\n         $SearchForm.="<tr><td style=\\"padding: 1px\\"><a href=\\"[~".$SearchFormsrc[''id'']."~]\\"><b>".$SearchFormsrc[''pagetitle'']."</b></a></td>\\n";\r\n         $SearchForm.="<td style=\\"padding: 1px\\">"; \r\n         $SearchForm.=$SearchFormsrc[''description'']!='''' ? " - <small>".$SearchFormsrc[''description'']."</small>" : "" ; \r\n         $SearchForm .= "</td></tr>";\r\n      } \r\n      $SearchForm .= "</table>";\r\n   } else { \r\n      $SearchForm.="<p>Sorry, couldn''t find anything!</p>"; \r\n   } \r\n} \r\n\r\nreturn $SearchForm;', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (6, 'GetStats', 'Fetches the visitor statistics totals from the database', '// Snippet name: GetStats\r\n// Snippet description: Fetches the visitor statistics totals from the database\r\n// Revision: 1.1 ships with Etomite 0.6.1-Final\r\n\r\n$tmpArray = $etomite->getSiteStats();\r\n\r\n$output = "\r\n<table class=\\"stats\\" cellspacing=\\"1\\">\r\n  <thead>\r\n    <tr class=\\"fancyRow\\">\r\n        <td width=\\"25%\\">&nbsp;</td>\r\n        <td width=\\"25%\\"><b>Page Impressions</b></td>\r\n        <td width=\\"25%\\"><b>Visits</b></td>\r\n        <td width=\\"25%\\"><b>Visitors</b></td>\r\n    </tr>\r\n  </thead>\r\n    <tr>\r\n        <td><b>Today</b></td>\r\n        <td>".number_format($tmpArray[''piDay''])."</td>\r\n        <td>".number_format($tmpArray[''viDay''])."</td>\r\n        <td>".number_format($tmpArray[''visDay''])."</td>\r\n    </tr>\r\n    <tr>\r\n        <td><b>This Month</b></td>\r\n        <td>".number_format($tmpArray[''piMonth''])."</td>\r\n        <td>".number_format($tmpArray[''viMonth''])."</td>\r\n        <td>".number_format($tmpArray[''visMonth''])."</td>\r\n    </tr>\r\n    <tr>\r\n        <td><b>All Time</b></td>\r\n        <td>".number_format($tmpArray[''piAll''])."</td>\r\n        <td>".number_format($tmpArray[''viAll''])."</td>\r\n        <td>".number_format($tmpArray[''visAll''])."</td>\r\n    </tr>\r\n</table>\r\n";\r\n\r\nreturn $output;', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (7, 'DateTime', 'Makes a date and time... thingy.', '// Snippet name: DateTime\r\n// Snippet description: Makes a date and time... thingy.\r\n// Revision: 1.1 ships with Etomite 0.6.1-Final\r\n// Author: Alex -- 2004-09-12\r\n\r\n/* For such a small piece of code, this is an exceedingly \r\n   powerful and handy snippet. The snippet accepts one \r\n   parameter, ''timestamp''. If this isn''t set, the snippet \r\n   will display the current date and time. If you pass a \r\n   timestamp (UNIX-style), it will convert that instead. \r\n   Probably the most useful way of using this snippet is \r\n   by writing something like the following in your template \r\n   or document:\r\n\r\n   Last edited on: [[DateTime?timestamp=[*editedon*]]\r\n\r\n   This will display the date and time at which the document \r\n   was last altered on your page!\r\n*/\r\n\r\n// Changes:\r\n//   v1.1 by Lloyd Borrett -- 2005-02-07\r\n//   Return local time based on Etomite server offset time\r\n\r\n// get the Etomite server offset time in seconds\r\n$server_offset_time = $etomite->config[''server_offset_time''];\r\nif (!$server_offset_time) {\r\n  $server_offset_time = 0;\r\n}\r\n\r\nif(!isset($timestamp)) {\r\n    $timestamp=time();\r\n}\r\n\r\nreturn strftime("%d-%m-%Y %H:%M:%S", $timestamp + $server_offset_time);', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (8, 'GetKeywords', 'Fetches the keywords attached to the document.', '// Snippet name: GetKeywords\r\n// Snippet description: Fetches the keywords attached to the document.\r\n// Revision: 1.00\r\n$keywords = $etomite->getKeywords();\r\nif(count($keywords)>0) {\r\n    $keys = join($keywords, ", ");\r\n    return ''<meta http-equiv="keywords" content="''.$keys.''" />'';\r\n} else {\r\n    return false;\r\n}', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (9, 'NewsListing', 'Displays news.', '// --------------------\r\n// Snippet: NewsListing\r\n// --------------------\r\n// Originated as NewsListing v1.0 by Alex\r\n// Revised as NewsListingRevised by mrruben5\r\n// Revised as NewsListingRev02 by LePrince\r\n// Revised as NewsListingRev03 by Lloyd Borrett (lloyd@borrett.id.au)\r\n// Revised as NewsListing v1.3 by Lloyd Borrett (lloyd@borrett.id.au)\r\n//\r\n// This version takes many of the ideas of NewsListingRev02 back \r\n// into the tableless form of NewsListingRevised. Plus adds some other ideas.\r\n//\r\n// Showing the date-time is now optional.\r\n//\r\n// Option to output dates and times as local time.\r\n// This would be typically done using the Etomite configuration \r\n// "server offset time" value. But you can specify a different value.\r\n//\r\n// Option to get only active documents, or all documents, in the folder.\r\n//\r\n// Last Modified: 07-Apr-2006\r\n\r\n//===== USAGE: ===============\r\n// [[NewsListing]] \r\n// [[NewsListing?newsid=8]]\r\n// [[NewsListing?newsid=8&complete_news_id=10]]\r\n// and so on for all the acceptable arguments.\r\n\r\n//===== ARGUMENTS: ===============\r\n\r\n// the folder that contains news entries\r\n// passed as argument "newsid" or default to current document id \r\n$resourceparent = isset($newsid) ? $newsid : $etomite->documentIdentifier;\r\n\r\n// set this to the id of the document which contains the \r\n// snippetcall where ALL news-articles are to be shown.\r\n// the "Older news" text serves as hyperlink\r\n// -1 = ignore this\r\nif (!isset($complete_news_id)) {$complete_news_id = -1;}\r\n\r\n// should the author be displayed?   1=yes,   0=no\r\nif (!isset($show_author)) {$show_author = 1;}\r\n\r\n// should the date-time be displayed?   1=yes,   0=no\r\nif (!isset($show_date)) {$show_date = 1;}\r\n\r\n// how many "older news" shall be displayed\r\n// -1 = all of them\r\nif (!isset($older_news)) {$older_news = -1;}\r\n\r\n// should the pagetitle, which is used as heading, be clickable?   1=yes,   0=no\r\nif (!isset($title_as_link)) {$title_as_link = 0;}\r\n\r\n// should the news item text be omitted?   1=yes,   0=no\r\n// goes nicely with $title_as_link!\r\nif (!isset($title_only)) {$title_only = 0;}\r\n\r\n// should only active documents be displayed?   1=yes,   0=no\r\n// yes - returns only active documents (i.e. published and not deleted) in the folder\r\n// no - returns all documents (i.e. published, unpublished, deleted) in the folder\r\nif (!isset($show_only_active)) {$show_only_active = 1;}\r\n\r\n//===== end of arguments =========\r\n\r\n//===== CONFIGURATION: ===============\r\n\r\n// number of news items to show a "short story" of\r\n$nrblogs = 3;\r\n\r\n// total number of news items to retrieve\r\n// archives is $nrblogstotal minus $nrblogs\r\n$nrblogstotal = 30;\r\n\r\n// how many characters to show of news item if splitter not being used\r\n$lentoshow = 150; \r\n\r\n// what indicates the "full story", i.e. the end of the \r\n// short portion and the beginning of the\r\n// "full story" - this has to be "written" manually in \r\n// the article''s text in HTML-mode (without the apostrophes of course)!\r\n// the <!-- --> makes it a comment which is automatically \r\n// invisible within the article.\r\n$splitter = "<!--FullStory-->";\r\n\r\n// the text to show as full story link\r\n$fullstorytext = "Full Story";\r\n\r\n// shall the article be cut off at the *splitter*?   1=yes,   0=no\r\n$use_splitter = 1;\r\n\r\n// the text to show for no entries found\r\n$noentriestext = "No entries found.";\r\n\r\n// the text to show as heading for older news \r\n// Note that you must write special characters as html entities. \r\n$oldernewstext = "Older news";\r\n\r\n// the default author name\r\n$noauthortext = "anonymous";\r\n// the date-time format to display based on strftime() \r\n$timeformat = "%A, %d-%b-%Y %H:%M %p";  #  ( Thursday, 08-Oct-2005 02:00 PM )\r\n\r\n// get server offset time in hours\r\n$server_offset_time = $etomite->config[''server_offset_time''];\r\nif (!$server_offset_time) {\r\n  $server_offset_time = 0;\r\n} else {\r\n  $server_offset_time = ($server_offset_time / 60 / 60);\r\n}\r\n \r\n// default time offset (+/-) in hours to use\r\n// typically set to the Etomite configuration "server offset time" value\r\n// using the $server_offset_time value calculated above\r\n$default_time_diff = $server_offset_time;\r\n\r\n//===== end of configuration =========\r\n\r\n// initialise the news variable \r\n$output = '''';\r\n\r\n// time adjustment\r\n$timeadjust = ($default_time_diff * 60 * 60);\r\n\r\nif ($show_only_active == 1) {\r\n  $resource = $etomite->getActiveChildren($resourceparent, ''createdon'', ''DESC'', $fields=''id, pagetitle, description, content, createdon, createdby'');\r\n} else {\r\n  $resource = $etomite->getAllChildren($resourceparent, ''createdon'', ''DESC'', $fields=''id, pagetitle, description, content, createdon, createdby'');\r\n}\r\n\r\n$limit = count($resource);\r\nif ($limit < 1) { \r\n   $output .= $noentriestext."<br />\\n"; \r\n} \r\n\r\n$nrblogs = $nrblogs<$limit ? $nrblogs : $limit; \r\nif ($limit > 0) { \r\n   for ($x = 0; $x < $nrblogs; $x++) { \r\n	  $tbl = $this->dbConfig[''dbase''].".".$this->dbConfig[''table_prefix'']."manager_users";\r\n      $sql = "SELECT username FROM $tbl WHERE $tbl.id = ".$resource[$x][''createdby'']; \r\n      $rs2 = $etomite->dbQuery($sql);\r\n      $limit2 = $etomite->recordCount($rs2); \r\n      if ($limit2 < 1) { \r\n         $username .= $noauthortext; \r\n      } else { \r\n         $resourceuser = $etomite->fetchRow($rs2); \r\n         $username = $resourceuser[''username'']; \r\n\r\n//====== Splitter to be used? =====\r\n         if ($use_splitter == 1) {\r\n           if (is_string(strstr ($resource[$x][''content''], $splitter))) {\r\n           // Does the content contain the socalled "splitter"?\r\n             $rest = array();\r\n\r\n             // HTMLarea/XINHA encloses it in paragraph''s\r\n             $rest = explode(''<p>''.$splitter.''</p>'',$resource[$x][''content'']);\r\n\r\n             // For TinyMCE or if it isn''t wrapped inside paragraph tags\r\n             $rest = explode($splitter,$rest[''0'']);\r\n\r\n             $rest = $rest[''0''].''<p><a href="[~''.$resource[$x][''id''].''~]">''.$fullstorytext."</a></p>\\n";\r\n           } else {\r\n             $rest = $resource[$x][''content'']; \r\n           }\r\n//======= End of splitter part ===\r\n\r\n         } else { \r\n//=== no splitter ... normal behaviour: ===\r\n           // strip the content \r\n           if (strlen($resource[$x][''content'']) > $lentoshow) { \r\n             $rest = substr($resource[$x][''content''], 0, $lentoshow); \r\n             $rest .= "...<br />\\n";\r\n             $rest .= "<a href=\\"[~".$resource[$x][''id'']."~]\\">&lt; More on this story &gt;</a>"; \r\n           } else { \r\n             $rest = $resource[$x][''content'']; \r\n           } \r\n//======= End of no splitter part ===\r\n         }\r\n\r\n         $output .= "\\n<fieldset><legend>";\r\n         if ($title_as_link == 1) {\r\n           $output .= "<a href=[~".$resource[$x][''id'']."~]>";\r\n         }\r\n         $output .= $resource[$x][''pagetitle''];\r\n         if ($title_as_link == 1) {\r\n           $output .= "</a>";\r\n         }\r\n         $output .= "</legend>\\n";\r\n      \r\n         if ($title_only != 1) {\r\n           $output .= $rest."\\n";\r\n         }\r\n\r\n         if (($show_author == 1) || ($show_date == 1)) {\r\n           $output .= "<p style=\\"text-align:right;\\">Posted ";\r\n           if ($show_author == 1) {\r\n             $output .= "by ".$username." ";\r\n           }\r\n           if ($show_date == 1) {\r\n             $output .= "on ".strftime($timeformat, $resource[$x][''createdon''] + $timeadjust);\r\n           }\r\n           $output .= "</p>";\r\n         } \r\n         $output .= "</fieldset>\\n";\r\n      } \r\n   } \r\n} \r\n\r\nif ($limit > $nrblogs) { \r\n   $output .= "<p><b>";\r\n\r\n   //=== is there a document where *all* news are to be displayed? If so\r\n   //=== here is the hyperlink\r\n   if ($complete_news_id != -1) {\r\n     $output .= "<a href=\\"[~$complete_news_id~]\\">";\r\n   }\r\n\r\n   //=== older news text:\r\n   $output .= "$oldernewstext"; \r\n\r\n   //=== is there a document where *all* news are to be displayed? If so\r\n   //=== close the hyperlink\r\n   if ($complete_news_id != -1) {\r\n     $output .= "</a>";\r\n   }\r\n   $output .= "</b><br />\\n";\r\n\r\n   //=== count of older news to be shown:\r\n   if ($older_news == -1) {\r\n     $older_news = $limit;\r\n   } else {\r\n     $older_news += $nrblogs;\r\n   }\r\n\r\n   for ($x = $nrblogs; $x < $limit; $x++) { \r\n\r\n      //=== show only a certain amount of older news:\r\n      if ($x < $older_news) {\r\n        $output .= "&gt; <a href=\\"[~".$resource[$x][''id'']."~]\\"";\r\n        if (($show_author == 1) || ($show_date == 1)) {\r\n          $output .= " title=\\"Posted ";\r\n          if ($show_author == 1) {\r\n            $output .= "by ".$username." ";\r\n          }\r\n          if ($show_date == 1) {\r\n            $output .= "on ".strftime($timeformat, $resource[$x][''createdon''] + $timeadjust);\r\n          }\r\n          $output .= "\\"";\r\n        } \r\n        $output .= ">".$resource[$x][''pagetitle'']."</a><br />\\n";\r\n      }          \r\n   }\r\n   $output .= "<br />\\n</p>\\n";\r\n}\r\n\r\nreturn $output;', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (10, 'DontLogPageHit', 'Stops the parser from logging the page hit', '$this->config[''track_visitors'']=0;\r\nreturn "";', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (11, 'DateTimePlus', 'Adjusts and formats document or current Date/Time', '// Snippet name: DateTimePlus\r\n// Snippet description: Adjusts and formats document or current Date/Time \r\n// Revision: 1.1 ships with Etomite 0.6.1-Final\r\n\r\n// Author: Ralph A. Dahlgren -- rad14701 -- 2005-04-14 based on Bill Wilson''s script\r\n// Usage: [!DateTimePlus?timestamp=[*editedon*]&diff=2&format=d-m-Y H:i:s!]\r\n\r\n// Changes:\r\n//   v1.1 by Lloyd Borrett -- 2005-02-07\r\n//   Use Etomite server offset time as the default time offset\r\n\r\n// get the Etomite server offset time in seconds and convert to hours\r\n$server_offset_time = $etomite->config[''server_offset_time''];\r\nif (!$server_offset_time) {\r\n  $server_offset_time = 0;\r\n} else {\r\n  $server_offset_time = ($server_offset_time / 3600);\r\n}\r\n\r\n// Default time offset (+/-) to use if not sent in snippet call\r\n$defaultDiff = $server_offset_time;\r\n\r\n// Default Date/Time format to use if not sent in snippet call based on date()\r\n$defaultFormat = "( l, F jS, Y g:i a )";  #  ( Thursday, April 14th, 2005 8:00 pm )\r\n\r\n// If timestamp such as [*editedon*] or [*createdon*] sent, use it, \r\n// otherwise use time()\r\nif($timestamp == "editedon") $timestamp = $etomite->documentObject[''editedon''];\r\nelseif($timestamp == "createdon") $timestamp = $etomite->documentObject[''createdon''];\r\nelseif($timestamp == "pub_date") $timestamp = $etomite->documentObject[''pub_date''];\r\nelseif($timestamp == "unpub_date") $timestamp = $etomite->documentObject[''unpub_date''];\r\n$timestamp = isset($timestamp) ? $timestamp : time();\r\n\r\n// Hours difference between server time and local time\r\n$diff = isset($diff) ? $diff : $defaultDiff;\r\n\r\n// Your desired Date/Time format based on date()\r\n$format = isset($format) ? $format : $defaultFormat;\r\n\r\n// Adjust time if required, format, and return\r\n$timeadjust = ($diff * 60 * 60);\r\n$output = date($format, $timestamp + $timeadjust);\r\nreturn $output;', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (12, 'GetAuthorData', 'Returns author information based on sent parameters', '// Snippet name: GetAuthorData\r\n// Snippet description: Returns author information based on sent parameters \r\n// Revision: 1.1 ships with Etomite 0.6.1-Final\r\n// Created By: Ralph A. Dahlgren - rad14701@yahoo.com - Modified 2005-04-17\r\n\r\n// Usage: [[GetAuthorData?internalKey=[*createdby*]&field=fullname]]\r\n// internalKey=[*editedby*] will return data about the user who last edited a document\r\n// field can be any column in the user_attributes database table\r\n// field subset: (fullname,email,phone,mobilephone)\r\n\r\nif(($internalKey == "") || ($field == "")){\r\n return "";\r\n} else {\r\n  $sql = "SELECT * FROM ".$etomite->db."user_attributes WHERE internalKey=".$internalKey.";";\r\n  $rs = $etomite->dbQuery($sql);\r\n  $limit = $etomite->recordCount($rs);\r\n  if($limit > 0){\r\n    $author = $etomite->fetchRow($rs);\r\n    $output = $author[$field];\r\n  } else {\r\n    $output = "";\r\n  }\r\n}\r\n\r\nreturn $output;', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (13, 'FormHandler', 'Saves form data to an internal or external database table (Advanced)', '#  FormHandler -- Etomite 0.6.1+ Snippet -- 2005-03-11\r\n#  Created By: Ralph A. Dahlgren -- rad14701@yahoo.com\r\n#  Extracts data from an Etomite form and saves to either an internal or external MySQL database table.\r\n#  WARNING: This is an advanced snippet which requires an understanding of HTML forms, PHP, and MySQL.\r\n#           This snippet assumes that the target database and table already exist.\r\n#  Usage:\r\n#  1. Place the snippet call [!FormHandler!] at the top of a document containing an HTML form\r\n#  2. Insert hidden fields within the form to\r\n#    Internal database tables\r\n#      $prefix = field perfix prepended onto form data elements only\r\n#      $into = name of the table which will receive the form data\r\n#    External database tables\r\n#      $host = MySQL server hostname (''localhost'',''www.your_server.com'')\r\n#      $user = username\r\n#      $pass = password\r\n#      $dbase = database name\r\n#      $into = name of the table which will receive the form data\r\n#      $prefix = field perfix prepended onto form data elements only\r\n#  Note: The control elements (host,user,pass,dbase,fields,into,prefix,submit,reset) do not require a prefix.\r\n#  Additional fields can be added to the form which will be replaced by calculated data. These fields must be prefixed.\r\n#    timestamp = Unix timestamp using time() function\r\n#    datetime = formatted date and/or time based on the string variable $datetime\r\n#    additonal calculated fields can be added to the appropriate code section\r\n\r\n$fields=array();  #  Define the $fields variable as an array\r\n$datetime = "%Y-%m-%d %T";  #  Assign desired formatting for datetime data fields\r\n\r\n# Has the form been submitted\r\nif(isset($_POST[''submit''])){\r\n  # Was a prefix assigned as a hidden form field\r\n  if(isset($_POST[''prefix''])) $prefix = $_POST[''prefix''];\r\n  else return "Database Field Prefix Required...";\r\n\r\n  # Extract the form data fields using getFormVars\r\n  $fields = $etomite->getFormVars($method="POST",$prefix,$trim=true,$REQUEST_METHOD);\r\n  if(isset($_POST[''into''])) $into = $_POST[''into''];\r\n  else return "Database Name Parameter Missing...";\r\n\r\n  #  Check for calculated field assignments based on returned value\r\n  foreach($fields as $key=>$value){\r\n    if($fields[$key] == "timestamp") $fields[$key] = time();\r\n    if($fields[$key] == "datetime") $fields[$key] = strftime($datetime,time());\r\n  }\r\n\r\n  #  Was external database information supplied\r\n  if(isset($_POST[''host''])){\r\n    $host = $_POST[''host''];\r\n    $user = $_POST[''user''];\r\n    $pass = $_POST[''pass''];\r\n    $dbase = $_POST[''dbase''];\r\n    #  External database so save using putExtTableRow\r\n    $rs = $etomite->putExtTableRow($host, $user, $pass, $dbase, $fields, $into);\r\n  } else {\r\n    #  Internal database so save using putIntTableRow\r\n    $rs = $etomite->putIntTableRow($fields,$into);\r\n  }\r\n}\r\n\r\n# END of snippet code', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (14, 'SiteUpdate', 'Returns date of most recent document update', '// Snippet name: SiteUpdate\r\n// Snippet description: Returns date of most recent document update\r\n// Revision: 1.1 ships with Etomite 0.6.1-Final\r\n\r\n// Author: Ralph A. Dahlgren -- 2005-07-13\r\n// Usage: [!SiteUpdate?dateFormat=%B %e, %Y!] Returns date formatted: July 13, 2005 \r\n// See strftime() documentation for additional formatting options\r\n\r\n// Changes:\r\n//   v1.1 by Lloyd Borrett -- 2006-04-07\r\n//   Return local time based on Etomite server offset time\r\n\r\n// Default Date/Time format to use if not sent in snippet call\r\n$format = isset($dateFormat) ? $dateFormat : "%B %e, %Y";\r\n\r\n// get the Etomite server offset time in seconds\r\n$server_offset_time = $etomite->config[''server_offset_time''];\r\nif (!$server_offset_time) {\r\n  $server_offset_time = 0;\r\n}\r\n\r\n$sql = "SELECT editedon FROM ".$etomite->db."site_content ORDER BY editedon DESC";\r\n$rs = $etomite->dbQuery($sql);\r\n\r\nif ($etomite->recordCount($rs) >= 1){\r\n  $row = $etomite->fetchRow($rs);\r\n  $update= strftime($format,$row[''editedon''] + $server_offset_time);\r\n} else {\r\n  $update="";\r\n}\r\n\r\nreturn $update;', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (15, 'SearchPrompt', 'Search prompt snippet for use with SearchResults', '// Snippet name: SearchPrompt\r\n// Snippet description: Search prompt snippet for use with SearchResults\r\n// Revision: 1.00 ships with Etomite 0.6.1-Final\r\n// Use: [!SearchPrompt?resultsid=###!] snippet call where ### is the\r\n//   document id of the page which contains the [!SearchResults!] snippet call\r\n\r\n$resultsDefault = "16";  // Document id to use if $resultsid not sent\r\n$resultsid = isset($resultsid) ? $resultsid : $resultsDefault;\r\n\r\n$prompt = "<br />Search this site<br />";  // Search box label text\r\n$submit = "Search";  // Submit button label\r\n\r\n$output = ''\r\n<div class="searchbox" style="text-align:center;">''.$prompt.''\r\n  <form name="SearchForm" action="[~''.$resultsid.''~]" method="post"> \r\n    <p><input type="text" name="search" value="" /></p>\r\n    <p><input type="submit" name="sub" class="button" value="''.$submit.''" /></p>\r\n  </form>\r\n</div>\r\n'';\r\n\r\nreturn $output;', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (16, 'SearchResults', 'Displays results of SearchPrompt snippet', '//  SearchResults\r\n//  Displays results of SearchPrompt snippet\r\n\r\n$noResults = "<p>No search results were found.</p>";\r\n$resultsText = "<p>The following results were found:</p>";\r\n$searchString = \r\nisset($_POST[''search'']) && \r\n$_POST[''search'']!= "{{" && \r\n$_POST[''search'']!= "[[" && \r\n$_POST[''search'']!= "[(" && \r\n$_POST[''search'']!= "[~" && \r\n$_POST[''search'']!= "[*" ?\r\n$_POST[''search''] : "" ;\r\n\r\nif(isset($_POST[''search'']) && $_POST[''search'']!='''') { \r\n   $search = explode(" ", $_POST[''search'']); \r\n   $sql = "SELECT id, pagetitle, parent, description FROM ".$etomite->db.site_content." WHERE (content LIKE ''%".$search[0]."%''"; \r\n   for ($x=1;$x < count($search); $x++) { \r\n       $sql .= " AND content like ''%$search[$x]%''"; \r\n   } \r\n   $sql .= " OR pagetitle LIKE ''%".$search[0]."%'' "; \r\n   for ($x=1;$x < count($search); $x++) { \r\n       $sql .= " AND pagetitle like ''%$search[$x]%''"; \r\n   } \r\n   $sql .= " OR description LIKE ''%".$search[0]."%'' "; \r\n   for ($x=1;$x < count($search); $x++) { \r\n       $sql .= " AND description like ''%$search[$x]%''"; \r\n   } \r\n   $sql .= ") AND published = 1 AND searchable=1 AND deleted=0;"; \r\n   $rs = $etomite->dbQuery($sql); \r\n   $limit = $etomite->recordCount($rs); \r\n   if($limit>0) { \r\n      $SearchForm .= $resultsText."<p><table cellspacing=''0'' cellpadding=''0''>"; \r\n      for ($y = 0; $y < $limit; $y++) { \r\n         $SearchFormsrc=$etomite->fetchRow($rs); \r\n         $SearchForm.="<tr><td style=''padding: 1px''><a href=''[~".$SearchFormsrc[''id'']."~]''><b>".$SearchFormsrc[''pagetitle'']."</b></a></td><td style=''padding: 1px''>"; \r\n         $SearchForm.=$SearchFormsrc[''description'']!='''' ? " - <small>".$SearchFormsrc[''description'']."</small>" : "" ; \r\n         $SearchForm .= "</td></tr>";\r\n      } \r\n      $SearchForm .= "</table>";\r\n   } else { \r\n      $SearchForm .= $noResults; \r\n   } \r\n} \r\n\r\nreturn $SearchForm;', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (17, 'ListDocuments', 'Displays document listings based on provided criteria', '// Snippet name: ListDocuments\r\n// Snippet description: Displays document listings based on provided criteria \r\n// Revision: 1.2 ships with Etomite 0.6.1-Final\r\n\r\n// Advanced version of the NewsListing snippet created by Ralph A. Dahlgren\r\n//   from the earlier version by Alex Butter\r\n\r\n// Displays brief listing of new article summaries with links to full articles\r\n// All passed variable assignments are optional and can be customized as needed\r\n// Usage: [!ListDocuments?ids=123&numListings=5&maxListings=20&maxChars=200!]\r\n///   Or: [!ListDocuments!] to use default settings for curent folder document\r\n//    Or: [!ListDocuments?ids=11,27,34,119&numListings=5&maxListings=5&maxChars=400!]\r\n//    Or: [!ListDocuments?createdby=1&createdon=20050514!]\r\n// Note:  createdon = YYYYMMDD or MM/DD/YY[YY] formats\r\n//        createdby = user/manager internalKey number\r\n\r\n// Changes:\r\n//   v1.1 by Ralph A. Dahlgren -- 2005-07-13\r\n\r\n//   v1.2 by Lloyd Borrett -- 2006-04-07\r\n//     Return local time based on Etomite server offset time\r\n\r\n//----------  Start of inline style variables  ----------//\r\n//  can be changed to use CSS by using: $object_css = "class=''object_class_name''";\r\n\r\n$entry_box_css = "style=\\"background-color:#F0F8FF; padding:5px; border:1px solid black;\\"";\r\n$title_css = "style=\\"color:red; font-weight:bold; display:block;\\"";\r\n$author_css = "style=\\"color:green; font-weight:bold; display:inline;\\"";\r\n$date_css = "style=\\"color:green; display:inline;\\"";\r\n$parent_css = "style=\\"color:#FFA500; font-weight:bold\\"";\r\n$text_css = "style=\\"color:black; font-weight:normal; margin-top:.5em;\\"";\r\n$more_css = "style=\\"float:right; color:#FFA500; font-weight:bold;\\"";\r\n \r\n//----------  Start of configuration variable assignments  ----------//\r\n\r\n// array of folder id''s that contain news listings, or current folder document (default)\r\n$ids = isset($ids) ? $ids : $etomite->documentIdentifier;\r\n\r\n// number of news listings to summarize\r\n$numListings = isset($numListings) ? $numListings : 3;\r\n\r\n// maximum number of news listings to display\r\n$maxListings = isset($maxListings) ? $maxListings : 100;\r\n \r\n//  maximum character count of news listing summaries to display\r\n$maxChars = isset($maxChars) ? $maxChars : 150;\r\n\r\n// assign message to return if no news listings are found\r\n$noResults = "No entries were found.<br />";\r\n \r\n// Date & Time format based on PHP function strftime() {"%d-%m-%y %H:%M:%S"}\r\n$date_time_format = "%Y-%m-%d";\r\n \r\n// text for author label\r\n$author = "Author: ";\r\n\r\n// Text to display as link to full news listing\r\n$more = "Read the complete article &raquo;";\r\n\r\n// Text to display above additional articles list\r\n$olderNews = "Additional Recent Articles:";\r\n\r\n// Text to display between Author and Date fields\r\n$between = "&#8212;";\r\n \r\n//----------  End of configuration variable assignments  ----------//\r\n\r\n// get the Etomite server offset time in seconds\r\n$server_offset_time = $etomite->config[''server_offset_time''];\r\nif (!$server_offset_time) {\r\n  $server_offset_time = 0;\r\n}\r\n\r\n// initialize the data variable to be returned\r\n$output = '''';\r\n\r\n// assign which data fields to extract from table rows\r\n\r\n$fields = ''\r\n  id,\r\n  pagetitle,\r\n  description,\r\n  content,\r\n  createdon,\r\n  createdby\r\n'';\r\n\r\n// assign selection criteria for WHERE clause\r\n$where = "parent IN($ids) AND published=1 AND deleted=0";\r\n\r\n// if $createdon was sent, convert it to a timestamp and use it\r\nif(isset($createdon)) $where .= " AND createdon=".strtotime($createdon);\r\n\r\n// if $createdby (user internalKey) was sent, add to where clause\r\nif(isset($createdby)) $where .= " AND createdby=".$createdby;\r\n\r\n// retrieve child documents that are published and not deleted using getIntTableRows() API function\r\n$rs = $etomite->getIntTableRows(\r\n  $fields,\r\n  $from="site_content",\r\n  $where,\r\n  $sort="createdon",\r\n  $dir="DESC",\r\n  $limit\r\n);\r\n\r\n// return a message if no listings were found\r\n$limit = count($rs);\r\nif($limit < 1) {\r\n  $output .= $noResults;\r\n} else {\r\n  \r\n  // determine how many listings to process\r\n  $numListings = ($numListings < $limit) ? $numListings : $limit;\r\n  \r\n  // process the proper number of listings\r\n  for ($x = 0; $x < $numListings; $x++) {\r\n    \r\n    // retrieve the authors full username using getAuthorData() API function\r\n    $userdata = $etomite->getAuthorData($rs[$x][''createdby'']);\r\n    $username = $userdata[''fullname''];\r\n    \r\n    // if the listing is longer than $maxChars, strip the HTML tags from the content \r\n    $stripped = strip_tags($rs[$x][''content'']);\r\n    if(strlen($stripped)>$maxChars) {\r\n      $rest = substr($stripped, 0, $maxChars);\r\n      $rest .= "...<br />"; \r\n    } else {\r\n      $rest = $rs[$x][''content''];\r\n    }\r\n    \r\n    // format the news listing for display\r\n    $output .= "\r\n    <div ".$entry_box_css.">\r\n      \r\n      <div ".$title_css.">\r\n        ".$rs[$x][''pagetitle'']."\r\n      </div>\r\n      \r\n      <div ".$text_css.">\r\n        \r\n        ".$rest."\r\n        <div style=\\"clear:both; margin-bottom:.5em;\\"></div>\r\n        \r\n        <div style=\\"text-align:left; float:left;\\">\r\n          ".$author."\r\n          <div ".$author_css.">\r\n            ".$username."\r\n          </div>\r\n          ".$between." ".strftime($date_time_format, $rs[$x][''createdon''] + $server_offset_time)."\r\n        </div>\r\n        <div style=''text-align:right; float:right;''>\r\n          <a href=\\"[~".$rs[$x][''id'']."~]\\">".$more."</a>\r\n        </div>\r\n      \r\n      </div>\r\n      \r\n      <br />\r\n    \r\n    </div>\r\n    <br />";\r\n  }\r\n}\r\n\r\n// display list of links to older news articles\r\nif(($limit > $numListings) && ($numListings < $maxListings)) {\r\n  $output .= "<br /><br /><b>".$olderNews."</b><br />";\r\n  for ($x = $numListings; $x < $limit; $x++) {\r\n    $output .= "<a href=\\"[~".$rs[$x][''id'']."~]\\">".$rs[$x][''pagetitle'']."</a><br />";          \r\n  }\r\n}\r\n\r\n// return snippet results for display\r\nreturn $output;', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (18, 'ListMenu', 'Feature-rich menu snippet', '// --------------------\r\n// Snippet: ListMenu\r\n// --------------------\r\n// Version: 0.6f\r\n// Date: 2005.08.04\r\n// jaredc@honeydewdesign.com\r\n//\r\n// This snippet was designed to show navigation\r\n// in a nested lists of arbitrary depth.\r\n\r\n// Configuration Settings\r\n\r\n   // $removeNewLines\r\n   // This setting will remove white space from between <ul> and <li> \r\n   // items so the list can be styled in IE. This makes it hard to read\r\n   // the source code- set to false for troubleshooting before launch. \r\n   // False is also handy if the list will be horizontal.\r\n   $removeNewLines = true;\r\n\r\n   // $currentAsLink\r\n   // If you would like to turn off the link for the\r\n   // current page, set to false.\r\n   $currentAsLink = true;\r\n\r\n   // $LM_node [ int ]\r\n   // Settable in snippet call only. Allows you to set an arbitrary\r\n   // anchor for this menu. Should be id number of initial document.\r\n   // For ListMenu this is typically the current page so that the\r\n   // snippet will generate a list back to the site root.\r\n   // [[ListMenu?LM_node=56]]\r\n\r\n   // $levelsDeep [ int ]\r\n   // Specifies how many levels of menu you want to show starting\r\n   // with the children of current document working back to root. For\r\n   // example, 3 levels would give you the children of the current \r\n   // page, the current page and its siblings, and the current page''s \r\n   // parent and its siblings. The child generation is counted regardless\r\n   // of wether or not there are children. \r\n   //\r\n   // You can also specify negative  values. Negative values indicate\r\n   // how many levels NOT to include, starting at the root. For example,\r\n   // if you want all BUT the root level showing, you can declare -1.\r\n   // This would be a main section menu - but without the "global" options.\r\n   //\r\n   // The default of 0 will show current children all the  back to root.\r\n   // This represents the complete menu. You can also set this in a snippet\r\n   // call with LM_levels:\r\n   // [[ListMenu?LM_levels=1]]\r\n   $levelsDeep = 0;\r\n\r\n   // $directGeneology [ true | false ]\r\n   // Set this option if you only want to show the direct geneolgy. For\r\n   // instance, with this set to true, and you were on examplePage 5\r\n   // levels deep, you would see all of examplePage''s child pages (if\r\n   // any), examplePage''s parent, but NOT siblings of any parent above\r\n   // the current page.\r\n   $directGeneology = true;\r\n   \r\n   // $showGlobals [ true | false ]\r\n   // Leave the root level folders showing, even if $directGeneology is\r\n   // true. NOTE- this will NOT override a set $levelsDeep. Settable in \r\n   // snippet call with LM_globals (0=false, 1=true)\r\n   // [[ListMenu?LM_globals=1]]\r\n   $showGlobals = true;\r\n\r\n   // $sortWiz [ array ]\r\n   // You can specify any number of sort columns and directions, so you\r\n   // are not limited to menuindex - for instance you might want alphabetic\r\n   // or folders first or whatever. Format each sort like this:\r\n   // $sortWiz[] = array("sortColumn","direction");\r\n   // Where sortColumn is the sort column like isfolder, pagetitle, etc.\r\n   // and direction is "ASC" for ascending and "DESC" is descending.\r\n   // Default is:\r\n   // $sortWiz[] = array("menuindex","ASC");\r\n   // If you wanted folders first, THEN contents in alphabetical order:\r\n   // $sortWiz[] = array("isfolder","ASC");\r\n   // $sortWiz[] = array("pagetitle","ASC");\r\n   $sortWiz[] = array("menuindex","ASC");\r\n   \r\n   // $alternateRows [ true | false ]\r\n   // Append "_alt" to style class of alternate rows (true)\r\n   $alternateRows = false;\r\n   \r\n   // $showDescription [ true | false ]\r\n   // Show the description under the link- usually not necessary\r\n   // Set in snippet call with LM_desc:\r\n   // [[ListMenu?LM_desc=1]]\r\n   $showDescription = false;\r\n\r\n// STYLES used\r\n//\r\n// #LM_level_N      menu level where N is the number of the depth\r\n//                  starting at 0\r\n// #LM_youAreHere   menu item of current location\r\n// .LM_expanded     expanded menu item with children\r\n// .LM_collapsed    menu item with childen, but not expanded\r\n// .LM_endPage      menu item with children\r\n// .LM_description  menu item description\r\n// \r\n\r\n// ########################################\r\n// End Config\r\n// The rest takes care of itself\r\n// ########################################\r\n\r\n// Adjust for snippet variables\r\n$showGlobals = (isset($LM_globals))? $LM_globals : $showGlobals ;\r\n$levelsDeep = (isset($LM_levels))? $LM_levels : $levelsDeep ;\r\n$showDescription = (isset($LM_desc))? $LM_desc : $showDescription ;\r\n\r\n// Make adjustment for new lines \r\n$ieSpace = ($removeNewLines)? "" : "\\n";\r\n\r\n// Create Geneology\r\n\r\n$fullGeneology = array();\r\n$geneologyMarker = (isset($LM_node))? $LM_node : $etomite->documentIdentifier;\r\nwhile ($currentMarker=$etomite->getPageInfo($geneologyMarker, null, ''id,parent'')){\r\n    $fullGeneology[] = $currentMarker[''id''];\r\n    $geneologyMarker = $currentMarker[''parent''];\r\n}\r\n$fullGeneology[] = 0;\r\n\r\n// alter geneology for correct depth\r\n$geneology = array();\r\nif (($levelsDeep > 0) && (count($fullGeneology) > $levelsDeep)){\r\n    for($i = 0; $i < $levelsDeep; $i++){\r\n        $geneology[] = $fullGeneology[$i];\r\n    }\r\n} elseif (($levelsDeep) < 0 && (count($fullGeneology) > abs($levelsDeep))){\r\n    for ($i = 0; $i < -$levelsDeep; $i++){\r\n        array_pop($fullGeneology);\r\n    }\r\n    $geneology = $fullGeneology;\r\n} else {\r\n    $geneology = $fullGeneology;\r\n}\r\n\r\n// Build lists\r\n\r\n// Initialize\r\n$currentParent = $geneology[0];\r\n\r\n\r\n$listSoFar = '''';\r\n$lookForChild = 0;\r\n// Assemble sort string\r\n$sortString = '''';\r\nforeach($sortWiz as $sortCriteria){\r\n  $sortString .= $sortCriteria[0] . " " . $sortCriteria[1] . ", ";\r\n}\r\n$sortString = substr($sortString,0,strlen($sortString)-2);\r\n\r\nfor($geneCount=0;$geneCount < count($geneology);$geneCount++){\r\n    $childrenList = $etomite->getActiveChildren($geneology[$geneCount], $sortString, null,''id, pagetitle, longtitle, parent, isfolder, description'');\r\n    if ($childrenList){\r\n        $currentLevelList = ''<ul id="LM_level_''.(count($geneology)-$geneCount).''">''."\\n".$ieSpace;\r\n        $listPosition = 0;\r\n        foreach ($childrenList as $childItem){\r\n          if (!$directGeneology || $geneCount==0 || (($geneCount==1)&&(!$etomite->getActiveChildren($geneology[0]))) || ($directGeneology && in_array($childItem[''id''],$geneology)) || ($showGlobals && ($geneology[$geneCount]==0))){\r\n                if ($childItem[''isfolder'']){\r\n                    $cssStyle = (in_array($childItem[''id''], $geneology))? '' class="LM_expanded'': '' class="LM_collapsed'';\r\n                } else {\r\n                    $cssStyle = '' class="LM_endPage'';\r\n                }\r\n	    $cssStyle .= ($alternateRows && ($listPosition%2))? ''_alt"'' : ''"'';\r\n                $currentLevelList .= ''<li''.$cssStyle.''>'';				\r\n                if((!$currentAsLink) && ($childItem[''id''] == $etomite->documentIdentifier)){\r\n                    $currentLevelList .= ''<span id="LM_youAreHere">'';\r\n                    $currentLevelList .= $childItem[''pagetitle''].''</span>'';\r\n                } else {\r\n                    $linkTitle = ($childItem[''longtitle''])? $childItem[''longtitle''] : $childItem[''pagetitle''] ;\r\n                    $currentLevelList .= ''<a href="[~''.$childItem[''id''].''~]" title="'' . $linkTitle .''">'';\r\n                    $currentLevelList .= $childItem[''pagetitle''].''</a>'';\r\n                }\r\n	    $currentLevelList .= ($showDescription)? ''<div class="LM_description">''.$childItem[''description''].''</div>'' : '''' ;\r\n                if ($lookForChild == $childItem[''id'']) {\r\n                    $currentLevelList .= $listSoFar;\r\n                }\r\n                $currentLevelList .= "</li>\\n".$ieSpace;\r\n          }\r\n          $listPosition++;\r\n        }\r\n        $currentLevelList .= "</ul>\\n".$ieSpace;\r\n      }\r\n    $listSoFar = $currentLevelList;\r\n    $lookForChild = $geneology[$geneCount];   \r\n}\r\n\r\n// send to parser\r\nreturn $listSoFar;', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (19, 'GetDocContent', 'Example of extracting document content using API', '#  GetDocContent -- Etomite 0.6.1\r\n#  Author: Ralph A. Dahlgren\r\n#  Date: 2005-04-17\r\n#  Purpose: Returns additional document content for inclusion in a page template, for example\r\n#  Usage: [[GetDocContent?id=nn]] where nn is the id of the document content being requested\r\n\r\nif(isset($id)){\r\n  $fields = "content";\r\n  $doc = $etomite->getDocument($id, $fields);\r\n  if($doc){\r\n    return $doc[''content''];\r\n  }else{\r\n    return "";\r\n  }\r\n}\r\nelse return "";\r\n', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (20, 'ListSiteMap', 'Output a nested list site map', '// --------------------\r\n// Snippet: ListSiteMap\r\n// --------------------\r\n// Version: 0.6h\r\n// Date: 2005.07.08\r\n// jaredc@honeydewdesign.com\r\n//\r\n// This snippet was designed to show a nested\r\n// list site map with each pagetitle being a\r\n// link to that page. It will not include\r\n// unpublished folders/pages OR its children,\r\n// even if the children ARE published.\r\n\r\n// Config\r\n   // $siteMapRoot [int]\r\n   // The parent ID of your root. Default 0. Can be set in \r\n   // snippet call with LSM_root (to doc id 10 for example):\r\n   // [[ListSiteMap?LSM_root=10]]\r\n   $siteMapRoot = 0;\r\n\r\n   // $showDescription [true | false]\r\n   // Specify if you would like to include the description\r\n   // with the page title link.\r\n   $showDescription = true;\r\n\r\n   // $titleOfLinks [ string ]\r\n   // What database field do you want the title of your links to be?\r\n   // The default is pagetitle because it is always a valid (not empty)\r\n   // value, but if you prefer it can be any of the following:\r\n   // id, pagetitle, description, parent, alias, longtitle\r\n   $titleOfLinks = ''pagetitle'';\r\n   \r\n   // $removeNewLines [ true | false ]\r\n   // If you want new lines removed from code, set to true. This is generally\r\n   // better for IE when lists are styled vertically. \r\n   $removeNewLines = true;\r\n   \r\n   // $maxLevels [ int ]\r\n   // Maximum number of levels to include. The default 0 will allow all\r\n   // levels. Also settable with snippet variable LSM_levels:\r\n   // [[ListSiteMap?LSM_levels=2]]\r\n   $maxLevels = 0;\r\n   \r\n   // $selfAsLink [ true | false ]\r\n   // Define if the current page should be a link (true) or not\r\n   // (false)\r\n   $selfAsLink = false;\r\n   \r\n   // $showUnpubs [ true | false ]\r\n   // Decide to include items in unpublished folders. This will show the\r\n   // unpublished items as well. No links will be made for the unpublished items\r\n   // but they will be shown in the structure. You will not likely want to do\r\n   // this but the option is yours.\r\n   $showUnpubs = false;\r\n\r\n// Styles\r\n//\r\n// .LSM_currentPage    span surrounding current page if $selfAsLink is false\r\n// .LSM_description    description of page\r\n// .LSM_N              ul style where N is the level of nested list- starting at 0\r\n\r\n// ###########################################\r\n// End config, the rest takes care of itself #\r\n// ###########################################\r\n\r\n// Initialize\r\n$siteMapRoot = (isset($LSM_root))? $LSM_root : $siteMapRoot ;\r\n$maxLevels = (isset($LSM_levels))? $LSM_levels : $maxLevels ;\r\n$ie = ($removeNewLines)? '''' : "\\n" ;\r\n\r\n// Overcome single use limitation on functions\r\nglobal $MakeMapDefined;\r\n\r\nif(!isset($MakeMapDefined)){\r\n  function MakeMap($funcEtomite, $listParent, $listLevel, $description, $titleOfLinks,$maxLevels,$su){\r\n    $children = $funcEtomite->getAllChildren($listParent, ''menuindex'', ''ASC'', ''id, pagetitle, description, parent, alias, longtitle, published'');\r\n    $output .= ''<ul class="LSM_''.$listLevel.''">''.$ie;\r\n    foreach($children as $child){\r\n    \r\n      // skip unpubs unless desired\r\n      if (!$su && !$child[''published'']) continue;\r\n      \r\n      $descText = ($description)? '' <span class="LSM_description">''.$child[''description''].''</span>'' : '''';\r\n      $output .= ''<li>'';\r\n      if (!$selfAsLink && ($child[''id''] == $funcEtomite->documentIdentifier)){\r\n        $output .= ''<span class="LSM_currentPage">''.$child[''pagetitle''].''</span>'';\r\n      } else if (!$child[''published'']){\r\n        $output .= ''<span class="LSM_unpubPage">''.$child[''pagetitle''].''</span>'';\r\n      } else {\r\n        $output .= ''<a href="[~''.$child[''id''].''~]" title="''.$child[$titleOfLinks].''">''.$child[''pagetitle''].''</a>'';\r\n      }\r\n      $output .= $descText;\r\n      if ($funcEtomite->getAllChildren($child[''id'']) && (($maxLevels==0) || ($maxLevels > $listLevel+1 ))){\r\n        $output .= MakeMap($funcEtomite,$child[''id''],$listLevel+1,$description,$titleOfLinks,$maxLevels,$su);\r\n      }\r\n      $output .= ''</li>''.$ie;\r\n    }\r\n    $output .= ''</ul>''.$ie;\r\n    return $output;\r\n  }\r\n  $MakeMapDefined = true;\r\n}\r\n\r\nreturn MakeMap($etomite, $siteMapRoot, 0, $showDescription, $titleOfLinks,$maxLevels,$showUnpubs);', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (21, 'Copyright', 'Returns a copyright statement', '/*\r\nSnippet name: Copyright\r\nSnippet description: Returns a copyright statement\r\nRevision: 1.1 ships with Etomite 0.6.1-Final\r\n\r\nDescription:\r\n  Returns a copyright statement of the form:\r\n    ''Copyright (c) 2006 by Lloyd Borrett. All rights reserved.''\r\n    ''Copyright (c) 2005-2006 by Lloyd Borrett. All rights reserved.''\r\n    ''Copyright (c) 2005-2006. All rights reserved.''\r\n\r\n  (Note: the (c) is replaced with the actual copyright symbol character.\r\n         the ''-'' is replaced with an en dash.)\r\n\r\n  The year range being from either a site start year (if provided) \r\n  to the current year, or from the year the document was created \r\n  to the current year. All year values are based on local time \r\n  using the Etomite server offset time configuration setting.\r\n  The copyright holder can be the one entity for the \r\n  whole web site (if provided), or the author of the current\r\n  document (if provided).\r\n\r\nSnippet Author:\r\n  Lloyd Borrett (lloyd@borrett.id.au)\r\n  \r\nSnippet Category:\r\n  Miscellaneous\r\n\r\nSee in use at:\r\n  www.raydon.com.au           \r\n\r\nUsage:\r\n  Insert [[Copyright]] anywhere in the appropriate section\r\n  of your template. (Usually the footer.)\r\n*/\r\n\r\n// *** Configuration Settings ***\r\n\r\n// Start Year of the web site.\r\n// To use the document creation date, set this to ''''\r\n$site_start_year = '''';\r\n\r\n// Copyright holder for the whole web site.\r\n// To use the document author details of each document, set this to ''''\r\n$site_copyholder = $etomite->config[''site_name''];\r\n\r\n// *** Start\r\n\r\n// Get the document details.\r\n\r\n$docInfo = $etomite->getDocument($etomite->documentIdentifier);\r\n\r\n// *** AUTHOR ***\r\nif ($site_copyholder == '''') {\r\n   $authorid = $docInfo[''createdby''];\r\n   $tbl = $etomite->dbConfig[''dbase''].".".$etomite->dbConfig[''table_prefix'']."user_attributes";\r\n   $query = "SELECT fullname FROM $tbl WHERE $tbl.id = $authorid"; \r\n   $rs = $etomite->dbQuery($query);\r\n   $limit = $etomite->recordCount($rs); \r\n   if($limit=1) {\r\n      $resourceauthor = $etomite->fetchRow($rs); \r\n      $authorname = $resourceauthor[''fullname''];  \r\n   }\r\n   // Trim and replace double quotes with entity\r\n   $copyholder = str_replace(''"'', ''&#34;'', trim($authorname));\r\n} else {\r\n   $copyholder = $site_copyholder;\r\n}\r\n\r\n// *** COPYRIGHT ***\r\n// get the Etomite server offset time in seconds\r\n$server_offset_time = $etomite->config[''server_offset_time''];\r\nif (!$server_offset_time) {\r\n  $server_offset_time = 0;\r\n}\r\n// get the current time and apply the offset\r\n$timestamp = time() + $server_offset_time;\r\n// Set the current year\r\n$today_year = date(''Y'',$timestamp);\r\n$createdon = date(''Y'',$docInfo[''createdon'']);\r\nif ($site_start_year == '''') {\r\n   if ($today_year != $createdon) {\r\n      $copydate = $createdon."&#8211;".$today_year;\r\n   } else {\r\n      $copydate = $today_year;\r\n   }\r\n} else {\r\n   if ($today_year != $site_start_year) {\r\n      $copydate = $site_start_year."&#8211;".$today_year;\r\n   } else {\r\n      $copydate = $today_year;\r\n   }\r\n}\r\nif ($copyholder == '''') {\r\n   $copyname = $copyholder;\r\n} else {\r\n   $copyname = " by ".$copyholder;\r\n}\r\n\r\n// *** BUILD COPYRIGHT STATEMENT & RETURN RESULTS ***\r\n\r\n$Copyright = "Copyright &#169; ";\r\n$Copyright .= $copydate.$copyname.". All rights reserved.";\r\n\r\nreturn $Copyright;', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (22, 'MetaTagsExtra', 'Output page related meta tags', '/*\r\nSnippet Title:     MetaTagsExtra\r\nSnippet Version:   2.2\r\nEtomite Version:   0.6 +\r\n\r\nDescription:\r\n  Returns XHTML for document meta tags: \r\n     Content-Type, Content-Language, Generator,\r\n     Title, Description, Keywords, Abstract, Author, Copyright, \r\n     Robots, Googlebot, Cache-Control, Pragma, Expires, Last Modified,\r\n     Distribution and Rating.\r\n  Can also return XHTML for Dublin Core Metadata Initiative meta tags:\r\n     DC.format, DC.language, DC.title, \r\n     DC.description, DC.subject, DC.title.alternative,\r\n     DC.publisher, DC.creator, DC.rights,\r\n     DC.date.created, DC.date.modified, DC.date.valid and DC.identifier.\r\n  Can also return the GeoURL and GeoTags meta tags:\r\n     DC.title, ICBM, geo.position, geo.placename and geo.region.\r\n\r\nSnippet Author:\r\n  Miels with mods by Lloyd Borrett (lloyd@borrett.id.au)\r\n\r\nVersion History:\r\n  1.3 - Lloyd Borrett added the Robots meta tag based \r\n  on the idea in the SearchableSE snippet by jaredc\r\n\r\n  1.4 - Lloyd Borrett added the Abstract meta tag\r\n  based on the Site Name and the Long Title.\r\n  Also added the Generator meta tag based on the Etomite version details.\r\n  The Robots meta tag is now only output if the document is non-searchable,\r\n  to reduce XHTML bloat. The Googlebot meta tag is now also output \r\n  when the document is non-searchable.\r\n\r\n  1.5 - Lloyd Borrett added no-cache directives via the Cache-Control \r\n  and Pragma meta tags if the document is non-cacheable.\r\n  Abstract meta tag uses the document description if long title not set.\r\n  Cleaned up some other tests.\r\n\r\n  1.6 - 2006-01-26 - Lloyd Borrett cleaned up some code.\r\n\r\n  1.7 - 2006-01-27 - Lloyd Borrett\r\n  Added support for the Distribution and Rating meta tags.\r\n  Copyright meta tag can now include a year range being from either \r\n  a site creation year to the current year, or from the year the \r\n  document was created to the current year, e.g. 2005-2006.\r\n  Added ability to specify a site wide author, and thus be able to\r\n  skip looking up document author details.\r\n\r\n  1.8 - 2006-01-27 - Lloyd Borrett\r\n  Current year now based on local time using the Etomite\r\n  Server Offset Time configuration setting\r\n\r\n  1.9 - 2006-03-08 - Lloyd Borrett\r\n  Dates in meta tags can be output in your choice of ISO 8601\r\n  or RFC 822 formats.\r\n  Dates in the meta tags are now corrected to local time.\r\n  Fixed problem with the generation of the "description" meta tag.\r\n\r\n  2.0 - 2006-03-10 - Lloyd Borrett\r\n  Moved the generation of the "content-type", "content-language" \r\n  and "title" meta tags into this snippet.\r\n  Added in support for the Dublin Core Metadata Initiative meta tags.\r\n\r\n  2.1 - 2006-03-15 - Lloyd Borrett\r\n  Dropped the choice of date formats. Dublin Core tags now use ISO dates. \r\n  Others tags use RFC 822 dates. This is what is properly supported.\r\n  Added in support for GeoURL (www.geourl.org) and \r\n  GeoTags (www.geotags.com) meta tags.\r\n\r\n  2.2 - 2006-04-07 - Lloyd Borrett\r\n  Get the base URL from Etomite instead of it being a configuration option.\r\n   \r\nSnippet Category:\r\n  Search Engines           \r\n\r\nUsage:\r\n  Insert [[MetaTagsExtra]] anywhere in the head section of your template.\r\n  Don''t forget to set the full name of all document authors.\r\n  You can find it at "Manage users" -> your username -> "full name".\r\n  This value is used for the Author and Copyright meta tags.\r\n\r\n  When you mark a page as "NOT searchable" - a Robots meta tag \r\n  with "noindex, nofollow" is inserted to keep web search engines\r\n  from indexing that document. After all, there''s little value in \r\n  making your Etomite document unsearchable to Etomite, when \r\n  Google still knows where it is! For "searchable" documents, no\r\n  Robots meta tag is inserted. The default is "index, follow", so not\r\n  putting it in reduced HTML bloat.\r\n  A Googlebot meta tag with "noindex, nofollow, noarchive, nosnippet"\r\n  is also output, to tell Google to clean out its cache.\r\n\r\n  When you mark a page as "non cacheable", no-cache directives \r\n  are inserted via the Cache-Control and Pragma meta tags.\r\n*/\r\n\r\n// *** Configuration Settings ***\r\n\r\n// Provide the content type setting.\r\n$content_type = "text/html; charset=iso-8859-1";\r\n\r\n// Provide the language setting.\r\n$language = "en";\r\n\r\n// Distribution can be "global", "local" or "iu"\r\n// If you want no Distribution meta tag use ''''\r\n$distribution = ''global'';\r\n\r\n// Rating can be "14 years", "general", "mature", "restricted" or "safe for kids"\r\n// If you want no Rating meta tag use ''''\r\n$rating = ''general'';\r\n\r\n// Start Date of the web site as used for the copyright meta tag\r\n// To use the document creation date, set this to ''''\r\n$site_start_year = '''';\r\n\r\n// Site Author can be used for the Author and Copyright meta tags\r\n// To use the document author details of each document, set this to ''''\r\n$site_author = $etomite->config[''site_name''];\r\n\r\n// Provide the full URL of your web site.\r\n// For example: http://www.yourdomain.com\r\n// NOTE: Do not put a / on the end of the web site URL.\r\n// Used to build the DC.identifier tag\r\nglobal $ETOMITE_PAGE_BASE;\r\n$websiteurl = $ETOMITE_PAGE_BASE[''www''];\r\n\r\n// Provide the latitude of the resource\r\n$latitude = "";\r\n\r\n// Provide the longitude of the resource\r\n$longitude = "";\r\n\r\n// Provide the place name of the resource\r\n$placename = "";\r\n\r\n// Provide the ISO 3166 region code of the resource\r\n$region = "";\r\n\r\n// DC Tags is used to specify if the Dublin Core Metadata Initiative \r\n// meta tags should also be generated.\r\n// Set to true to generate them, false otherwise.\r\n$dc_tags = true;\r\n\r\n// Geo Tags is used to specify if the Geo Tags \r\n// meta tags should also be generated.\r\n// Set to true to generate them, false otherwise.\r\n$geo_tags = true;\r\n\r\n\r\n// Initialise variables\r\n\r\n$MetaType = "";\r\n$MetaLanguage = "";\r\n$MetaTitle = "";\r\n$MetaGenerator = "";\r\n$MetaDesc = "";\r\n$MetaKeys = "";\r\n$MetaAbstract = "";\r\n$MetaAuthor = "";\r\n$MetaCopyright = "";\r\n$MetaRobots = "";\r\n$MetaGooglebot = "";\r\n$MetaCache = "";\r\n$MetaPragma = "";\r\n$MetaExpires = "";\r\n$MetaEditedOn = "";\r\n$MetaDistribution = "";\r\n$MetaRating = "";\r\n\r\n// The data format of the resource\r\n$DC_format = "";\r\n\r\n// The language of the content of the resource\r\n$DC_language = "";\r\n\r\n// The name given to the resource\r\n$DC_title = "";\r\n\r\n// A textual description of the content and/or purpose of the resource\r\n// Equivalent to "description"\r\n$DC_description = "";\r\n\r\n// The subject and topic of the resource that succinctly \r\n// describes the content of the resource.\r\n// Equivalent to "keywords"\r\n$DC_subject = "";\r\n\r\n// Any form of the title used as a substitute or alternative \r\n// to the formal title of the resource.\r\n// Equivalent to "abstract"\r\n$DC_title_alternative = "";\r\n\r\n// The name of the entity responsible for making the resource available\r\n// Equivalent to "author"\r\n$DC_publisher = "";\r\n\r\n// An entity primarily responsible for making the content of the resource\r\n// Equivalent to "author"\r\n$DC_creator = "";\r\n\r\n// A statement or pointer to a statement about the \r\n// rights management information for the resource\r\n// Equivalent to "copyright"\r\n$DC_rights = "";\r\n\r\n// The date the resource was created in its current form\r\n$DC_date_created = "";\r\n\r\n// The date the resource was last modified or updated\r\n$DC_date_modified = "";\r\n\r\n// The date of validity of the resource.\r\n// Specified as from the creation date to the expiry date\r\n$DC_date_valid = "";\r\n\r\n// A unique identifier for the resource\r\n$DC_identifier = "";\r\n\r\n\r\n// The latitude and longitude of the resource\r\n$Geo_position = "";\r\n\r\n// The latitude and longitude of the resource\r\n$Geo_icbm = "";\r\n\r\n// The place name of the resource\r\n$Geo_placename = "";\r\n\r\n// The region of the resource\r\n$Geo_region = "";\r\n\r\n\r\n// *** FUNCTIONS ***\r\n\r\nfunction get_local_GMT_offset($server_offset_time) {\r\n    // Get the local GMT offset when given the\r\n    // local to Etomite server offset time in seconds\r\n    $GMT_offset = date("O");\r\n    $GMT_hr = substr($GMT_offset,1,2);\r\n    $GMT_min = substr($GMT_offset,4,2);\r\n    $GMT_sign = substr($GMT_offset,0,1);\r\n    $GMT_secs = (intval($GMT_hr) * 3600) + (intval($GMT_min) * 60);\r\n    if ($GMT_sign == ''-'') { $GMT_secs = $GMT_secs * (-1); }\r\n\r\n    // Get the local GMT offset in seconds\r\n    $GMT_local_seconds = $GMT_secs + $server_offset_time;\r\n    $GMT_local_secs = abs($GMT_local_seconds);\r\n\r\n    // round down to the number of hours\r\n    $GMT_local_hours = intval($GMT_local_secs / 3600);\r\n    // round down to the number of minutes\r\n    $GMT_local_minutes = intval(($GMT_local_secs - ($GMT_local_hours * 3600)) / 60);\r\n    if ($GMT_local_seconds < 0) {\r\n      $GMT_value = "-";\r\n    } else {\r\n      $GMT_value = "+";\r\n    }\r\n    $GMT_value .= sprintf("%02d:%02d", $GMT_local_hours, $GMT_local_minutes);\r\n    return $GMT_value;\r\n}\r\n\r\nfunction get_local_iso_8601_date($int_date, $server_offset_time) {\r\n    // Return an ISO 8601 style local date\r\n    // $int_date: current date in UNIX timestamp\r\n    $GMT_value = get_local_GMT_offset($server_offset_time);\r\n    $local_date = date("Y-m-d\\TH:i:s", $int_date + $server_offset_time);\r\n    $local_date .= $GMT_value;\r\n    return $local_date;\r\n}\r\n\r\nfunction get_local_rfc_822_date($int_date, $server_offset_time) {\r\n    // return an RFC 822 style local date\r\n    // $int_date: current date in UNIX timestamp\r\n    $GMT_value = get_local_GMT_offset($server_offset_time);\r\n    $local_date = date("D, d M Y H:i:s", $int_date + $server_offset_time);\r\n    $local_date .= " ".str_replace('':'', '''', $GMT_value);\r\n    return $local_date;\r\n}\r\n\r\n\r\n// *** Start Creating Meta Tags ***\r\n\r\n// *** CONTENT-TYPE ***\r\n$MetaType = " <meta http-equiv=\\"content-type\\" content=\\"".$content_type."\\" />\\n";\r\n\r\n// *** DC.FORMAT ***\r\nif ($dc_tags) {\r\n   $DC_format = " <meta name=\\"DC.format\\" content=\\"".$content_type."\\" />\\n";\r\n}\r\n\r\n\r\n// *** CONTENT-LANGUAGE ***\r\n$MetaLanguage = " <meta http-equiv=\\"content-language\\" content=\\"".$language."\\" />\\n";\r\n\r\n// *** DC.LANGUAGE ***\r\nif ($dc_tags) {\r\n   $DC_language = " <meta name=\\"DC.language\\" content=\\"".$language."\\" />\\n";\r\n}\r\n\r\n// *** GENERATOR ***\r\n$version = $etomite->getVersionData();\r\n$version[''version''] = trim($version[''version'']);\r\n$version[''code_name''] = trim($version[''code_name'']);\r\nif (($version[''version''] != "") || ($version[''code_name''] != "")) {\r\n   $MetaGenerator = " <meta name=\\"generator\\" content=\\"Etomite";\r\n   if($version[''version''] != ""){\r\n      $MetaGenerator .= " ".$version[''version''];\r\n   }\r\n   if($version[''code_name''] != ""){\r\n      $MetaGenerator .= " (".$version[''code_name''].")";\r\n   }\r\n   $MetaGenerator .= "\\" />\\n";\r\n}\r\n\r\n$docInfo = $etomite->getDocument($etomite->documentIdentifier);\r\n\r\n// *** DESCRIPTION ***\r\n// Trim and replace double quotes with entity\r\n$description = $docInfo[''description''];\r\n$description = str_replace(''"'', ''&#34;'', trim($description)); \r\nif(!$description == ""){\r\n   $MetaDesc = " <meta name=\\"description\\" content=\\"$description\\" />\\n";\r\n\r\n// *** DC.DESCRIPTION ***\r\n   if ($dc_tags) {\r\n      $DC_description = " <meta name=\\"DC.description\\"";\r\n      $DC_description .= " content=\\"$description\\" />\\n";\r\n   }\r\n}\r\n\r\n// *** KEYWORDS ***\r\n$keywords = $etomite->getKeywords();\r\nif(count($keywords)>0) {\r\n   $keys = join($keywords, ", ");\r\n   $MetaKeys = " <meta name=\\"keywords\\" content=\\"$keys\\" />\\n";\r\n\r\n// *** DC.SUBJECT ***\r\n   if ($dc_tags) {\r\n      $keys = join($keywords, "; ");\r\n      $DC_subject = " <meta name=\\"DC.subject\\"";\r\n      $DC_subject .= " content=\\"$keys\\" />\\n";\r\n   }\r\n}\r\n\r\n// *** ABSTRACT ***\r\n// Use the Site Name and the documents Long Title (or Description)  \r\n// to build an Abstract meta tag.\r\n$sitename = $etomite->config[''site_name''];\r\n// Trim and replace double quotes with entity\r\n$sitename = str_replace(''"'', ''&#34;'', trim($sitename)); \r\n\r\n$abstract = trim($docInfo[''longtitle'']);\r\nif($abstract == ""){\r\n   $abstract = $description;\r\n}\r\n// Replace double quotes with entity\r\n$abstract = str_replace(''"'', ''&#34;'', $abstract); \r\n\r\nif(($sitename != "") || ($abstract != "")) {\r\n   $separator = " - ";\r\n   if($sitename == ""){\r\n      $separator = "";\r\n   }\r\n   $MetaAbstract = " <meta name=\\"abstract\\" content=\\"".$sitename.$separator.$abstract."\\" />\\n";\r\n\r\n// *** DC.TITLE.ALTERNATIVE ***\r\n   if ($dc_tags) {\r\n      $DC_title_alternative = " <meta name=\\"DC.title.alternative\\"";\r\n      $DC_title_alternative .= " content=\\"".$sitename.$separator.$abstract."\\" />\\n";\r\n   }\r\n}\r\n\r\n// *** TITLE ***\r\n// Use the Site Name and the documents Page Title and Long Title  \r\n// to build the Title meta tag.\r\n\r\n// Start with the site name\r\n$title = $sitename;\r\n// Get the pagetitle, trim and replace double quotes with entity\r\n$pagetitle = str_replace(''"'', ''&#34;'', trim($docInfo[''pagetitle''])); \r\nif ($pagetitle != "") {\r\n   if ($title == "") {\r\n      $title = $pagetitle;\r\n   } else {\r\n      $title .= " - ".$pagetitle;\r\n   }\r\n}\r\n// Get the longtitle, trim and replace double quotes with entity\r\n$longtitle = str_replace(''"'', ''&#34;'', trim($docInfo[''longtitle''])); \r\nif ($longtitle != "") {\r\n   if ($title == "") {\r\n      $title = $longtitle;\r\n   } else {\r\n      $title .= " - ".$longtitle;\r\n   }\r\n}\r\nif ($title != "") {\r\n   $MetaTitle = " <title>".$title."</title>\\n";\r\n\r\n// *** DC.TITLE ***\r\n   if ($dc_tags || $geo_tags) {\r\n      $DC_title = " <meta name=\\"DC.title\\"";\r\n      $DC_title .= " content=\\"".$title."\\" />\\n";\r\n   }\r\n}\r\n\r\n// *** AUTHOR ***\r\nif ($site_author == '''') {\r\n   $authorid = $docInfo[''createdby''];\r\n   $tbl = $etomite->dbConfig[''dbase''].".".$etomite->dbConfig[''table_prefix'']."user_attributes";\r\n   $query = "SELECT fullname FROM $tbl WHERE $tbl.id = $authorid"; \r\n   $rs = $etomite->dbQuery($query);\r\n   $limit = $etomite->recordCount($rs); \r\n   if($limit=1) {\r\n      $resourceauthor = $etomite->fetchRow($rs); \r\n      $authorname = $resourceauthor[''fullname''];  \r\n   }\r\n   // Trim and replace double quotes with entity\r\n   $authorname = str_replace(''"'', ''&#34;'', trim($authorname));\r\n} else {\r\n   $authorname = $site_author;\r\n}\r\nif (!$authorname == ""){\r\n   $MetaAuthor = " <meta name=\\"author\\" content=\\"$authorname\\" />\\n";\r\n\r\n// *** DC.PUBLISHER & DC.CREATOR ***\r\n   if ($dc_tags) {\r\n      $DC_publisher = " <meta name=\\"DC.publisher\\" content=\\"$authorname\\" />\\n";\r\n      $DC_creator = " <meta name=\\"DC.creator\\" content=\\"$authorname\\" />\\n";\r\n   }\r\n}\r\n\r\n// *** COPYRIGHT ***\r\n// get the Etomite server offset time in seconds\r\n$server_offset_time = $etomite->config[''server_offset_time''];\r\nif (!$server_offset_time) {\r\n   $server_offset_time = 0;\r\n}\r\n\r\n// get the current time and apply the offset\r\n$timestamp = time() + $server_offset_time;\r\n// Set the current year\r\n$today_year = date(''Y'',$timestamp);\r\n$createdon = date(''Y'',$docInfo[''createdon'']);\r\nif ($site_start_year == '''') {\r\n   if ($today_year != $createdon) {\r\n      $copydate = $createdon."&#8211;".$today_year;\r\n   } else {\r\n      $copydate = $today_year;\r\n   }\r\n} else {\r\n   if ($today_year != $site_start_year) {\r\n      $copydate = $site_start_year."&#8211;".$today_year;\r\n   } else {\r\n      $copydate = $today_year;\r\n   }\r\n}\r\nif ($authorname == '''') {\r\n   $copyname = $authorname;\r\n} else {\r\n   $copyname = " by ".$authorname;\r\n}\r\n$MetaCopyright = " <meta name=\\"copyright\\" content=\\"Copyright &#169; ";\r\n$MetaCopyright .= $copydate.$copyname.". All rights reserved.\\" />\\n";\r\n\r\n// *** DC.RIGHTS ***\r\nif ($dc_tags) {\r\n   $DC_rights = " <meta name=\\"DC.rights\\" content=\\"Copyright &#169; ";\r\n   $DC_rights .= $copydate.$copyname.". All rights reserved.\\" />\\n";\r\n}\r\n\r\n// *** ROBOTS and GOOGLEBOT ***\r\n// Determine if this document has been set to non-searchable.\r\n// As the default for the Robots and Googlebot Meta Tags are index and follow,\r\n// these tags are only needed when we don''t want the document searched. \r\nif(!$etomite->documentObject[''searchable'']){\r\n   $MetaRobots = " <meta name=\\"robots\\" content=\\"noindex, nofollow\\" />\\n";\r\n   $MetaGooglebot = " <meta name=\\"googlebot\\" content=\\"noindex, nofollow, noarchive, nosnippet\\" />\\n";\r\n}\r\n\r\n// *** CACHE-CONTROL and PRAGMA ***\r\n// Output no-cache directives via the Cache-Control and Pragma meta tags\r\n// if this document is set to non-cacheable. \r\n$cacheable = $docInfo[''cacheable''];\r\nif (!$cacheable) {\r\n   $MetaCache = " <meta http-equiv=\\"cache-control\\" content=\\"no-cache\\" />\\n";\r\n   $MetaPragma = " <meta http-equiv=\\"pragma\\" content=\\"no-cache\\" />\\n";\r\n}\r\n\r\n// *** DC.DATE.CREATED ***\r\nif ($dc_tags) {\r\n   $createdon = get_local_iso_8601_date($docInfo[''createdon''], $server_offset_time);\r\n   $created = substr($createdon,0,10);\r\n   $DC_date_created = " <meta name=\\"DC.date.created\\" content=\\"";\r\n   $DC_date_created .= $created."\\" />\\n";\r\n}\r\n\r\n// *** EXPIRES ***\r\n$unpub_date = $docInfo[''unpub_date''];\r\nif ($unpub_date > 0) {\r\n   $unpubdate = get_local_rfc_822_date($unpub_date, $server_offset_time);\r\n   $MetaExpires = " <meta http-equiv=\\"expires\\" content=\\"$unpubdate\\" />\\n";\r\n\r\n// *** DC.DATE.VALID ***\r\n   if ($dc_tags) {\r\n      $dcunpubdate = get_local_iso_8601_date($unpub_date, $server_offset_time);\r\n      $valid = substr($dcunpubdate,0,10);\r\n      $DC_date_valid = " <meta name=\\"DC.date.valid\\" content=\\"";\r\n      $DC_date_valid .= $created."/".$valid."\\" />\\n";\r\n   }\r\n}\r\n\r\n// *** LAST MODIFIED ***\r\n$editedon = get_local_rfc_822_date($docInfo[''editedon''], $server_offset_time);\r\n$MetaEditedOn = " <meta http-equiv=\\"last-modified\\" content=\\"$editedon\\" />\\n";\r\n\r\n// *** DC.DATE.MODIFIED ***\r\nif ($dc_tags) {\r\n   $dceditedon = get_local_iso_8601_date($docInfo[''editedon''], $server_offset_time);\r\n   $modified = substr($dceditedon,0,10);\r\n   $DC_date_modified = " <meta name=\\"DC.date.modified\\" content=\\"";\r\n   $DC_date_modified .= $modified."\\" />\\n";\r\n}\r\n\r\n// *** DISTRIBUTION ***\r\nif (!$distribution == '''') {\r\n   $MetaDistribution = " <meta name=\\"distribution\\" content=\\"".$distribution."\\" />\\n";\r\n}\r\n\r\n// *** RATING ***\r\nif (!$rating == '''') {\r\n   $MetaRating = " <meta name=\\"rating\\" content=\\"".$rating."\\" />\\n";\r\n}\r\n\r\nif ($dc_tags) {\r\n\r\n// *** DC.IDENTIFIER ***\r\n   $url = $websiteurl."[~".$etomite->documentIdentifier."~]";\r\n   $DC_identifier = " <meta name=\\"DC.identifier\\" content=\\"".$url."\\" />\\n";\r\n}\r\n\r\n\r\nif ($geo_tags) {\r\n   if (($latitude != "") && (longitude != "")) {\r\n\r\n// *** GEO.ICBM ***\r\n      $Geo_icbm = " <meta name=\\"ICBM\\"";\r\n      $Geo_icbm .= " content=\\"".$latitude.", ".$longitude."\\" />\\n";\r\n\r\n// *** GEO.POSITION ***\r\n      $Geo_position = " <meta name=\\"geo.position\\"";\r\n      $Geo_position .= " content=\\"".$latitude.";".$longitude."\\" />\\n";\r\n   }\r\n\r\n   if ($region != "") {\r\n\r\n// *** GEO.REGION ***\r\n      $Geo_region = " <meta name=\\"geo.region\\"";\r\n      $Geo_region .= " content=\\"".$region."\\" />\\n";\r\n   }\r\n\r\n   if ($placename != "") {\r\n\r\n// *** GEO.PLACENAME ***\r\n      $Geo_placename = " <meta name=\\"geo.placename\\"";\r\n      $Geo_placename .= " content=\\"".$placename."\\" />\\n";\r\n   }\r\n\r\n}\r\n\r\n\r\n// *** RETURN RESULTS ***\r\n\r\n$output = $MetaType.$MetaLanguage.$MetaGenerator;\r\n$output .= $MetaTitle.$MetaDesc.$MetaKeys;\r\n$output .= $MetaAbstract.$MetaAuthor.$MetaCopyright;\r\n$output .= $MetaRobots.$MetaGooglebot;\r\n$output .= $MetaCache.$MetaPragma.$MetaExpires.$MetaEditedOn;\r\n$output .= $MetaDistribution.$MetaRating;\r\n\r\nif ($dc_tags) {\r\n  $dc_output = $DC_format.$DC_language.$DC_title;\r\n  $dc_output .= $DC_description.$DC_subject.$DC_title_alternative;\r\n  $dc_output .= $DC_publisher.$DC_creator.$DC_rights;\r\n  $dc_output .= $DC_date_created.$DC_date_modified.$DC_date_valid;\r\n  $dc_output .= $DC_identifier;\r\n  if ($dc_output != "") {\r\n    $output .= " \\n".$dc_output;\r\n  }\r\n}\r\nif ($geo_tags) {\r\n  $geo_output = "";\r\n  if (!$dc_tags) {\r\n    $geo_output .= $DC_title;\r\n  }\r\n  $geo_output .= $Geo_icbm;\r\n  $geo_output .= $Geo_position.$Geo_region.$Geo_placename;\r\n  if ($geo_output != "") {\r\n    $output .= " \\n".$geo_output;\r\n  }\r\n}\r\n\r\nreturn $output;', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (23, 'GoogleSiteMap_XML', 'Output a Google XML site map', '/**\r\n * GoogleSiteMap_XML Snippet for Etomite CMS\r\n * Version 0.8 2006-11-17\r\n *\r\n * Parameters:\r\n * [!GoogleSiteMap_XML?validate=true!] or [!GoogleSiteMap_XML?validate=1!]\r\n * tells the snippet to output the additional headers required to validate \r\n * your Sitemap file against a schema.\r\n *\r\n * Useage:\r\n * Create a snippet: GoogleSiteMap_XML\r\n * with the content of this file.\r\n * Update the configuration options below to suit your needs.\r\n * Create a template: GoogleSiteMap_Template \r\n * with the content "[!GoogleSiteMap_XML!]".\r\n * Create a page in your repository: Google Site Map\r\n * with no content, the alias "google-sitemap",\r\n * using the GoogleSiteMap_Template, not searchable,\r\n * not cacheable, with content type "text/xml".\r\n *\r\n * Goto the Google Webaster Tools site at https://www.google.com/webmasters/tools/\r\n * Create an account, or login using your existing account.\r\n * Enter http://www.<your domain name>/ in the add site box and click OK.\r\n * Click on "Verify your site".\r\n * Choose "Add a META tag" as your verification option.\r\n * Add the generated meta tag to the head section of your home page template.\r\n * Back in Google Webmaster Tools, click on "Verify".\r\n * Click on the "Sitemaps" button.\r\n * Click on "Add a Sitemap".\r\n * Select "Add General Web Sitemap".\r\n * Enter "http://www.<your domain name>/google-sitemap.htm" as your sitemap URL.\r\n * Click on "Add Web Sitemap".\r\n *\r\n * \r\n * Ryan Nutt - http://blog.nutt.net\r\n * v0.1 - June 4, 2005\r\n * v0.2 - June 5, 2005 - Fixed a stupid mistake :-)\r\n * \r\n * Changes by Lloyd Borrett - http://www.borrett.id.au\r\n *\r\n * v0.3 - Sep 22, 2005\r\n * Only list searchable pages (Mod suggested by mplx)\r\n * Added configuration settings.\r\n * Made the site URL a configuration option.\r\n * Made displaying lastmoddate, priority and/or changefreq optional.\r\n * Added ability to display long date & time for lastmoddate\r\n * Made the long or short timeformat optional.\r\n * \r\n * v0.4 - 05-Feb-2006\r\n * Changed the snippet to output the local time for all date values\r\n * based on the Etomite server offset time\r\n * \r\n * v0.5 - 15-Feb-2006\r\n * Fixed incorrect local GMT offset value\r\n * \r\n * v0.6 - 7-Apr-2006\r\n * Get the base URL from Etomite instead of it being a configuration option.\r\n * \r\n * v0.7 - 30-Apr-2006\r\n * Get the base URL from Etomite using the new available \r\n * method built in to Etomite 0.6.1 Final. If using an earlier\r\n * version of Etomite, you''ll still need to provide the URL\r\n * as a configuration option.\r\n * \r\n * v0.8 - 17-Nov-2006\r\n * Updated to identify itself as using the Sitemap 0.9 protocol.\r\n * Added ability to force the change frequency to a set value for all documents.\r\n * Added ability to output the additional headers required to validate the sitemap format.\r\n * Additional comments added.\r\n * Code layout made consistent.\r\n * \r\n * Based on the ListSiteMap snippet by\r\n * JaredDC\r\n * \r\n * datediff function from\r\n * www.ilovejackdaniels.com\r\n */ \r\n\r\n// Overcome single use limitation on functions\r\nglobal $MakeMapDefined;\r\n\r\n// Get the validate parameter, if any\r\n$validateschema = false;\r\nif (isset($validate)) {\r\n   if (($validate == "1") || ($validate == "true")) {\r\n       $validateschema = true;\r\n   }\r\n}\r\n\r\n// Determine values required to convert the lastmod date and\r\n// time to local time. \r\n// get the Etomite server offset time in seconds\r\nglobal $server_offset_time;\r\nglobal $GMT_value;\r\n$server_offset_time = $etomite->config[''server_offset_time''];\r\nif (!$server_offset_time) {\r\n    $server_offset_time = 0;\r\n} \r\n\r\n// Get the server GMT offset in seconds\r\n$GMT_offset = date("O");\r\n$GMT_hr = substr($GMT_offset, 1, 2);\r\n$GMT_min = substr($GMT_offset, 4, 2);\r\n$GMT_sign = substr($GMT_offset, 0, 1);\r\n$GMT_secs = (intval($GMT_hr) * 3600) + (intval($GMT_min) * 60);\r\nif ($GMT_sign == ''-'') {\r\n    $GMT_secs = $GMT_secs * (-1);\r\n} \r\n\r\n// Get the local GMT offset in seconds\r\n$GMT_local_seconds = $GMT_secs + $server_offset_time;\r\n$GMT_local_secs = abs($GMT_local_seconds); \r\n// round down to the number of hours\r\n$GMT_local_hours = intval($GMT_local_secs / 3600); \r\n// round down to the number of minutes\r\n$GMT_local_minutes = intval(($GMT_local_secs - ($GMT_local_hours * 3600)) / 60);\r\nif ($GMT_local_seconds < 0) {\r\n    $GMT_value = "-";\r\n} else {\r\n    $GMT_value = "+";\r\n} \r\n$GMT_value .= sprintf("%02d:%02d", $GMT_local_hours, $GMT_local_minutes);\r\n\r\nif (!function_exists(datediff)) {\r\n    function datediff($interval, $datefrom, $dateto, $using_timestamps = false)\r\n    {\r\n        /**\r\n         * $interval can be:\r\n         * yyyy - Number of full years\r\n         * q - Number of full quarters\r\n         * m - Number of full months\r\n         * y - Difference between day numbers\r\n         * (eg 1st Jan 2004 is "1", the first day. 2nd Feb 2003 is "33". The datediff is "-32".)\r\n         * d - Number of full days\r\n         * w - Number of full weekdays\r\n         * ww - Number of full weeks\r\n         * h - Number of full hours\r\n         * n - Number of full minutes\r\n         * s - Number of full seconds (default)\r\n         */\r\n\r\n        if (!$using_timestamps) {\r\n            $datefrom = strtotime($datefrom, 0);\r\n            $dateto = strtotime($dateto, 0);\r\n        } \r\n\r\n        $difference = $dateto - $datefrom; // Difference in seconds\r\n        \r\n        switch ($interval) {\r\n            case ''yyyy'': // Number of full years\r\n                $years_difference = floor($difference / 31536000);\r\n                if (mktime(date("H", $datefrom), date("i", $datefrom), date("s", $datefrom), date("n", $datefrom), date("j", $datefrom), date("Y", $datefrom) + $years_difference) > $dateto) {\r\n                    $years_difference--;\r\n                } \r\n                if (mktime(date("H", $dateto), date("i", $dateto), date("s", $dateto), date("n", $dateto), date("j", $dateto), date("Y", $dateto) - ($years_difference + 1)) > $datefrom) {\r\n                    $years_difference++;\r\n                } \r\n                $datediff = $years_difference;\r\n                break;\r\n\r\n            case "q": // Number of full quarters\r\n                $quarters_difference = floor($difference / 8035200);\r\n                while (mktime(date("H", $datefrom), date("i", $datefrom), date("s", $datefrom), date("n", $datefrom) + ($quarters_difference * 3), date("j", $dateto), date("Y", $datefrom)) < $dateto) {\r\n                    $months_difference++;\r\n                } \r\n                $quarters_difference--;\r\n                $datediff = $quarters_difference;\r\n                break;\r\n\r\n            case "m": // Number of full months\r\n                $months_difference = floor($difference / 2678400);\r\n                while (mktime(date("H", $datefrom), date("i", $datefrom), date("s", $datefrom), date("n", $datefrom) + ($months_difference), date("j", $dateto), date("Y", $datefrom)) < $dateto) {\r\n                    $months_difference++;\r\n                } \r\n                $months_difference--;\r\n                $datediff = $months_difference;\r\n                break;\r\n\r\n            case ''y'': // Difference between day numbers\r\n                $datediff = date("z", $dateto) - date("z", $datefrom);\r\n                break;\r\n\r\n            case "d": // Number of full days\r\n                $datediff = floor($difference / 86400);\r\n                break;\r\n\r\n            case "w": // Number of full weekdays\r\n                $days_difference = floor($difference / 86400);\r\n                $weeks_difference = floor($days_difference / 7); // Complete weeks\r\n                $first_day = date("w", $datefrom);\r\n                $days_remainder = floor($days_difference % 7);\r\n                $odd_days = $first_day + $days_remainder; // Do we have a Saturday or Sunday in the remainder?\r\n                if ($odd_days > 7) { // Sunday\r\n                    $days_remainder--;\r\n                } \r\n                if ($odd_days > 6) { // Saturday\r\n                    $days_remainder--;\r\n                } \r\n                $datediff = ($weeks_difference * 5) + $days_remainder;\r\n                break;\r\n\r\n            case "ww": // Number of full weeks\r\n                $datediff = floor($difference / 604800);\r\n                break;\r\n\r\n            case "h": // Number of full hours\r\n                $datediff = floor($difference / 3600);\r\n                break;\r\n\r\n            case "n": // Number of full minutes\r\n                $datediff = floor($difference / 60);\r\n                break;\r\n\r\n            default: // Number of full seconds (default)\r\n                $datediff = $difference;\r\n                break;\r\n        } \r\n\r\n        return $datediff;\r\n    } \r\n} \r\n\r\nif (!isset($MakeMapDefined)) {\r\n    function MakeMap($funcEtomite, $listParent)\r\n    {\r\n        global $server_offset_time;\r\n        global $GMT_value;\r\n\r\n        // ***********************************\r\n        // Configuration Settings \r\n        // ***********************************\r\n\r\n        // $websiteURL [string]\r\n        // Provide the full base path URL of your web site,\r\n        // or let Etomite get it (v0.6.1 Final).\r\n        // For example: http://www.yourdomain.com/\r\n        // NOTE: You must put a / on the end of the web site URL.\r\n        //\r\n        // Original hard coded way to specify $websiteURL\r\n        // $websiteurl = ''http://www.<your domain name>/''; \r\n        //\r\n        // Early Etomite way to get $websiteURL automatically\r\n        // $websiteurl = $etomite->config[''www_base_path''];\r\n        //\r\n        // Etomite 0.6.1 Final way to get $websiteURL automatically\r\n        global $ETOMITE_PAGE_BASE;\r\n        $websiteurl = $ETOMITE_PAGE_BASE[''www''];\r\n\r\n        // $showlastmoddate [true | false]\r\n        // You can choose to disable providing the last modification\r\n        // date, or get it from the documents.\r\n        // true  - Get time from documents\r\n        // false - Disabled, do not write it\r\n        $showlastmoddate = true; \r\n\r\n        // $showlongtimeformat [ true | false ]\r\n        // You can choose to provide the time format as:\r\n        // true  - Long time format (with time, e.g. 2006-09-29T13:43:51+11:00)\r\n        // false - Short time format (date only, e.g. 2006-11-17)\r\n        $showlongtimeformat = true; \r\n\r\n        // $showpriority [ true | false ]\r\n        // You can choose to disable prividing the priority\r\n        // of a document relative to the whole set of documents,\r\n        // or calculate it based on the date difference.\r\n        // true  - Provide the priority\r\n        // false - Disabled, do not write it\r\n        $showpriority = true; \r\n\r\n        // $showchangefreq [true | false]\r\n        // You can choose to disable prividing the update\r\n        // (change) frequency of a document relative to the\r\n        // whole set of documents, or calculate it based on\r\n        // the date difference.\r\n        // true  - Provide the change frequency\r\n        // false - Disabled, do not write it\r\n        $showchangefreq = true;\r\n\r\n        // $forcechangefreq [string]\r\n        // You can choose to force the change frequency for all \r\n        // documents to one of the valid values.\r\n        // By specifying nothing, the snippet will calculate the \r\n        // change frequency of a document relative to the\r\n        // whole set of documents, or calculate it based on\r\n        // the date difference.\r\n        // "always", "hourly", "daily", "weekly", "monthly",\r\n        // "yearly", "never" - Force this value for every document\r\n        // "" - Calculate change frequency from last mod date\r\n        $forcechangefreq = "";\r\n\r\n        // ***********************************\r\n        // END CONFIG SETTINGS\r\n        // THE REST SHOULD TAKE CARE OF ITSELF\r\n        // ***********************************\r\n\r\n        $children = $funcEtomite->getActiveChildren($listParent, "menuindex", "ASC", "id, editedon, searchable");\r\n        foreach($children as $child) {\r\n            $id = $child[''id''];\r\n            $url = $websiteurl . "[~" . $id . "~]";\r\n\r\n            $date = $child[''editedon''];\r\n            $lastmoddate = $date;\r\n            $date = date("Y-m-d", $date);\r\n\r\n            $searchable = $child[''searchable''];\r\n            if ($searchable) {\r\n                // Get the date difference\r\n                $datediff = datediff("d", $date, date("Y-m-d"));\r\n                if ($datediff <= 1) {\r\n                    $priority = "1.0";\r\n                    $update = "daily";\r\n                } elseif (($datediff > 1) && ($datediff <= 7)) {\r\n                    $priority = "0.75";\r\n                    $update = "weekly";\r\n                } elseif (($datediff > 7) && ($datediff <= 30)) {\r\n                    $priority = "0.50";\r\n                    $update = "weekly";\r\n                } else {\r\n                    $priority = "0.25";\r\n                    $update = "monthly";\r\n                } \r\n\r\n                $output .= "<url>\\n";\r\n\r\n                $output .= "<loc>$url</loc>\\n";\r\n\r\n                if ($showlastmoddate) {\r\n                    if (!$showlongtimeformat) {\r\n                        $lastmoddate = date("Y-m-d", $lastmoddate + $server_offset_time);\r\n                    } else {\r\n                        $lastmoddate = date("Y-m-d\\TH:i:s", $lastmoddate + $server_offset_time) . $GMT_value;\r\n                    } \r\n                    $output .= "<lastmod>$lastmoddate</lastmod>\\n";\r\n                } \r\n\r\n                if ($showchangefreq) {\r\n                    if ($forcechangefreq == "") {\r\n                        $output .= "<changefreq>$update</changefreq>\\n";\r\n                    } else {\r\n                        $output .= "<changefreq>$forcechangefreq</changefreq>\\n";\r\n                    }\r\n                } \r\n\r\n                if ($showpriority) {\r\n                    $output .= "<priority>$priority</priority>\\n";\r\n                } \r\n\r\n                $output .= "</url>\\n";\r\n            } \r\n\r\n            if ($funcEtomite->getActiveChildren($child[''id''])) {\r\n                $output .= MakeMap($funcEtomite, $child[''id'']);\r\n            } \r\n        } \r\n        return $output;\r\n    } \r\n    $MakeMapDefined = true;\r\n} \r\n\r\n$out = "<?xml version=\\"1.0\\" encoding=\\"UTF-8\\"?>\\n";\r\nif ($validateschema) {\r\n    $out .= "<urlset xmlns:xsi=\\"http://www.w3.org/2001/XMLSchema-instance\\"\\n";\r\n    $out .= "         xsi:schemaLocation=\\"http://www.sitemaps.org/schemas/sitemaps/0.9\\n";\r\n    $out .= "         http://www.sitemaps.org/schemas/sitemaps/sitemap.xsd\\"\\n";\r\n    $out .= "         xmlns=\\"http://www.sitemaps.org/schemas/sitemap/0.9\\">\\n";\r\n} else {\r\n    // $out .= "<urlset xmlns=\\"http://www.google.com/schemas/sitemap/0.84\\">\\n";\r\n    $out .= "<urlset xmlns=\\"http://www.sitemaps.org/schemas/sitemap/0.9\\">\\n";\r\n}\r\n\r\n// Produce the sitemap for the main web site\r\n$out .= MakeMap($etomite, 0);\r\n\r\n// To also list documents in unpublished repository folders,\r\n// place an additional call to MakeMap here for each one, e.g. \r\n// $out .= MakeMap($etomite, 8);\r\n// where 8 is the document id of the unpublished repository folder.\r\n\r\n$out .= "</urlset>";\r\n\r\nreturn $out;', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (25, 'MollioCrumbs', '[TEMPLATE] Outputs the page trail for Mollio templates', '// Snippet name: MollioCrumbs\r\n// Snippet description: Outputs the page trail for Mollio templates\r\n// Revision: 1.0 ships with Etomite 0.6.1-Final\r\n// Author: jaredc@honeydewdesign.com - 2005-05-26\r\n// \r\n// This snippet was designed to show the\r\n// path through the various levels of\r\n// site structure back to the root. It\r\n// is NOT necessarily the path the user\r\n// took to arrive at a given page. Based on\r\n// PageTrail snippet by: Bill Wilson.\r\n\r\n// Changes by Lloyd Borrett - 2006-04-08\r\n//   Adapted to produce output for Mollio templates\r\n\r\n// Configuration Settings\r\n\r\n   // $maxCrumbs [number]\r\n   // Max number of elements to have in a path.\r\n   // 100 is an arbitrary high number.\r\n   // If you make it smaller, like say 2, but you\r\n   // you are 5 levels deep, it will appear as:\r\n   // Home > ... > Level 4 > Level 5\r\n   // It should be noted that "Home" and the current\r\n   // page do not count. Each of these are configured\r\n   // separately.\r\n   $maxCrumbs = 5;\r\n\r\n   // $pathThruUnPub [ true | false ]\r\n   // When you path includes an unpublished folder, setting this to \r\n   // true will show all documents in path EXCEPT the unpublished.\r\n   // Example path (unpublished in caps)\r\n   // home > news > CURRENT > SPORTS > skiiing > article\r\n   // $pathThruUnPub = true would give you this:\r\n   // home > news > skiiing > article\r\n   // $pathThruUnPub = false  would give you this:\r\n   // home > skiiing > article (assuming you have home crumb turned on)\r\n   $pathThruUnPub = true;\r\n\r\n   // $showHomeCrumb [true | false]\r\n   // Would you like your crumb string to start\r\n   // with a link to home? Some would not because\r\n   // a home link is usually found in the site logo\r\n   // or elsewhere in the navigation scheme.\r\n   $showHomeCrumb = true;\r\n\r\n   // $showCrumbsAtHome [ true | false ]\r\n   // You can use this to turn off the breadcrumbs on the\r\n   // home page.\r\n   $showCrumbsAtHome = true;\r\n\r\n   // $showCurrentCrumb [true | false]\r\n   // Show the current page in path\r\n   $showCurrentCrumb = true;\r\n\r\n   // $currentAsLink [true | false]\r\n   // If you want the current page crumb to be a\r\n   // link (to itself) then make true.\r\n   $currentAsLink = false;\r\n\r\n   // $crumbSeparator [string]\r\n   // Define what you want between the crumbs\r\n   $crumbSeparator = "/";\r\n\r\n   // $homeCrumbTitle [string]\r\n   // Just in case you want to have a home link,\r\n   // but want to call it something else\r\n   $homeCrumbTitle = ''Home'';\r\n\r\n// ***********************************\r\n// END CONFIG SETTINGS\r\n// THE REST SHOULD TAKE CARE OF ITSELF\r\n// ***********************************\r\n\r\n// Check for home page\r\nif ($showCrumbsAtHome || (!$showCrumbsAtHome && ($etomite->documentIdentifier != $etomite->config[''site_start''])) ){\r\n\r\n  //initialize crumb array\r\n  $ptarr = array();\r\n  // get current page parent id\r\n	$docInfo = $etomite->getDocument($etomite->documentIdentifier);\r\n  $pid = $docInfo[''parent''];\r\n  // show current page, as link or not\r\n  if ($showCurrentCrumb){\r\n    if ($currentAsLink){\r\n      $ptarr[] = ''<a href="[~''.$etomite->documentIdentifier.''~]" title="''.$docInfo[''pagetitle''].''">''.$docInfo[''pagetitle'']."</a>\\n";\r\n    } else {\r\n      $ptarr[] = "<strong>".$docInfo[''pagetitle'']."</strong>\\n";\r\n    }\r\n  }\r\n  // assemble intermediate crumbs\r\n  $crumbCount = 0;\r\n  $activeOnly = ($pathThruUnPub)? 0 : 1;\r\n  while (($parent=$etomite->getPageInfo($pid,$activeOnly,"id,pagetitle,published,deleted,parent")) && ($crumbCount < $maxCrumbs)) {\r\n    if ($parent[''published''] && !$parent[''deleted''] && $parent[''id''] != $etomite->config[''site_start'']){\r\n      $ptarr[] = ''<a href="[~''.$parent[''id''].''~]" title="''.$parent[''pagetitle''].''">''.$parent[''pagetitle'']."</a>\\n";\r\n    }    \r\n    $pid = $parent[''parent''];\r\n    $crumbCount++;\r\n  }\r\n  // insert ''...'' if maximum number of crumbs exceded\r\n  if ($parent != 0){\r\n    $ptarr[] = ''...'';\r\n  }\r\n  // add home link if desired\r\n  if ($showHomeCrumb && ($etomite->documentIdentifier != $etomite->config[''site_start''])){\r\n    $ptarr[] = ''<a href="[~''.$etomite->config[''site_start''].''~]" title="''.$homeCrumbTitle.''">''.$homeCrumbTitle."</a>\\n";\r\n  }\r\n\r\n  $ptarr = array_reverse($ptarr);\r\n  $output = join($ptarr, " $crumbSeparator ");\r\n\r\n  return $output;\r\n} // end check if home page', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (28, 'MollioMainMenu', '[TEMPLATE] Outputs the Main menu for Mollio templates', '// Snippet name: MollioMainMenu\r\n// Snippet description: Outputs the Main Menu for Mollio templates\r\n// Revision: 1.0 ships with Etomite 0.6.1-Final\r\n// Author: Lloyd Borrett - 2006-04-09\r\n//\r\n// Based on elements from the ListSiteMap and ListMenu snippets\r\n// by jaredc@honeydewdesign.com\r\n//\r\n// This snippet was designed to show a nested\r\n// list menu with each pagetitle being a\r\n// link to that page. It will not include\r\n// unpublished folders/pages OR its children,\r\n// even if the children ARE published.\r\n// List items are marked with CSS class values of\r\n// active, last or first as appropriate.\r\n\r\n// Configuration\r\n   // $menuRoot [int]\r\n   // The parent ID of your root. Default 0. Can be set in \r\n   // snippet call with MMM_root (to doc id 10 for example):\r\n   // [[MollioMainMenu?MMM_root=10]]\r\n   $menuRoot = 0;\r\n\r\n   // $titleOfLinks [ string ]\r\n   // What database field do you want the title of your links to be?\r\n   // it can be any of the following:\r\n   // id, pagetitle, description, parent, alias, longtitle.\r\n   // If the field you choose is empty for any given document,\r\n   // the the pagetitle of the document is used. \r\n   $titleOfLinks = ''longtitle'';\r\n   \r\n   // $maxLevels [ int ]\r\n   // Maximum number of levels to include. The default 2 is the number\r\n   // of levels supported by the CSS styles.\r\n   // A value of 0 will allow all levels.\r\n   // Also settable with snippet variable MMM_levels:\r\n   // [[MollioMainMenu?MMM_levels=2]]\r\n   $maxLevels = 2;\r\n   \r\n\r\n// ###########################################\r\n// End config, the rest takes care of itself #\r\n// ###########################################\r\n\r\n// Initialize\r\n$menuRoot = (isset($MMM_root))? $MMM_root : $menuRoot ;\r\n$maxLevels = (isset($MMM_levels))? $MMM_levels : $maxLevels ;\r\n\r\n// Overcome single use limitation on functions\r\nglobal $MakeMainMenuDefined;\r\n\r\nif(!isset($MakeMainMenuDefined)){\r\n  function MakeMainMenu($funcEtomite, $listParent, $listLevel, $titleOfLinks, $maxLevels, $fullGeneology){\r\n    $children = $funcEtomite->getActiveChildren($listParent, ''menuindex'', ''ASC'', ''id, pagetitle, parent, alias, longtitle, published'');\r\n    $childrenCount = count($children); \r\n    $ie = "\\n";\r\n    $pad = str_pad($pad,($listLevel * 2)," ");\r\n\r\n    // start this level\r\n    if ($listLevel == 0) {\r\n      $output .= $pad.''<ul id="nav">''.$ie;\r\n    } else {\r\n      $output .= $pad.''<ul>''.$ie;\r\n    }\r\n\r\n    for($x=0; $x<$childrenCount; $x++) {\r\n      $child = $children[$x];\r\n\r\n      // Is this the current document or an ancestor?\r\n      $ancestor = in_array($child[''id''], $fullGeneology);\r\n    \r\n      // Set the class to active, last, first or none\r\n      if ($ancestor) {\r\n        $cssStyle = '' class="active"'';\r\n      } else {\r\n	if (($x+1) == $childrenCount) {\r\n          $cssStyle = '' class="last"'';\r\n        } else {\r\n          if ($x == 0) {\r\n            $cssStyle = '' class="first"'';\r\n          } else {\r\n            $cssStyle = '''';\r\n          }\r\n        }\r\n      }\r\n\r\n      $output .= $pad.''<li''.$cssStyle.''>'';\r\n      $output .= ''<a href="[~''.$child[''id''].''~]" title="'';\r\n      if ($child[$titleOfLinks] != "") {\r\n        $output .= str_replace(''"'',"''",$child[$titleOfLinks]);\r\n      } else {\r\n        $output .= str_replace(''"'',"''",$child[''pagetitle'']);\r\n      }\r\n      $output .= ''">''.$child[''pagetitle''].''</a>'';\r\n\r\n      if ($funcEtomite->getActiveChildren($child[''id'']) && (($maxLevels==0) || ($maxLevels > $listLevel+1 ))){\r\n        $output .= MakeMainMenu($funcEtomite, $child[''id''], $listLevel+1, $titleOfLinks, $maxLevels, $fullGeneology);\r\n      }\r\n      $output .= ''</li>''.$ie;\r\n    }\r\n    $output .= $pad.''</ul>''.$ie;\r\n    return $output;\r\n  }\r\n  $MakeMainMenuDefined = true;\r\n}\r\n\r\n// Create Geneology\r\n$fullGeneology = array();\r\n$geneologyMarker = $etomite->documentIdentifier;\r\nwhile ($currentMarker=$etomite->getPageInfo($geneologyMarker, null, ''id,parent'')){\r\n    $fullGeneology[] = $currentMarker[''id''];\r\n    $geneologyMarker = $currentMarker[''parent''];\r\n}\r\n$fullGeneology[] = 0;\r\n\r\nreturn MakeMainMenu($etomite, $menuRoot, 0,  $titleOfLinks, $maxLevels, $fullGeneology);', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (29, 'MollioSecondaryMenu', '[TEMPLATE] Outputs the Secondary Menu for Mollio templates', '// Snippet name: MollioSecondaryMenu\r\n// Snippet description: Outputs the Secondary Menu for Mollio templates\r\n// Revision: 1.0 ships with Etomite 0.6.1-Final\r\n// Author: Lloyd Borrett - 2006-04-09\r\n//\r\n// Based on elements from the ListSiteMap and ListMenu snippets\r\n// by jaredc@honeydewdesign.com\r\n//\r\n// This snippet was designed to show a nested\r\n// list menu with each pagetitle being a\r\n// link to that page. It will not include\r\n// unpublished folders/pages OR its children,\r\n// even if the children ARE published.\r\n// List items are marked with CSS class values of\r\n// active, last or first as appropriate.\r\n\r\n// Configuration\r\n   // $titleOfLinks [ string ]\r\n   // What database field do you want the title of your links to be?\r\n   // it can be any of the following:\r\n   // id, pagetitle, description, parent, alias, longtitle.\r\n   // If the field you choose is empty for any given document,\r\n   // the the pagetitle of the document is used. \r\n   $titleOfLinks = ''longtitle'';\r\n   \r\n   // $maxLevels [ int ]\r\n   // Maximum number of levels to include. The default 4 is the number\r\n   // of levels supported by the CSS styles.\r\n   // A value of 0 will allow all levels.\r\n   // Also settable with snippet variable MMM_levels:\r\n   // [[MollioSecondaryMenu?MSM_levels=2]]\r\n   $maxLevels = 4;\r\n   \r\n\r\n// ###########################################\r\n// End config, the rest takes care of itself #\r\n// ###########################################\r\n\r\n// Initialize\r\n$maxLevels = (isset($MSM_levels))? $MSM_levels : $maxLevels ;\r\n\r\n// Overcome single use limitation on functions\r\nglobal $MakeSecMenuDefined;\r\n\r\nif(!isset($MakeSecMenuDefined)){\r\n  function MakeSecMenu($funcEtomite, $listParent, $listLevel, $titleOfLinks, $maxLevels, $fullGeneology){\r\n    $children = $funcEtomite->getActiveChildren($listParent, ''menuindex'', ''ASC'', ''id, pagetitle, parent, alias, longtitle, published'');\r\n    $childrenCount = count($children); \r\n    $ie = "\\n";\r\n    $pad = str_pad($pad,($listLevel * 2)," ");\r\n\r\n    // start this level\r\n    if ($listLevel == 0) {\r\n      $output .= $pad.''<ul id="nav-secondary">''.$ie;\r\n    } else {\r\n      $output .= $ie.$pad.''<ul>''.$ie;\r\n    }\r\n\r\n    for($x=0; $x<$childrenCount; $x++) {\r\n      $child = $children[$x];\r\n\r\n      // Is this the current document or an ancestor?\r\n      $ancestor = in_array($child[''id''], $fullGeneology);\r\n\r\n      // Set the class to active, last, first or none\r\n      if ($ancestor) {\r\n        $cssStyle = '' class="active"'';\r\n      } else {\r\n	if (($x+1) == $childrenCount) {\r\n          $cssStyle = '' class="last"'';\r\n        } else {\r\n          if ($x == 0) {\r\n            $cssStyle = '' class="first"'';\r\n          } else {\r\n            $cssStyle = '''';\r\n          }\r\n        }\r\n      }\r\n\r\n      $output .= $pad.''<li''.$cssStyle.''>'';\r\n      $output .= ''<a href="[~''.$child[''id''].''~]" title="'';\r\n      if ($child[$titleOfLinks] != "") {\r\n        $output .= str_replace(''"'',"''",$child[$titleOfLinks]);\r\n      } else {\r\n        $output .= str_replace(''"'',"''",$child[''pagetitle'']);\r\n      }\r\n      $output .= ''">''.$child[''pagetitle''].''</a>'';\r\n\r\n      // Does this document have children?\r\n      $hasChildren = $funcEtomite->getActiveChildren($child[''id'']);\r\n\r\n      if ($hasChildren && $ancestor && (($maxLevels==0) || ($maxLevels > $listLevel+1 ))){\r\n        $output .= MakeSecMenu($funcEtomite, $child[''id''], $listLevel+1, $titleOfLinks, $maxLevels, $fullGeneology);\r\n      }\r\n      $output .= ''</li>''.$ie;\r\n    }\r\n    $output .= $pad.''</ul>''.$ie;\r\n    return $output;\r\n  }\r\n  $MakeSecMenuDefined = true;\r\n}\r\n\r\n$id = $etomite->documentIdentifier; //current document\r\n\r\n// If we''re at home, do nothing\r\n$atHome = ($id == $etomite->config[''site_start''])? true : false ;\r\nif ($atHome) {\r\n	return "";\r\n}\r\n\r\n// Create Geneology\r\n$fullGeneology = array();\r\n$geneologyMarker = $id;\r\nwhile (($currentMarker = $etomite->getPageInfo($geneologyMarker, null, ''id,parent'')) && ($currentMarker[''parent''] != 0 ) ) {\r\n    $fullGeneology[] = $currentMarker[''id''];\r\n    $geneologyMarker = $currentMarker[''parent''];\r\n}\r\n$fullGeneology[] = 0;\r\n\r\nreturn MakeSecMenu($etomite, $geneologyMarker, 0,  $titleOfLinks, $maxLevels, $fullGeneology);', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (35, 'MenuHori', '[TEMPLATE] MenuHori Snippet', '//  --------------------------------------------\r\n//        Snippet:  MenuHori by summean\r\n//  --------------------------------------------\r\n//  Based on the MenuBuilder snippet, however \r\n//  MenuHori does not show subchildren.  Inserts\r\n//  into a template just like MenuBuilder:\r\n//  [[MenuHori?id=__]] where __ is the folder \r\n//  containing the links/documents.\r\n\r\n// --Config:--\r\n// Insert what you would like to appear between\r\n// the links in the " " below.\r\n\r\n$seperator="&nbsp; | &nbsp;";\r\n\r\n// --End Config--\r\n\r\n$children = $etomite->getActiveChildren($id); $menu = ""; $childrenCount = count($children);\r\nif($children==false) {\r\n    return false;\r\n}\r\n\r\nfor($x=0; $x<$childrenCount; $x++) {\r\n\r\n//If its the last link/document, we don''t want the seperator after it. (Thanks Alex)\r\n	if($x==($childrenCount-1)){ \r\n\r\n$menu .= "<a href=''[~".$children[$x][''id'']."~]''>".$children[$x][''pagetitle'']."</a>";\r\n\r\n	} else {\r\n\r\n$menu .= "<a href=''[~".$children[$x][''id'']."~]''>".$children[$x][''pagetitle'']."</a>$seperator";\r\n	\r\n	}\r\n}\r\n\r\nreturn $menu;', 0);

INSERT INTO `{PREFIX}site_snippets` VALUES (38, 'RelatedInfo', 'Output a related chunk into the document', '// Snippet name: RelatedInfo\r\n// Snippet description: Outputs a related chunk into the document\r\n// Revision: 1.0 ships with Etomite 0.6.1-Final\r\n// Author: Lloyd Borrett - 2006-04-09\r\n\r\n// Description:\r\n//   Outputs a chunk into the document based on the \r\n//   document''s alias/id, and optionally, a prefix \r\n//   passed to the chunk.\r\n\r\n// Usage:\r\n//   Insert [[RelatedInfo]] or [[RelatedInfo?prefix=<YourPrefix>]]\r\n//   in your template where you want the required document \r\n//   specific content to appear.\r\n//   e.g. [[RelatedInfo]], [[RelatedInfo?prefix=RightColumn]],\r\n//   [[RelatedInfo?prefix=MiddleColumn]] etc.\r\n//   Create a chunk called "RelatedInfo-<value>" and/or \r\n//   "<YourPrefix>-<value>" for each document where you want \r\n//   to display document related content.\r\n\r\n//   "<value>" is the document alias (if specified), or the \r\n//   document id number if there is no alias value.\r\n//   "<YourPrefix>" is a prefix value passed to the chunk.\r\n\r\n//   For example: "RelatedInfo-home", "RelatedInfo-1",\r\n//   "MiddleColumn-home", "MiddleColumn-1" etc.\r\n\r\n//   The snippet will insert the content of your "RelatedInfo-<value>" and/or\r\n//   "<YourPrefix>-<value>" chunks into the appropriate document.\r\n\r\n//   If there is no output from "RelatedInfo-<value>" and/or "<YourPrefix>-<value>",\r\n//   typically because the chunks don''t exist, the you can request that the default\r\n//   "RelatedInfo" or "<YourPrefix>" chunks are used, if they exist.\r\n\r\n// Problem 1:\r\n//   You want to be able to put some content into a section of \r\n//   your document template. But you would like to be able to have \r\n//   different content for different documents.\r\n//   Typically this might be document related content for another \r\n//   column or something similar.\r\n\r\n// Solution 1:\r\n//   Insert [[RelatedInfo]] into your template where you want the content to appear.\r\n//   Now create a chunk called "RelatedInfo-<value>" for each document where you want\r\n//   document specific content to appear.\r\n//   For example, if you have a document with an alias "productx", \r\n//   the chunk would be called "RelatedInfo-productx".\r\n//   If the document has no alias, then it''s id value is used, \r\n//   for example "RelatedInfo-23".\r\n//   Into the "RelatedInfo-<value>" chunk you can put the content you want,\r\n//   and/or calls to other chunks and snippets.\r\n//   If you don''t have document specific content for that document, \r\n//   then you can let the default content from the "RelatedInfo" chunk \r\n//   be output, if it exists.\r\n//   If there is no "RelatedInfo-<value>" or "RelatedInfo" chunks, \r\n//   then nothing is output.\r\n\r\n// Problem 2:\r\n//   Okay so you can use [[RelatedInfo]] to do document specific \r\n//   content for say your middle column.\r\n//   But on some documents you might also might want some page \r\n//   specific extra content in another part of the document. \r\n//   For example, the right column.\r\n\r\n// Solution 2:\r\n//   Insert [[RelatedInfo?prefix=<YourPrefix>]] into your template \r\n//   where you want the content to appear.\r\n//   Now create a chunk called "<YourPrefix>-<value>" for each page \r\n//   where you want this document specific content to appear.\r\n//   For example, you want to put some content into the right \r\n//   column of your template.\r\n//   So you put [[RelatedInfo?prefix=RightColumn]] into your template.\r\n//   And if you have a document with an alias "productx", the chunk would be\r\n//   called "RightColumn-productx". If the document has no alias, \r\n//   then it''s id value is used, for example "RightColumn-23".\r\n//   Into the "<YourPrefix>-<value>" chunk you can put the content you want,\r\n//   and/or calls to other chunks and snippets.\r\n//   If you don''t have document specific content for that document, \r\n//   you can let the default content from the "<YourPrefix>" chunk \r\n//   be output, if it exists.\r\n//   If there is no "<YourPrefix>-<alias>" or "<YourPrefix>" chunks, \r\n//   then nothing is output.\r\n\r\n// Explanation:\r\n//   The power of this snippet is that a chunk doesn''t have to just \r\n//   contain raw HTML code.\r\n//   The chunk can also have calls to other chunks, and even calls to snippets.\r\n//   Thus each document specific chunk you create can be extremely \r\n//   flexible in what gets  put into your document, with you having \r\n//   to duplicate raw HTML code here, there and everywhere.\r\n\r\n//   (So much to explain such a simple snippet!)\r\n\r\n\r\n// Configuration Setting\r\n\r\n// $showDefaultCrumb [true | false]\r\n// If there is no output from calling the crumb for the specific document, \r\n// which typically occurs if you haven''t created the crumb, \r\n// instead of getting nothing you can ask for a default crumb \r\n// to be used by setting this value to true. \r\n// Of course, if you don''t set up a default crumb, you still get nothing. \r\n// If you don''t want to have this feature enabled just set this value to false.\r\n$showDefaultCrumb = true;\r\n\r\n$output = "";\r\n\r\nif (!isset($prefix)) {\r\n	$prefix = "RelatedInfo";\r\n} else {\r\n	if ($prefix == "") {\r\n		$prefix = "RelatedInfo";\r\n	}\r\n}\r\n\r\n$alias = $etomite->documentObject[''alias''];\r\nif ($alias == "") {\r\n	$alias = $etomite->documentIdentifier;\r\n}\r\n\r\n$output .= $etomite->putChunk($prefix.''-''.$alias);\r\nif ($output == "" && $showDefaultCrumb) {\r\n	$output .= $etomite->putChunk($prefix);\r\n}\r\n\r\nreturn $output;', 0);

CREATE TABLE `{PREFIX}site_templates` (
  `id` int(10) NOT NULL auto_increment,
  `templatename` varchar(50) NOT NULL default '',
  `description` varchar(255) NOT NULL default 'Template',
  `content` mediumtext NOT NULL,
  `locked` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM PACK_KEYS=0 COMMENT='Contains the site''s templates.' ;

INSERT INTO `{PREFIX}site_templates` VALUES (1, 'New-E', 'A new Etomite template', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"\r\n  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\r\n<html xmlns="http://www.w3.org/1999/xhtml">\r\n<head>\r\n[[MetaTagsExtra]]\r\n <style type="text/css">@import url(templates/new-E/new-E.css);</style>\r\n <script type="text/javascript">\r\n <!--\r\n // Empty script to kill FOUC in IE\r\n // www.bluerobot.com/web/css/fouc.asp\r\n -->\r\n </script>\r\n</head>\r\n\r\n<body>\r\n<div id="bodyLiner">\r\n\r\n<div id="neweMasthead">\r\n  <div id="templateLogo"><img src="templates/new-E/images/mastheadLogo.jpg"\r\n    width="200" height="140" alt="Template logo" /></div>\r\n  <h1>[*pagetitle*]</h1>\r\n  <p>[*longtitle*]</p>\r\n</div>\r\n\r\n<div id="neweContent">\r\n\r\n  <div id="neweTrail">\r\n    [[PageTrail]]\r\n  </div>\r\n\r\n  <div id="neweMainCol">\r\n    <div id="neweMainColLiner">\r\n      [*content*]\r\n    </div>\r\n  </div>\r\n\r\n  <div id="neweSideCol">\r\n    <div id="neweSideColLiner">\r\n      <div class="sideTitle">Navigation</div>\r\n      [!ListMenu!]\r\n    </div>\r\n  </div>\r\n  \r\n</div>\r\n\r\n<div id="neweFooter">\r\n  <p>[!Copyright!] | [[PoweredBy]]</p>\r\n  <p>MySQL: [^qt^], [^q^] request(s), PHP: [^p^], total: [^t^], \r\n    document retrieved from [^s^].</p>\r\n</div>\r\n</div>\r\n</body>\r\n</html>', 0);

INSERT INTO `{PREFIX}site_templates` VALUES (2, 'Greens', 'Site template created by Karen Atherholt (katherholt)', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"\r\n "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\r\n<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">\r\n<head>\r\n  <title>[(site_name)] &raquo; [*pagetitle*]</title>\r\n  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />\r\n  <!-- Example of using a Chunk to hold stylesheet information -->\r\n  <style type="text/css">\r\n  {{greens.css}} /* template stylesheet */\r\n  {{lm.css}} /* ListMenu snippet stylesheet */\r\n  </style>\r\n</head>\r\n<body>\r\n<table class="border">\r\n  <tr>\r\n    <td style="width:15%;"><a href="[~[(site_start)]~]"><img \r\n      src="templates/greens/images/logo.gif" \r\n      alt="[(site_name)]" width="150" height="84" style="border:none;" /></a></td>\r\n    <td style="width:85%" align="right" valign="middle" class="slogan">Welcome\r\n      to [(site_name)]... &nbsp;</td>\r\n  </tr>\r\n  <tr align="left" valign="top">\r\n    <td style="text-align:left; background-color:#006633; width:150px;">\r\n      <table style="width:100%;" cellpadding="0" cellspacing="0">\r\n        <tr>\r\n          <td class="navtitle">Navigation</td>\r\n        </tr>\r\n        <tr>\r\n          <!--Menu Snippet Goes Below Here -->\r\n          <td class="navigation" style="padding: 0px; margin: 0px; \r\n            text-align:left; vertical-align:top;">\r\n            <div id="listMenuWrapper">\r\n              [[ListMenu?LM_levels=3]]\r\n            </div>\r\n            <div style="height:20px;">&nbsp;</div>\r\n            <div style="width:100%;">\r\n              [!SearchPrompt?resultsid=16!]\r\n            </div>\r\n          </td>\r\n        </tr>\r\n      </table>\r\n    </td>\r\n    <td align="left">\r\n      <table style="width:100%; border:none;" cellpadding="1" cellspacing="0">\r\n        <tr>\r\n          <td style="width:2; background-color:#FFFFFF; wrap:nowrap; \r\n            vertical-align:top;" rowspan="4" class="divider">&nbsp;</td>\r\n          <td colspan="2" align="right" valign="top" bgcolor="#FFFFFF" \r\n            class="pagetrail">[[PageTrail]]</td>\r\n          <td rowspan="4" valign="top" bgcolor="#FFFFFF" \r\n            nowrap="nowrap">&nbsp;&nbsp;</td>\r\n        </tr>\r\n        <tr align="left" valign="top">\r\n          <td  style="width:15px;" bgcolor="#FFFFFF">&nbsp;</td>\r\n          <td style="width:100%" bgcolor="#FFFFFF">\r\n            <h1>[*longtitle*]</h1>\r\n          </td>\r\n        </tr>\r\n        <tr align="left" valign="top">\r\n          <td bgcolor="#FFFFFF">&nbsp;</td>\r\n          <td style="width:100%" bgcolor="#FFFFFF" class="content">\r\n            [*content*]</td>\r\n        </tr>\r\n        <tr align="left" valign="top">\r\n          <td colspan="2" bgcolor="#FFFFFF">&nbsp;</td>\r\n        </tr>\r\n      </table>\r\n    </td>\r\n  </tr>\r\n  <tr>\r\n    <td colspan="2" align="center" class="footer">&copy; Copyright 2005 \r\n      <a href="[~[(site_start)]~]">[(site_name)]</a> - all rights reserved.</td>\r\n  </tr>\r\n  <tr valign="middle">\r\n    <td height="20" colspan="2" align="right" bgcolor="#006633" \r\n      class="copy_white">MySQL: [^qt^], [^q^] request(s), PHP: [^p^], total: [^t^],\r\n      document retrieved from [^s^].</td>\r\n  </tr>\r\n</table>\r\n<p>&nbsp;</p>\r\n</body>\r\n</html>', 0);

INSERT INTO `{PREFIX}site_templates` VALUES (3, 'AlexisPro Redux', 'Default template, designed by Helder :)', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" \r\n  "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">\r\n<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">\r\n<head>\r\n  <title>[(site_name)] &raquo; [*pagetitle*]</title>\r\n  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />\r\n  [[GetKeywords]]\r\n  <style type="text/css">\r\n    @import url(''templates/AlexisProRedux/AlexisProRedux.css'');\r\n  </style>\r\n</head>	\r\n\r\n<body>\r\n<table border="0" cellpadding="0" cellspacing="0" class="mainTable">\r\n  <tr class="fancyRow">\r\n    <td><span class="headers">&nbsp;<img \r\n      src="templates/AlexisProRedux/images/dot.gif" alt="" \r\n      style="margin-top: 1px;" />&nbsp;<a \r\n      href="[~[(site_start)]~]">[(site_name)]</a></span></td>\r\n    <td align="right"><span class="headers">[[PageTrail]]</span></td>\r\n  </tr>\r\n  <tr class="fancyRow2">\r\n    <td colspan="2" class="border-top-bottom smallText" \r\n      align="right">[[PoweredBy]]</td>\r\n  </tr>\r\n  <tr align="left" valign="top">\r\n    <td colspan="2"><table width="100%" border="0" \r\n      cellspacing="0" cellpadding="1">\r\n      <tr align="left" valign="top">\r\n        <td class="w22"><table width="100%" border="0" \r\n          cellpadding="0" cellspacing="0">\r\n          <tr>\r\n            <td align="center" valign="middle" class="logoBox"><a \r\n              href="[~[(site_start)]~]"><img \r\n              src="templates/AlexisProRedux/images/logoGradient.jpg" \r\n              width="131" height="121" alt="" /></a></td>\r\n          </tr>\r\n          <tr>\r\n            <td align="left" valign="top"><img \r\n              src="templates/AlexisProRedux/images/_tx_.gif" \r\n              height="4" alt="" /></td>\r\n          </tr>\r\n          <tr class="fancyRow2">\r\n            <td align="left" valign="top" class="navigationHead">Navigation</td>\r\n          </tr>\r\n          <tr style="padding: 0px; margin: 0px;">\r\n            <td align="left" valign="top" class="navigation" \r\n              style="padding: 0px; margin: 0px;"><img \r\n              src="templates/AlexisProRedux/images/_tx_.gif" \r\n              alt="" height="4" /><br />\r\n              [!MenuBuilder?id=0!]<img src="templates/AlexisProRedux/images/_tx_.gif" \r\n              height="4" alt="" /></td>\r\n          </tr>\r\n        </table></td>\r\n        <td class="pad" id="content">\r\n          <h1>[*longtitle*]</h1>\r\n          [*content*]</td>\r\n      </tr>\r\n    </table></td>\r\n  </tr>\r\n  <tr class="fancyRow2">\r\n    <td class="border-top-bottom smallText">&nbsp;</td>\r\n    <td class="border-top-bottom smallText" align="right">MySQL: \r\n      [^qt^], [^q^] request(s), PHP: [^p^], total: [^t^], \r\n      document retrieved from [^s^].</td>\r\n  </tr>\r\n</table>\r\n</body>\r\n</html>', 0);

INSERT INTO `{PREFIX}site_templates` VALUES (4, 'GoogleSiteMap_Template', 'Used to create a Google XML site map', '[!GoogleSiteMap_XML!]', 0);

INSERT INTO `{PREFIX}site_templates` VALUES (5, 'Mollio_typeC', '3 columns - Main + Left hand nav + Right Sidebar', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\r\n<html xmlns="http://www.w3.org/1999/xhtml">\r\n<!--\r\nCopyright: Daemon Pty Limited 2006, http://www.daemon.com.au\r\nCommunity: Mollio http://www.mollio.org $\r\nLicense: Released Under the "Common Public License 1.0", \r\nhttp://www.opensource.org/licenses/cpl.php\r\nLicense: Released Under the "Creative Commons License", \r\nhttp://creativecommons.org/licenses/by/2.5/\r\nLicense: Released Under the "GNU Creative Commons License", \r\nhttp://creativecommons.org/licenses/GPL/2.0/\r\n-->\r\n<head>\r\n<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />\r\n[[MetaTagsExtra]]\r\n<link rel="stylesheet" type="text/css" href="templates/mollio/css/main.css" media="screen" />\r\n<link rel="stylesheet" type="text/css" href="templates/mollio/css/print.css" media="print" />\r\n<!--[if lte IE 6]>\r\n<link rel="stylesheet" type="text/css" href="templates/mollio/css/ie6_or_less.css" />\r\n<![endif]-->\r\n<script type="text/javascript" src="templates/mollio/js/common.js"></script>\r\n</head>\r\n<body id="type-c">\r\n<div id="wrap">\r\n\r\n	<div id="header">\r\n		<div id="site-name">[(site_name)]</div>\r\n		<div id="search">\r\n			<form action="">\r\n			<label for="searchsite">Site Search:</label>\r\n			<input id="searchsite" name="searchsite" type="text" />\r\n			<input type="submit" value="Go" class="f-submit" />\r\n			</form>\r\n		</div>\r\n[!MollioMainMenu!]\r\n	</div>\r\n	\r\n	<div id="content-wrap">\r\n	\r\n		<div id="utility">\r\n\r\n<!--authenticate_visitor-->\r\n[!MollioSecondaryMenu!]\r\n\r\n		</div>\r\n		\r\n		<div id="content">\r\n		\r\n			<div id="breadcrumb">\r\n			[[MollioCrumbs]]\r\n			</div>\r\n			\r\n[*content*]\r\n			\r\n			<div id="footer">\r\n			<p><a href="#">Contact Us</a> | <a href="#">Privacy</a> | <a href="#">Links</a></p>\r\n			<p>[[Copyright]] | [[PoweredBy]]</p>\r\n			</div>\r\n			\r\n		</div>\r\n		\r\n		<div id="sidebar">\r\n[[RelatedInfo?prefix=RelatedInfoMollio]]\r\n		</div>\r\n		\r\n		<div id="poweredby"><a href="http://www.etomite.com/"><img src="templates/mollio/wsimages/mollio.gif" alt="Etomite CMS - Mollio Templates" /></a></div>\r\n		\r\n	</div>\r\n	\r\n</div>\r\n</body>\r\n</html>', 0);

INSERT INTO `{PREFIX}site_templates` VALUES (22, 'Mollio_typeA', '1 column', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\r\n<html xmlns="http://www.w3.org/1999/xhtml">\r\n<!--\r\nCopyright: Daemon Pty Limited 2006, http://www.daemon.com.au\r\nCommunity: Mollio http://www.mollio.org $\r\nLicense: Released Under the "Common Public License 1.0", \r\nhttp://www.opensource.org/licenses/cpl.php\r\nLicense: Released Under the "Creative Commons License", \r\nhttp://creativecommons.org/licenses/by/2.5/\r\nLicense: Released Under the "GNU Creative Commons License", \r\nhttp://creativecommons.org/licenses/GPL/2.0/\r\n-->\r\n<head>\r\n<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />\r\n[[MetaTagsExtra]]\r\n<link rel="stylesheet" type="text/css" href="templates/mollio/css/main.css" media="screen" />\r\n<link rel="stylesheet" type="text/css" href="templates/mollio/css/print.css" media="print" />\r\n<!--[if lte IE 6]>\r\n<link rel="stylesheet" type="text/css" href="templates/mollio/css/ie6_or_less.css" />\r\n<![endif]-->\r\n<script type="text/javascript" src="templates/mollio/js/common.js"></script>\r\n</head>\r\n<body id="type-a">\r\n<div id="wrap">\r\n\r\n	<div id="header">\r\n		<div id="site-name">[(site_name)]</div>\r\n		<div id="search">\r\n			<form action="">\r\n			<label for="searchsite">Site Search:</label>\r\n			<input id="searchsite" name="searchsite" type="text" />\r\n			<input type="submit" value="Go" class="f-submit" />\r\n			</form>\r\n		</div>\r\n[!MollioMainMenu!]\r\n	</div>\r\n	\r\n	<div id="content-wrap">\r\n	\r\n		<div id="content">\r\n		\r\n			<div id="breadcrumb">\r\n			[[MollioCrumbs]]\r\n			</div>\r\n			\r\n[*content*]\r\n		\r\n			<div id="footer">\r\n			<p><a href="#">Contact Us</a> | <a href="#">Privacy</a> | <a href="#">Links</a></p>\r\n			<p>[[Copyright]] | [[PoweredBy]]</p>\r\n			</div>\r\n		\r\n		</div>\r\n		\r\n		<div id="poweredby"><a href="http://www.etomite.com/"><img \r\n			src="templates/mollio/wsimages/mollio.gif" \r\n			alt="Etomite CMS - Mollio Templates" /></a>\r\n		</div>\r\n		\r\n	</div>\r\n\r\n</div>\r\n</body>\r\n</html>', 0);

INSERT INTO `{PREFIX}site_templates` VALUES (23, 'Mollio_typeB', '2 columns - Main + Left hand nav', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\r\n<html xmlns="http://www.w3.org/1999/xhtml">\r\n<!--\r\nCopyright: Daemon Pty Limited 2006, http://www.daemon.com.au\r\nCommunity: Mollio http://www.mollio.org $\r\nLicense: Released Under the "Common Public License 1.0", \r\nhttp://www.opensource.org/licenses/cpl.php\r\nLicense: Released Under the "Creative Commons License", \r\nhttp://creativecommons.org/licenses/by/2.5/\r\nLicense: Released Under the "GNU Creative Commons License", \r\nhttp://creativecommons.org/licenses/GPL/2.0/\r\n-->\r\n<head>\r\n<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />\r\n[[MetaTagsExtra]]\r\n<link rel="stylesheet" type="text/css" href="templates/mollio/css/main.css" media="screen" />\r\n<link rel="stylesheet" type="text/css" href="templates/mollio/css/print.css" media="print" />\r\n<!--[if lte IE 6]>\r\n<link rel="stylesheet" type="text/css" href="templates/mollio/css/ie6_or_less.css" />\r\n<![endif]-->\r\n<script type="text/javascript" src="templates/mollio/js/common.js"></script>\r\n</head>\r\n<body id="type-b">\r\n<div id="wrap">\r\n\r\n	<div id="header">\r\n		<div id="site-name">[(site_name)]</div>\r\n		<div id="search">\r\n			<form action="">\r\n			<label for="searchsite">Site Search:</label>\r\n			<input id="searchsite" name="searchsite" type="text" />\r\n			<input type="submit" value="Go" class="f-submit" />\r\n			</form>\r\n		</div>\r\n[!MollioMainMenu!]\r\n	</div>\r\n	\r\n	<div id="content-wrap">\r\n	\r\n		<div id="utility">\r\n\r\n[!MollioSecondaryMenu!]\r\n		</div>\r\n		\r\n		<div id="content">\r\n		\r\n			<div id="breadcrumb">\r\n			[[MollioCrumbs]]\r\n			</div>\r\n			\r\n[*content*]\r\n			\r\n			<div id="footer">\r\n			<p><a href="#">Contact Us</a> | <a href="#">Privacy</a> | <a href="#">Links</a></p>\r\n			<p>[[Copyright]] | [[PoweredBy]]</p>\r\n			</div>\r\n			\r\n		</div>\r\n		\r\n		<div id="poweredby"><a href="http://www.etomite.com/"><img \r\n			src="templates/mollio/wsimages/mollio.gif" \r\n			alt="Etomite CMS - Mollio Templates" /></a>\r\n		</div>\r\n		\r\n	</div>\r\n	\r\n</div>\r\n</body>\r\n</html>', 0);

INSERT INTO `{PREFIX}site_templates` VALUES (24, 'Mollio_typeD', '2 columns - Main + Right Sidebar', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\r\n<html xmlns="http://www.w3.org/1999/xhtml">\r\n<!--\r\nCopyright: Daemon Pty Limited 2006, http://www.daemon.com.au\r\nCommunity: Mollio http://www.mollio.org $\r\nLicense: Released Under the "Common Public License 1.0", \r\nhttp://www.opensource.org/licenses/cpl.php\r\nLicense: Released Under the "Creative Commons License", \r\nhttp://creativecommons.org/licenses/by/2.5/\r\nLicense: Released Under the "GNU Creative Commons License", \r\nhttp://creativecommons.org/licenses/GPL/2.0/\r\n-->\r\n<head>\r\n<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />\r\n[[MetaTagsExtra]]\r\n<link rel="stylesheet" type="text/css" href="templates/mollio/css/main.css" media="screen" />\r\n<link rel="stylesheet" type="text/css" href="templates/mollio/css/print.css" media="print" />\r\n<!--[if lte IE 6]>\r\n<link rel="stylesheet" type="text/css" href="templates/mollio/css/ie6_or_less.css" />\r\n<![endif]-->\r\n<script type="text/javascript" src="templates/mollio/js/common.js"></script>\r\n</head>\r\n<body id="type-d">\r\n<div id="wrap">\r\n\r\n	<div id="header">\r\n		<div id="site-name">[(site_name)]</div>\r\n		<div id="search">\r\n			<form action="">\r\n			<label for="searchsite">Site Search:</label>\r\n			<input id="searchsite" name="searchsite" type="text" />\r\n			<input type="submit" value="Go" class="f-submit" />\r\n			</form>\r\n		</div>\r\n[!MollioMainMenu!]\r\n	</div>\r\n	\r\n	<div id="content-wrap">\r\n		\r\n		<div id="content">\r\n		\r\n			<div id="breadcrumb">\r\n			[[MollioCrumbs]]\r\n			</div>\r\n			\r\n[*content*]\r\n			\r\n			<div id="footer">\r\n			<p><a href="#">Contact Us</a> | <a href="#">Privacy</a> | <a href="#">Links</a></p>\r\n			<p>[[Copyright]] | [[PoweredBy]]</p>\r\n			</div>\r\n			\r\n		</div>\r\n		\r\n		<div id="sidebar">\r\n[[RelatedInfo?prefix=RelatedInfoMollio]]\r\n		</div>\r\n		\r\n		<div id="poweredby"><a href="http://www.etomite.com/"><img \r\n			src="templates/mollio/wsimages/mollio.gif" \r\n			alt="Etomite CMS - Mollio Templates" /></a>\r\n		</div>\r\n		\r\n	</div>\r\n	\r\n</div>\r\n</body>\r\n</html>', 0);

INSERT INTO `{PREFIX}site_templates` VALUES (25, 'Mollio_typeE', '2 columns - Main + Right hand nav', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\r\n<html xmlns="http://www.w3.org/1999/xhtml">\r\n<!--\r\nCopyright: Daemon Pty Limited 2006, http://www.daemon.com.au\r\nCommunity: Mollio http://www.mollio.org $\r\nLicense: Released Under the "Common Public License 1.0", \r\nhttp://www.opensource.org/licenses/cpl.php\r\nLicense: Released Under the "Creative Commons License", \r\nhttp://creativecommons.org/licenses/by/2.5/\r\nLicense: Released Under the "GNU Creative Commons License", \r\nhttp://creativecommons.org/licenses/GPL/2.0/\r\n-->\r\n<head>\r\n<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />\r\n[[MetaTagsExtra]]\r\n<link rel="stylesheet" type="text/css" href="templates/mollio/css/main.css" media="screen" />\r\n<link rel="stylesheet" type="text/css" href="templates/mollio/css/print.css" media="print" />\r\n<!--[if lte IE 6]>\r\n<link rel="stylesheet" type="text/css" href="templates/mollio/css/ie6_or_less.css" />\r\n<![endif]-->\r\n<script type="text/javascript" src="templates/mollio/js/common.js"></script>\r\n</head>\r\n<body id="type-e">\r\n<div id="wrap">\r\n\r\n	<div id="header">\r\n		<div id="site-name">[(site_name)]</div>\r\n		<div id="search">\r\n			<form action="">\r\n			<label for="searchsite">Site Search:</label>\r\n			<input id="searchsite" name="searchsite" type="text" />\r\n			<input type="submit" value="Go" class="f-submit" />\r\n			</form>\r\n		</div>\r\n[!MollioMainMenu!]\r\n	</div>\r\n	\r\n	<div id="content-wrap">\r\n	\r\n		<div id="utility">\r\n[!MollioSecondaryMenu!]\r\n		</div>\r\n		\r\n		<div id="content">\r\n		\r\n			<div id="breadcrumb">\r\n			[[MollioCrumbs]]\r\n			</div>\r\n			\r\n[*content*]\r\n			\r\n			<div id="footer">\r\n			<p><a href="#">Contact Us</a> | <a href="#">Privacy</a> | <a href="#">Links</a></p>\r\n			<p>[[Copyright]] | [[PoweredBy]]</p>\r\n			</div>\r\n			\r\n		</div>\r\n		\r\n		<div id="poweredby"><a href="http://www.etomite.com/"><img \r\n			src="templates/mollio/wsimages/mollio.gif" \r\n			alt="Etomite CMS - Mollio Templates" /></a>\r\n		</div>\r\n		\r\n	</div>\r\n	\r\n</div>\r\n</body>\r\n</html>', 0);

INSERT INTO `{PREFIX}site_templates` VALUES (26, 'Mollio_typeF', '3 columns - Main + Right hand nav + Left Sidebar', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\r\n<html xmlns="http://www.w3.org/1999/xhtml">\r\n<!--\r\nCopyright: Daemon Pty Limited 2006, http://www.daemon.com.au\r\nCommunity: Mollio http://www.mollio.org $\r\nLicense: Released Under the "Common Public License 1.0", \r\nhttp://www.opensource.org/licenses/cpl.php\r\nLicense: Released Under the "Creative Commons License", \r\nhttp://creativecommons.org/licenses/by/2.5/\r\nLicense: Released Under the "GNU Creative Commons License", \r\nhttp://creativecommons.org/licenses/GPL/2.0/\r\n-->\r\n<head>\r\n<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />\r\n[[MetaTagsExtra]]\r\n<link rel="stylesheet" type="text/css" href="templates/mollio/css/main.css" media="screen" />\r\n<link rel="stylesheet" type="text/css" href="templates/mollio/css/print.css" media="print" />\r\n<!--[if lte IE 6]>\r\n<link rel="stylesheet" type="text/css" href="templates/mollio/css/ie6_or_less.css" />\r\n<![endif]-->\r\n<script type="text/javascript" src="templates/mollio/js/common.js"></script>\r\n</head>\r\n<body id="type-f">\r\n<div id="wrap">\r\n\r\n	<div id="header">\r\n		<div id="site-name">[(site_name)]</div>\r\n		<div id="search">\r\n			<form action="">\r\n			<label for="searchsite">Site Search:</label>\r\n			<input id="searchsite" name="searchsite" type="text" />\r\n			<input type="submit" value="Go" class="f-submit" />\r\n			</form>\r\n		</div>\r\n[!MollioMainMenu!]\r\n	</div>\r\n	\r\n	<div id="content-wrap">\r\n	\r\n		<div id="utility">\r\n[!MollioSecondaryMenu!]\r\n		</div>\r\n		\r\n		<div id="content">\r\n		\r\n			<div id="breadcrumb">\r\n			[[MollioCrumbs]]\r\n			</div>\r\n			\r\n[*content*]\r\n			\r\n			<div id="footer">\r\n			<p><a href="#">Contact Us</a> | <a href="#">Privacy</a> | <a href="#">Links</a></p>\r\n			<p>[[Copyright]] | [[PoweredBy]]</p>\r\n			</div>\r\n			\r\n		</div>\r\n		\r\n		<div id="sidebar">\r\n[[RelatedInfo?prefix=RelatedInfoMollio]]\r\n		</div>\r\n		\r\n		<div id="poweredby"><a href="http://www.etomite.com/"><img \r\n			src="templates/mollio/wsimages/mollio.gif" \r\n			alt="Etomite CMS - Mollio Templates" /></a>\r\n		</div>\r\n		\r\n	</div>\r\n	\r\n</div>\r\n</body>\r\n</html>', 0);

INSERT INTO `{PREFIX}user_roles` VALUES (1, 'Administrator', 'Site administrators have full access to all functions', 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1);
